*****************************************************************************
* Modulname:	<-LIBz->
* Modultype:	Library
* Dest.Comp.:	HP48
* Language:	System RPL/Saturn assembler
* Author: Yann Collet, Paris, France (compression part)	
*   Detlef Mueller, Bellerbek 33, 22559 Hamburg, +49 40 8119280
*		Raymond Hellstern,Liebigstr. 8, 30163 Hannover, +49 511 661011
*		Parts from Rick Grevelle & Mika Heiskanen
* Interface:	Stack or current directory
* Description:	Tools for creating libraries
* To do:	$ALG list ?
*		add correct arry dc in LIBp
*
* $Id: libz.s 0.4c 2008/06/14 Yann Collet$
*
* Revision history:
*
* $Log: lib.s $
* Revision 2.4.1.1  1998/11/11 23:25:17  Detlef
* Public release
*
* Edition History:
*     0.000 1991/11/21	DM	alpha version
*	...
*     1.200 1992/02/09	DM	strip L->D, add sort in LIB?, release
*	...
*     2.000 1993/08/02	DM	finish GX port
*	...
*****************************************************************************


    TITLE	Library builder & Programming Tools


*****************************************************************************
*		ROM ID DEFINITIONS --> 1221
*****************************************************************************


xROMID		4C5

ASSEMBLE
RomID		EQU	#4C5
RPL


*****************************************************************************
*		EXTERNAL DEFINITIONS, LAYOUT
*****************************************************************************


EXTERNAL	Error
EXTERNAL	EvalSG:

EXTERNAL	xDLIB		( *1	Page 1* )
EXTERNAL	DoD->Lib
EXTERNAL	GetRID
EXTERNAL	#>hxs3
EXTERNAL	Convert
EXTERNAL	MkHashTab
EXTERNAL	{}-
EXTERNAL	xLDIR		( *2* )
EXTERNAL	ChkLid
EXTERNAL	EnshureSX
EXTERNAL	L->D
EXTERNAL	RompConv
EXTERNAL	xMCFG		( *3* )
EXTERNAL	xMLD		( *4* )
EXTERNAL	{}->LD
EXTERNAL	GenLDComp
EXTERNAL	xMDL		( *5* )
EXTERNAL	xOB		( *6* )
EXTERNAL	A->

EXTERNAL	PosHxs
EXTERNAL	ob>hxs

* 1st Assembler Jumptable

EXTERNAL	xDIR		( *7	Page 2* )
EXTERNAL	xPRG		( *8* )
EXTERNAL	xXLIB		( *9* )
EXTERNAL	xARR		( *10* )
EXTERNAL	xALG		( *11* )
EXTERNAL	xLD		( *12* )

EXTERNAL	xBAK		( *13	Page 3* )
EXTERNAL	xID		( *14* )
EXTERNAL	xADRp		( *15* )
EXTERNAL	x$romid 	( *16* )
EXTERNAL	x$title 	( *17* )
EXTERNAL	x$visible	( *18* )
EXTERNAL  x$nocompress   ( *Ca sera 19* )

EXTERNAL	x$config	( *19	Page 4* )
EXTERNAL	x$vars		( *20* )
EXTERNAL	x$hidden	( *21* )
EXTERNAL	x$message	( *22* )
EXTERNAL	xLBCRC		( *23* )
EXTERNAL	xRNLIB		( *24* )

EXTERNAL	xCHLID		( *25	Page 5* )

EXTERNAL	xRHASH		( *26* )
EXTERNAL	RCtrl:
EXTERNAL	GetHash
EXTERNAL	xRLINK		( *27* )
EXTERNAL	GetLink
EXTERNAL	xRCFG		( *28* )
EXTERNAL	GetConfig
EXTERNAL	xRMSG		( *29* )
EXTERNAL	GetMesg
EXTERNAL	xRTITLE 	( *30* )
EXTERNAL	GetTitle

EXTERNAL	xRPORT		( *31	Page 6* )

* 2nd Assembler Jumptable

EXTERNAL	x@
EXTERNAL	xRLIB		( *32* )
EXTERNAL	Tag>LidP

EXTERNAL	xPGLIB		( *33* )
EXTERNAL	PgLidP
EXTERNAL	xSTLIB		( *34* )
EXTERNAL	InstLib

EXTERNAL	xACLIB		( *35* )
EXTERNAL	xLIBp		( *36* )
EXTERNAL	?AccPtr>

EXTERNAL	xINSTp		( *37	Page 7* )
EXTERNAL	{#}>{%}

EXTERNAL	xLIBSp		( *38* )
EXTERNAL	xfEVAL		( *39* )
EXTERNAL	DoffEval

EXTERNAL	xsto		( *40* )
EXTERNAL	STOLB
EXTERNAL	xpinit		( *41* )
EXTERNAL	xBZ
EXTERNAL	ubz

*****************************************************************************
*		USEFULL ENTRIES
*****************************************************************************


ASSEMBLE
	INCLUDE ENTRIES.H
	INCLUDE SUPROM48.H
RPL


*****************************************************************************
*		GLOBAL DEFINES
*****************************************************************************


DEFINE	NULLHXS?	NULL$?		( *is legal* )

DEFINE	ROMID		  ID $ROMID
DEFINE	TITLE		  ID $TITLE
DEFINE	MESSAGE 	ID $MESSAGE
DEFINE	VARS		  ID $VARS
DEFINE	VISIBLE 	ID $VISIBLE
DEFINE NOCOMPRESS ID $NOCOMPRESS
DEFINE	HIDDEN		ID $HIDDEN
DEFINE	CONFIG		ID $CONFIG

DEFINE	fQuiet		THIRTEEN
DEFINE	fRunCfg 	FIVE

DEFINE	VER$		"\8ELIBz\8D Version 0.4"


*****************************************************************************
*		OBJECTS
*****************************************************************************


*** cfg *********************************************************************
* Interface :	( --> )
* Description : Attach this library
* Uses :	RomID -13
*****************************************************************************

ASSEMBLE
=cfg
RPL
::
    [#] RomID TOSRRP			( *Autoattach* )

    fRunCfg TestUserFlag NOT?SEMI

    '                                   ( --> $ y )
    ::	#8* SWAPTRUE SWAP $>GROB	( --> y T g )
	DUPONE ZERO GROB+#		( --> y g )
	BINT_131d OVER GROBDIMw #- #2/	( --> y g x )
	ROT HARDBUFF UNROT GROB!
    ;
    1LAMBIND

    CLEARVDISP

    ARRY
    [	VER$
	"\A9 2008 by"
	"Yann Collet"
	"Detlef M\DCller"
	"Raymond Hellstern"
	"Rick Grevelle"
	"Mika Heiskanen"
    ]

    ARRYLP_DO (DO)
	INDEX@ OVER GETATELN DROP	( --> arry $ )
	INDEX@ 1GETLAM EVAL
    LOOP

    DROP ABND

    FIFTEEN 400 TWENTYFOUR 300
    setbeep setbeep
    VERYSLOW
;

*** msg *********************************************************************
* Description : Message table
*****************************************************************************

ASSEMBLE
=msg
RPL
ARRY
[
    "$CONFIG Not a Program"
    "Missing $ROMID"
*    "Found ID Name>16 Chars"
    "$NOCOMPRESS Not a List"       ( 3 )
    "$ROMID Not Real/Binary"
    "$ROMID Out of Range"
    "$HIDDEN Not a List"
    "$VISIBLE Not a List"
    "$VARS Not a List"
    "$MESSAGE Not a List"
    "Not on a G"
    "COMPRESS not found"
*    1234567890123456789012
]

DEFINE	$CfgNotProg	:: ONE Error ;
DEFINE	Miss$ROMID	:: TWO Error ;
DEFINE	IDtoLong	:: THREE Error ;	( Not used! )
DEFINE  $NoCNotList :: THREE Error ;  ( Ah yes, used ... )
DEFINE	$RidInvT	FOUR Error		( !!! )
DEFINE	$RidOutOR	:: FIVE Error ;
DEFINE	$HidNotList	:: SIX Error ;
DEFINE	$VisNotList	:: SEVEN Error ;
DEFINE	$VarNotList	:: EIGHT Error ;
DEFINE	$MesNotList	:: NINE Error ;
DEFINE	NoG		:: TEN Error ;
DEFINE  CompNotF    :: ELEVEN Error ;

** Error ********************************************************************
* Interface :	( #[MsgNr] --> )
* Description : Error exit
* Uses :	RomID
*****************************************************************************

NULLNAME	Error
::
    [#]
    ASSEMBLE
	CON(5)	(RomID)*256
    RPL
    #+ ERROROUT
;

*** EvalSG: *****************************************************************
* Description : Quote the next two objs from the caller, on a S run the
*		1st, on a G run the 2nd
*****************************************************************************

NULLNAME	EvalSG:
::
    'R'R

    CODE
IsGX?	AD0EX
	D0=(5)	(=addrADISP)+6
	C=DAT0	B
	AD0EX
	?CBIT=1 3
	GOYES	isGX			carry set if GX
isGX	GOVLNG	=PushT/FLoop
    ENDCODE

    ?SWAP DROP COLA_EVAL
;

** DoVars *******************************************************************
* Interface :	( --> { ids } )
* Description : Replacement for slow RPL DOVARS for the SX
* Calls :	SavPtr GetPtr Mk$n MoveD
*****************************************************************************

ASSEMBLE
DoVars
* CPU			A	B	C	D	D0	D1	xx
	GOSUBL	SavPtr
	GOSUB	GoRRP			xx		->lastid	C
	GONC	FndIDs

EmpRRP	LA(5)	=NULL{} ** RRP empty, leave by pushing an empty list
Exit	GOSUBL	GetPtr
	PC=(A)

FndIDs	D=0	A	** preset needed mem with 0. DOCSTR,len -> DOLIST,SEMI

NxtIDSz C=0	A	** for each ID
	C=DAT0	B	** get char count,
	C=C+C	A	** conv. to nibbs
	C=C+CON A,7	** DOIDNT, len
	D=D+C	A				mem'

	D0=D0-	5					->RAM-WORD link field
	A=DAT0	A
	?A=0	A	** first RAM-WORD ?
	GOYES	GotMem	** yes, we got it

	CD0EX				->id
	C=C-A	A			->id'
	D0=C
	GONC	NxtIDSz ** BET

GotMem	C=D	A			mem
	GOSUBL	Mk$n	len	val	->stk	->body	->stk	->$	R0:->ob
	D0=D0-	10					->hole
	LC(5)	=DOLIST 		list
	DAT0=C	A	** we want {} !
	D0=D0+	5					->1st

	CD0EX
	D1=C							->1st

	GOSUB	GoRRP					->ID	->1st

	LC(5)	=DOIDNT
	D=C	A				->DOIDNT

NxtIDCp
*			** for each ID
	C=D	A			->DOIDNT
	DAT1=C	A	** copy DOIDNT
	D1=D1+	5

	C=0	A
	C=DAT0	B	** get char count,
	C=C+1	A	** add len byte,
	C=C+C	A	** conv. to nibbs
	B=C	A		len ID

	GOSUBL	MoveD				->pastID ->nxt

	AD0EX
	A=A-B	A
	D0=A						->ID

	D0=D0-	5					->RAM-WORD link field
	A=DAT0	A
	?A=0	A	** first RAM-WORD ?
	GOYES	AllCped ** yes, all copied

	CD0EX				->ID
	C=C-A	A			->ID'
	D0=C
	GONC	NxtIDCp ** BET

AllCped LC(5)	=SEMI
	DAT1=C	A

	A=R0		->{}
	GOTO	Exit

** GoRRP ********************************************************
* Entry:	--
* Exit:		CC: C,D0 ->lastid
*		CS: rrp is empty
* Stack Levels: 1
* Uses:		A[A], C[A], D0
*****************************************************************

GoRRP
	GOSUBL	D0=RAM
	CON(5)	=CONTEXT_G
	CON(5)	=CONTEXT				->CONTEXT

	A=DAT0	A	->rrp

	GOSUBL	D0=RAM
	CON(5)	=USEROB_G
	CON(5)	=USEROB 				->USEROB

	C=DAT0	A			->SYSRAMROMPAIR
	D0=A						->rrp
	D0=D0+	5					->ROMPART ID field
	?A#C	A	** not SYSRAMROMPAIR ?
	GOYES	NormRRP ** yes, bye
	C=DAT0	A			SYSROMPART count

NxtSRP	C=C-1	X
	GOC	NormRRP
	D0=D0+	13					->nxt
	GONC	NxtSRP	** BET

NormRRP D0=D0+	3					->last o-pair pointer
	A=DAT0	A	LASTRAM-WORD offset
	?A=0	A	** empty RAMPART ?
	RTNYES		** yes, leave with CS

	CD0EX
	C=C+A	A
	D0=C						->RAM-WORD name form
	RTNCC
RPL

** xD->LIB ******************************************************************
* Interface :	( --> lib )
* Uses :	-13, objects of current directory
* Calls :	ob>hxs {}- PosHxs ReplID
*		x$romid x$title x$message x$vars x$visible x$hidden x$config x$nocompress
*		=Loop Pop# SavPtr =PUSHhxsLoop #>hxs =DoCRC GpLp
* Defines :	GetRID #>hxs3
*		#>hxs PHxsLp LCrc LBCrc
*****************************************************************************

DEFINE	@tmpa	  	1GETLAM 	( *temp A* )
DEFINE	!tmpa	  	1PUTLAM
DEFINE	@hidden 	2GETLAM 	( *{id} - unnamed obs* )
DEFINE	!hidden 	2PUTLAM
DEFINE	@msgtab 	3GETLAM 	( *hxs[arry[$]] - message table* )
DEFINE	!msgtab 	3PUTLAM
DEFINE	@hash	  	4GETLAM 	( *hxs[hxs]] - hash table* )
DEFINE	!hash	  	4PUTLAM
DEFINE	@cfg  		5GETLAM 	( *hxs[::] - config code* )
DEFINE	!cfg  		5PUTLAM
DEFINE	@lib  		6GETLAM 	( *hxs - library and tmp* )
DEFINE	!lib	  	6PUTLAM
DEFINE	@incl	  	7GETLAM 	( *{id} - obs to add to library* )
DEFINE	!incl	  	7PUTLAM
DEFINE	@romid		8GETLAM 	( *hxs[3] - target romid* )
DEFINE	!romid		8PUTLAM
DEFINE  @nocompress 9GETLAM ( *{id} - Uncompressible data* )
DEFINE  !nocompress 9PUTLAM
DEFINE  @cancompress 10GETLAM ( *t/f - Can compress* )
DEFINE  !cancompress 10PUTLAM
DEFINE  @defaultcompress 11GETLAM ( *t/f - Using default compressor * )
DEFINE  !defaultcompress 11PUTLAM

DEFINE	D->Llams	ELEVEN		( *Need a 8-lam temp env.* )

ASSEMBLE
	CON(1)	8		* Tell parser 'Non algebraic'
RPL
xNAME	DLIB
::
    CK0
    ' DoD->Lib
    fQuiet TestSysFlag
    NOTcase EVAL
    DoffEval
;

NULLNAME	DoD->Lib
::
				( *ANALYZING PART* )

    NULLNAME	GetRID		( *Get and check $ROMID* )
    ::
	x$romid SAFE@_HERE
	?SKIP Miss$ROMID		( *unable to find RID var* )

	::  DUPTYPEREAL? case COERCE	( % --> # )
	    DUPTYPEHSTR? case HXS>#	( hxs --> # )
	    $RidInvT			( *RID have invallid type* )
	;

	# 7FF OVER#< case $RidOutOR	( *RID out of range* )
    ;

    BlankDA2

    "Analyzing\1F" DISPROW4

    NULLNAME #>hxs3			( # --> hxs[3] )
    CODE
	P=	2		want to push HXS 3
#>hxs	GOSUBL	Pop#
	GOSUBL	SavPtr
PHxsLp	GOVLNG	=PUSHhxsLoop
    ENDCODE
				( *Set up TEMP env.* )
					( *Initial: romid,* )
    
    ' ID UNCOMPRESS SAFE@_HERE
	  DUP ITE				    ( *if $UNCOMPRESS exists..* )
	    ::
        SWAPDROP
        ' ID COMPRESS SAFE@ ?SKIP CompNotF DROP
      ;                                   
      ::      
	      x$nocompress SAFE@_HERE
	      ITE				    ( *$NOCOMPRESS exists..* )
	      ::  
	        DUPNULL{}? ITE DROP
          :: DROP ubz ID UNCOMPRESS STO ;
	      ;
	      :: ubz ID UNCOMPRESS STO ;
	    ;
    NOT SWAP          ( *defaultcompress?* )

    TRUE SWAP         ( *cancompress?* )
    
    NULL{} SWAP       ( *nocompress {}* )

    CODE
	   GOTO	DoVars			( *incl,* )
    ENDCODE

    NULLHXS DUP DUPDUP			( *lib, cfg, hash, msgtab,* )
    NULL{}            ( *hidden* )
    x$romid x$title x$message x$vars
    x$visible x$hidden x$config x$nocompress
    EIGHT {}N				  ( *tmpa* )

    ' NULLLAM D->Llams NDUPN DOBIND

				( *Get and check $VARS* )
    x$vars SAFE@_HERE
    IT
    ::	DUPTYPELIST? ?SKIP $VarNotList	( *Not a list* )
	    @tmpa OVER {}- &COMP !tmpa	( $VARS + [$ctrl - $VARS] )
    ;

    @incl @tmpa {}- !incl		   ( *correct incl* )

				( *Get and check $HIDDEN & $VISIBLE* )
    ::
	    x$hidden SAFE@_HERE
	    case				( *$HIDDEN exists..* )
	    ::  DUPTYPELIST?
	      ?SKIP $HidNotList		   ( *..but not as list* )
	      DUP @incl {}- {}- !hidden	( hid - [hid - inc] )
	    ;
	
	    x$nocompress SAFE@_HERE
	    ITE				( *$NOCOMPRESS exists..* )
	    ::  DUPTYPELIST?
	      ?SKIP $NoCNotList		    ( *..but not as list* )
	      DUPNULL{}? NOT !cancompress
	    ;
	    NULL{}
	    ' ID UNCOMPRESS >TCOMP    ( * on ajoute UNCOMPRESS  la liste des fichiers  ne pas compresser * )
      !nocompress	

      @cancompress IT :: @hidden ' ID UNCOMPRESS >TCOMP !hidden ; ( * on ajoute UNCOMPRESS  la liste $hidden si compression possible * )
     
	    x$visible SAFE@_HERE NOT?SEMI	( *$VISIBLE exists..* )
	    DUPTYPELIST?
	    ?SKIP $VisNotList		( *..but not as list* )

	    @incl SWAP {}- !hidden		( inc - vis )
    ;

				( *Order visible and hidden names* )
    @incl @hidden {}- DUP
    @hidden &COMP !incl
				( *Leaves {vis} on the stack !* )

				( *Get and check $CONFIG* )
    x$config SAFE@_HERE
    IT
    ::	DUPTYPECOL? ?SKIP $CfgNotProg	( *Not a program* )
	  @incl @romid HXS># FALSE Convert ( *Convert romptrs id cfg* )
	  ob>hxs !cfg
    ;
				( *Get and check $MESSAGE* )
    x$message SAFE@_HERE
    IT
    ::	DUPTYPELIST? ?SKIP $MesNotList	( *Message table not a list* )
	  DUPNULL{}? caseDROP		( *MsgTab nulllist, ignore* )

	  INNERCOMP			( --> ..obn #n )
	  HXS A C2A2010000		( *DOCSTR, dim = 1..* )
	  OVER #>HXS &$SWAP		( *..elem. cnt. = n* )
					( --> ..obn hxs #n )
	  ZERO_DO (DO)
	    ISTOP-INDEX #1+ROLL
	    DO>STR ob>hxs
	    SIX MINUSONE SUBHXS 	( *Strip DOCSTR* )
	    !!append$
	  LOOP

	  [#] DOARRY ChgType

	  ob>hxs !msgtab
    ;

				( *HASH TABLE CREATION* )
    DUPNULL{}? ITE_DROP 		( *No visible vars* )
    ::
	  "Creating Hash Table\1F" DISPROW4
	  MkHashTab
	  ob>hxs !hash
    ;

				( *LINK TABLE CREATION AND OBJECTS ADDING* )
    ?ATTNQUIT

    @incl DUPNULL{}?
    ITE
    ::	DROP NULLHXS			( *no obs to include* )
    ;
    ::	"Creating Link Table\1F" DISPROW4

	LENCOMP !tmpa

	NULLHXS
	@tmpa #1+_ONE_DO (DO)
	    @incl INDEX@ NTHCOMPDROP

	    "Adding " OVER ID>$ &$ DISPROW5

      @nocompress OVER
    CODE
	GOLONG	EqualPosComp
    ENDCODE
      UNROT     ( --> 0-#/nc hxs[lt] id )
      
	    @hidden OVER
    CODE
	GOLONG	EqualPosComp
    ENDCODE
	    UNROT			( --> 0-#/nc t/f hxs[lt] id )
	    
	    SAFE@_HERE DROP		   ( --> 0-#/nc t/f hxs[lt] ob )
	    @incl @romid HXS># FALSE Convert	( *Convert IDs* )
	    
      4ROLL #0=	@cancompress	AND	( * Compressed * )
	    IT
*********************************************************************************	    
*     ICI ON PEUT COMPRESSER
*********************************************************************************	    
    ::  
      DUP OSIZE               ( Taille d'origine )
      OVER
      @defaultcompress ITE
        xBZ  
        ID COMPRESS           ( On compresse )
      DUP OSIZE               ( Taille compresse Pile : 1:Comp.Taill;2:Comp.Ob;3:Orig.Taill;4:Orig.Ob )
      FORTY #+                ( Gain minimum de 40 nibbles = 20 octets)
      ROTSWAP                 ( 1:Comp.Taill+40;2:Orig.Taill;3:Comp.Ob;4:Orig.Ob;5:Hxs;6:t/f; )
      #< ITE DROP             ( Si Taille d'origine infrieure alors on drop le compress)
      ::
        SWAP                  ( On Vire l'original )
        TYPECOL?              ( 1:Col?;2:Comp.Ob;3:Hxs;4:t/f; )
        SWAP                  ( 1:Comp.Ob;2:Col?;3:Hxs;4:t/f; )
        ' ID UNCOMPRESS       ( UNCOMPRESS en pile )
        ROT ITE ::
          ' xEVAL               ( Si c'est un programme )
          THREE ;
        TWO ::N             ( Programme : Chaine compresse + UNCOMPRESS + EVAL )
        @incl @romid HXS># FALSE Convert	( *Convert IDs* , Ici UNCOMPRESS )
	    ;
	  ;
*******************************************************************************	    
*     FIN BLOCK COMPRESSION
*******************************************************************************	    	    
	    
	    ob>hxs			( --> t/f hxs[lt] hxs[ob'] )
	    @lib ZERO !lib
	    SWAP !insert$		( --> t/f hxs[lt] hxs[ob+lib] )
	    OVER LENHXS #10+
	    OVER LENHXS #+		( --> t/f hxs[lt] hxs[lib] #offs )
	    ZERO SWAP#- #>HXS
	    ROTSWAP &$SWAP		( --> t/f hxs[lt] hxs[lib] )

	    ROT #0=			( *Not hidden,* )
	    OVER HXS># [#] DOCOL #= AND ( *and is program* )
	    IT
	    ::
		   ( * x<<  xALG->    x<<	DOLAM * )
		HXS 1E E1632BEF22D6E20E16321C432D6E20
		   ( *		 DOLAM	   xRPN->     * )

		OVER SIX FIFTEEN SUBHXS
		ONE PosHxs		( --> hxs[lt] hxs[lib] # )
		#0=ITE
		    HXS 1 8
		    HXS 3 0

		@romid &$ INDEX@ #1- #>hxs3 &$
		!!insert$
	    ;

	    !lib			( --> hxs[lt] )

	    ?ATTNQUIT
	LOOP

	ob>hxs
	NULL$ DISPROW5
    ;
				( *LIBRARY CREATION * )

    "Creating Library\1F" DISPROW4
    !tmpa				( *Link table to tmpa* )

    @defaultcompress IT :: ' ID UNCOMPRESS ?PURGE_HERE ;  ( * on supprime dcompresseur par dfaut * )
    @lib ZERO !lib			( --> hxs[obs] )
    @cfg !insert$			( --> hxs[cfg_obs] )
    @msgtab !!insert$			( --> hxs[msg_cfg_obs] )
    !lib				( *Library object part to lib* )

				( *Create library header* )
    x$title SAFE@_HERE
    ITE 				( *Title exists* )
    ::	DO>STR DUPLEN$			( *enshure string* )

    CODE
	P=	1
	GOLONG	#>hxs
    ENDCODE
					( --> $ hxs[len$] )
	SWAPOVER HXS 2 0 EQUALcase DROP ( *$ out of range -> no title* )
	ob>hxs				( --> hxs[len] hxs[$] )
	ELEVEN MINUSONE SUBHXS		( *strip DOCSTR, len* )
	OVER &$ &$			( --> hxs[len $ len] )
    ;
	HXS 2 0 			( *No title* )

    @romid &$				( --> hxs[tit_rid] )

    @hash NULLHXS?
    ITE
	ZERO				( *No hash table* )
    ::	@lib LENHXS @tmpa LENHXS #+ TWENTY #+
    ;
    #>HXS				( *Ptr to hash table* )
    &$					( --> hxs[tit_rid_hash] )

    @msgtab NULLHXS?
    ITE
	ZERO
	FIFTEEN
    #>HXS				( *Ptr to message table* )
    &$					( --> hxs[tit_rid_hash_msg] )

    @tmpa NULLHXS?
    ITE
	ZERO
    ::	@lib LENHXS #10+
    ;
    #>HXS				( *Ptr to link table* )
    &$					( --> hxs[tit_rid_hash_msg_link] )

    @cfg NULLHXS?
    ITE
	ZERO
    ::	@msgtab LENHXS #5+
    ;
    #>HXS				( *Ptr to configuration code* )
    &$					( --> hxs[tit_rid_hash_msg_link_cfg] )

    @lib @tmpa @hash			( --> header obs link hash )

    ABND

    HXS 4 0 !append$ !append$ !append$
    SWAP !insert$			( --> hxs-lib )

    CODE			( *hxs becomes lib, calc and patch CRC* )
* CPU			A	C	D0	D1
LCrc	GOSUBL	SavPtr

	C=DAT1	A		->hxs
	D0=C				->hxs
	LA(5)	=DOLIB	lib_prol
	DAT0=A	A	    *** Change prologue

LBCrc	D0=D0+	5			->len

	A=DAT0	A	len
	A=A-CON A,4	len - CRClen

	GOSBVL	=DoCRC	CRC	xx	->CRC	xx

	DAT0=A	4	    *** Patch CRC

	GOLONG	GpLp
    ENDCODE
;

** Convert ******************************************************************
* Interface:	( ob {ids} #romid flag --> ob' )
* Description:	Does id<-->romptr conversion in ob for DIR->L and L->DIR
* Calls:	=popflag, =DropLoop, =OverWrALoop, =GETTEMP, =D0=DSKTOP
*		SavPtr, GetPtr, Pop#, SkipOb, MoveD
* Ed. Hist. :
*     1.000 30.06.1993 MH	alpha
*****************************************************************************

ASSEMBLE
FromRomp?	EQU	5	* ST flag to indicate conversion direction
Found?		EQU	4	* ST flag to indicate a match in pass 1
RPL

* R0 = ob' address
* R1 = save for ~ob
* R2 = save for ~dest
* R3 = names list address ( DOLIST skipped )
* R4 = romid
* D0 = ~ob (running pointer inside ob)
* D1 = ~dest (running pointer inside ob')

* CPU				A	B	C	D	D0	D1

NULLNAME Convert
CODE
	ST=1	FromRomp?	** Set default is romptr->id
	GOSBVL	=popflag	flag					#romid
	GOC	GotFlag 	** Flag was TRUE?
	ST=0	FromRomp?	** Set id->romptr conversion
GotFlag ST=0	Found?		** Set nothing to convert has been found

	GOSUBL	Pop#		romid					{names}
	R4=A			** Save romid
	GOSUBL	SavPtr
	A=DAT1	A		->{names}
	D0=A							->{names}
	D0=D0+	5						->names
	LC(5)	=SEMI		** Is {names} empty?
	A=DAT0	A
	?A#C	A
	GOYES	ConvOk

ExitDrp GOSUBL	GetPtr		** Exit by dropping stk1
	GOVLNG	=DropLoop

ConvOk	AD0EX			->names
	R3=A			** save ->names
	D1=D1+	5							ob
	A=DAT1	A		->ob
	D0=A							ob
	GOSUB	ObLen				oblen
	B=C	A			oblen
	B=B-1	A		** decreased to get a carry test
	D=0	A		** Init needlen counter
* CPU				A	B	C	D	D0	D1
Pass1Lp GOSUB	Comp?		** Composite?			~ob
	GONC	NotCmp1
	D0=D0+	5		** Skip prolog/semi		~ob+5
	LC(5)	5				passlen
	GOTO	PassLen1
NotCmp1 ?ST=1	FromRomp?	** Choose test
	GOYES	TstRomp1
	GOSUB	Idnt?		** ~ob is idnt from {names} ?
	GOC	IsIdnt1

PassOb1  GOSUB	ObLen		~obend		~oblen		~ob
	 D0=A							~obend
PassLen1 A=C	A		oblen
PassMix1 D=D+C	A		** Fix needed len
	 B=B-A	A		** Fix done len
	 GONC	Pass1Lp ** Cont pass 1?
	 GOC	DoPass2
TstRomp1
	GOSUB	Romp?		** ~ob is romptr with libnum=romid?
	GONC	PassOb1
	ST=1	Found?		** Set match was found
	GOSUB	GetRompName	** Find name of romptr		->id
	GOSUB	ObLen				idlen
	A=R2			~ob
	D0=A							~ob
	LA(5)	11		** romptr size
	GOTO	PassMix1
IsIdnt1
	ST=1	Found?		** Set match was found
	GOSUB	ObLen		~obend		~oblen		~ob
	D0=A							~obend
	A=C	A		~oblen
	LC(5)	11		** romptr size
	GOTO	PassMix1


DoPass2 ?ST=1	Found?		** Anything to convert?
	GOYES	Pass2Ok
	GOTO	ExitDrp 	** No, drop {names} and leave ob

* CPU				A	B	C	D	D0	D1
Pass2Ok C=D	A				len
	GOSBVL	=GETTEMP					dest
	B=C	A			len
	B=B-1	A		** To get carry test
	AD0EX			dest
	R0=A			** Save start of dest
	D1=A								~dest
	GOSBVL	=D0=DSKTOP	** Get stack to D0		{names}
	A=DAT0	A		->{names}
	A=A+CON A,5		->names
	R3=A			** Save names again (GC during GETTEMP?)
	D0=D0+	5						ob
	A=DAT0	A		->ob
	D0=A							->ob

Pass2Lp GOSUB	Comp?		** ~ob is composite/semi?
	GONC	NotCmp2
	A=DAT0	A		** Copy comp_prol
	DAT1=A	A
	D0=D0+	5		** Skip to next 	~ob+5
	D1=D1+	5						~dest+5
	LC(5)	5		** Passed lenght
	GOTO	PassLen2
NotCmp2 ?ST=1	FromRomp?	** Choose test
	GOYES	TstRomp2
	GOSUB	Idnt?		** idnt from {names} ?
	GOC	IsIdnt2
PassOb2 GOSUB	CpyOb					~obnxt	~destnxt
PassLen2 B=B-C	A		** Fix done lenght
	GONC	Pass2Lp 	** More to do?

	GOSUBL	GetPtr		** Exit by
	D1=D1+	5		** dropping {names}
	D=D+1	A		** and
	A=R0			** replacing ob with ob'
	GOVLNG	=OverWrALoop

TstRomp2 GOSUB	Romp?		** ~ob is romptr with libnum=romid?
	GONC	PassOb2
	GOSUB	GetRompName				->id
	GOSUB	CpyOb				~idlen		~destnxt
	A=R2			~obnxt
	D0=A						~obnxt
	GOTO	PassLen2

IsIdnt2 A=C	A		cmdnum
	LC(5)	=DOROMP 	romp_prol
	DAT1=C	A		** Set romp_prol to dest
	D1=D1+	5						~dest+5
	C=R4					romid
	DAT1=C	3		** Set libnum to dest
	D1=D1+	3						~dest+8
	DAT1=A	3		** Set cmdnum to dest
	D1=D1+	3						~dest+11
	GOSUBL	SkipOb					~obnxt
	LC(5)	11		** Lenght of romptr
	GOTO	PassLen2

** Comp? *****************************************************************
* Entry:
*	D0: ob
* Exit:
*	CS: ob composite or SEMI
*	CC: ob not composite nor SEMI
* Stack Levels:
*	0
* Uses:
*	A[A], C[A]
**************************************************************************

Comp?	A=DAT0	A
	LC(5)	=DOCOL	** Program?
	?A=C	A
	RTNYES
	LC(5)	=DOSYMB ** Symbolic?
	?A=C	A
	RTNYES
	LC(5)	=DOLIST ** List?
	?A=C	A
	RTNYES
	LC(5)	=DOEXT	** Unit?
	?A=C	A
	RTNYES
	LC(5)	=SEMI	** SEMI?
	?A=C	A
	RTNYES
	RTNCC		** None of above

** GetRompName ***********************************************************
* Entry:
*	D0: romptr
*	R3[A]: ->names
* Exit:
*	D0: id from {names}
*	R2[A]: obnxt (skipped romptr)
*	SC
* Stack Levels:
*	4
* Uses:
*	A[A], C[A], D0, R2
**************************************************************************

* CPU			A	C	D0	D1
GetRompName
	D0=D0+	8			->cmdnum
	C=0	A
	C=DAT0	X		cmdnum
	D0=D0+	3			obnxt
	AD0EX		obnxt
	R2=A		** Save obnxt
	A=R3		->names
	D0=A				->names
SkipLp	C=C-1	A	** Decrement counter (index to {names})
	RTNC		** No more skipping, exit
	RSTK=C		** Save index
	GOSUBL	SkipOb			~namesnxt
	C=RSTK		** Restore index
	GOTO	SkipLp

** Romp? *****************************************************************
* Entry:
*	D0: ob
*	R4[A]: romid
* Exit:
*	CS: ob is ROMPTR with libnum = romid
*	CC: not above
* Stack Levels:
*	0
* Uses:
*	A[A], C[A]
**************************************************************************

* CPU			A	C	D0
*					ob
Romp?	A=DAT0	A	ob_prol
	LC(5)	=DOROMP 	romp_prol
	?A#C	A	** ob not romptr?
	GOYES	NotRomp
	D0=D0+	5			->libnum
	A=0	A
	A=DAT0	X	libnum
	D0=D0-	5			->romptr
	C=R4			romid
	?A=C	A	** libnum = romid?
	RTNYES
NotRomp RTNCC		** not matching romptr, clear carry

** Idnt? *****************************************************************
* Entry:
*	D0: ob
*	R3[A]: ->names
* Exit:
*	CS: ob is idnt from {names}, C[A]=cmdnum
*	CC: not above
* Stack Levels:
*	1
* Uses:
*	A[A], C[A], R2
**************************************************************************

* CPU				A	C	D0	D1	RSTK
*						ob
Idnt?	A=DAT0	A		ob_prol
	LC(5)	=DOIDNT 	idnt_prol
	?A=C	A		** ob is idnt?
	GOYES	IdLen?
	RTNCC			** ob not idnt, exit with cc
IdLen?	AD0EX			ob
	R2=A			** Save ob
	D0=A					ob
	AD1EX			** Save possible dest in D1
	R1=A
	A=R3			->names
	D1=A						~names
	C=0	A		** Init cmdnum counter
	RSTK=C							cmdnum
	D0=D0+	5				->idlen
NxtIdLp D1=D1+	5					->namelen
	A=DAT0	B		idlen
	C=DAT1	B			namelen
	?A=C	B		** Same lenght?
	GOYES	IdBody?
NtIdLen A=0	A		** Init skip counter
	A=C	B		idlen
	A=A+1	A		idlen+1
	A=A+A	A		size(id)-5
	CD1EX			** Skip to next name
	C=C+A	A
	CD1EX						->namenxt
	C=RSTK				cmdnum
	C=C+1	A			cmdnum+1
	RSTK=C							cmdnum+1
	A=DAT1	A		** Test if end of {names}
	LC(5)	=DOIDNT
	?A=C	A
	GOYES	NxtIdLp
	C=RSTK			** No match, ignore cmdnum
	D0=D0-	5				ob
	A=R1			** Restore possible dest
	D1=A
	RTNCC			** Exit with no match
IdBody? C=0	W		** C.M is charcounter in body comparison
	C=A	B			idlen
	CSL	A
	CSL	A
	CSL	A		** C.N is now idlen
	C=C-1	M		** To get carry test
CmpChrLp
	D0=D0+	2				->idchr
	D1=D1+	2					->namechr
	A=DAT0	B		idchr
	C=DAT1	B			namechr
	?A#C	B		** Not same chars?
	GOYES	NotIdBody
	C=C-1	M		** More to test?
	GONC	CmpChrLp
	A=R2			ob (match found)
	D0=A					ob
	C=R1			** Restore possible dest
	D1=C
	C=RSTK				cmdnum
	RTNSC			** Exit with match
NotIdBody
	A=R2			ob
	D0=A					ob
	D0=D0+	5		** Skip id prolog
	CSR	A		** Resume remaining id lenght from C.M
	CSR	A
	CSR	A
	GOTO	NtIdLen 	** Skip remainder & test next

** ObLen *****************************************************************
* Entry:
*	D0: ob
* Exit:
*	D0: ob
*	A[A]: obend
*	C[A]: oblen
*	P=0, ST1=0, CC
* Stack Levels:
*	4
* Uses:
*	A[A], C[A], ST1, P
**************************************************************************

* CPU			A	B	C	D	D0	D1	RSTK
*							ob
ObLen	AD0EX		ob
	D0=A						ob
	C=A	A			ob
	RSTK=C								ob
	GOSUBL	SkipOb					obend
	C=RSTK				ob
	A=C	A	ob
	AD0EX		obend				ob
	C=A-C	A			oblen
	RTNCC

** CpyOb *****************************************************************
* Entry:
*	D0: ob
*	D1: destination
* Exit:
*	D0: obend
*	D1: destend
*	C[A]: oblen
*	P=0, ST1=0, CC
* Stack Levels:
*	4
* Uses:
*	A[W], C[A], D0, D1, ST1, P
**************************************************************************

* CPU			A	B	C	D	D0	D1	RSTK
*							ob	dest
CpyOb	GOSUB	ObLen			oblen
	RSTK=C								oblen
	GOSUBL	MoveD					obend	destend
	C=RSTK				oblen
	RTNCC

ENDCODE

** MkHashTab ****************************************************************
* Interface:	( {ids} --> hxs )
* Description:	Creates hash table from list of ids
* Uses: 	=GpOverWrR0Lp, =OverWrALoop, =D0=DSKTOP, =ErrJmpC
*		SavPtr, GetPtr, Pop#, SkipOb, Mk$n, MoveD
* Algorithm:
*	Calculate hash table size from #len and size({ids})
*	Add names from {ids} one size at a time
* Ed. Hist:
*     1.000 30.06.1993 MH	alpha
*****************************************************************************

NULLNAME MkHashTab
::
    DUPLENCOMP			( {ids} --> {ids} #N )
    CODE

* R0 = hsh	(address of hash table)
* R1 = hshtab	(start of names in hash table, running pointer)
* R2 = hshend	(start of backward offsets)
* R3 = hashlen	(lenght of hashtab - lenght of fwd and bck references)
* R4 = N

* CPU				A	C	D0	D1
	GOSUBL	Pop#		N			{ids}
	?A#0	A		** Something to build?
	GOYES	HashTabOk
	LA(5)	=NULLHXS	** Exit with empty hash table
	GOVLNG	=OverWrALoop
HashTabOk
	R4=A			** Save N
	GOSUBL	SavPtr
	A=DAT1	A		->{ids}
	D0=A					->{ids}
	GOSUBL	SkipOb				->idsend
	D0=D0-	10		** Minus 5+5 for {}
	AD0EX			->idsend-10
	C=DAT1	A			->{ids}
	A=A-C	A		idslen
	C=R4				N
	A=A-C	A
	A=A-C	A		idslen-2N
	R3=A			** Save hashlen
	A=A+C	A		idslen-N
	C=C+C	A			2N
	C=C+C	A			4N
	A=A+C	A		idslen+3N
	LC(5)	5+16*5		** Lenght of fwd offsets + 5 for hashlen
	C=C+A	A			len
	GOSUBL	Mk$n				hsh	hshend
	D0=D0-	10		** Set hxs instead of $
	LC(5)	=DOHXS
	DAT0=C	A
	LC(5)	5+16*5+5	** Offset to hshoff (lenght of hshtab)
	AD0EX			hsh
	A=A+C	A		hshoff
	D0=A					hshoff
	A=A+CON A,5		hshtab
	R1=A			** Save start of hshtab
	C=R3				hshlen
	A=A+C	A		hshend
	R2=A			** Save start of backward offsets
	C=C+CON A,5		** Set hshtab len to dest
	DAT0=C	A

	B=0	S		** Init idlen counter
NxtHashLen
	GOSUB	AddHashLen	** Add ids of size to table
	B=B+1	S		** Next size
	GONC	NxtHashLen
	GOVLNG	=GPOverWrR0Lp	** Exit by leaving the hxs

** AddHashLen ************************************************************
* Entry:
*	B[S]	idlen-1
*	R0[A]	hsh
*	R1[A]	hshtab
*	R2[A]	hshend
*	@DSKTOP {ids}
* Exit:
*	Modified hsh
* Stack Levels:
* Uses: A[W], C[A], D[A], D0, D1, R1
**************************************************************************

* CPU				A	C	D0	D1

AddHashLen
	GOSBVL	=D0=DSKTOP			{ids}
	A=DAT0	A		->{ids}
	D0=A					->{ids}
	D0=D0+	5				->ids
	D=0	A		** Init cmdnum counter
	GOSUB	NxtHash?	** Fetch first id of current size
	GOC	HshLenIs	** Atleast one hash of current size exists?
	GOSUB	FwdHshLoc	** Fetch loc of fwd offset
	D0=A					fwdloc
	C=0	A		** Set no hashes of size exist
	DAT0=C	A
	RTN
HshLenIs
	GOSUB	FwdHshLoc	** Fetch loc of fwd offset
	D1=A						fwdloc
	C=R1				hshtab
	C=C-A	A			fwdoff
	DAT1=C	A		** Set offset to hash size
HshLenLp
	C=R1				hshtab
	D1=C						hshtab
	C=0	A
	C=DAT0	B			idlen
	C=C+1	A
	C=C+C	A			idbodylen
	GOSUBL	MoveD		** Copy ID body to hshtab
	C=D	A			cmdnum
	DAT1=C	3		** Copy cmdnum to hshtab
	D1=D1+	3
	GOSUB	BckHshLoc	** Get loc of bck offset to A
	CD1EX				hshtabnxt
	CR1EX			** Exchange new and old hshtabs
	D1=A					bcklock
	A=A-C	A		bckoff
	DAT1=A	A		** Set backward offset
	D=D+1	A		** Increase cmdnum
	GOSUB	NxtHash?	** More ids of current size?
	GOC	HshLenLp
	RTN

** BckHshLoc ************************************************************
* Entry:
*	D[A] = cmdnum
*	R2[A] = hshend (start of bckoffsets)
* Exit:
*	A[A] = bckloc (location of backward offset for cmdnum)
* Uses:
*	A[W], C[A]
*************************************************************************

* CPU			A	C

BckHshLoc
	C=D	A		cmdnum
	C=C+C	A
	C=C+C	A		4*cmdnum
	C=C+D	A		5*cmdnum
	A=R2		hshend
	A=A+C	A	hshend+5*cmdnum
	RTN

** FwdHshLoc ************************************************************
* Entry:
*	B[S] = idlen-1
*	R0[A] = hash table
* Exit:
*	A[A] = fwdloc (location of fwd offset for size idlen)
*	P=0
* Uses:
*	A[A], C[W], P
*************************************************************************

* CPU			A	C

FwdHshLoc
	C=0	A	** Init idsize
	C=B	S	** Copy B.S to C.0 through P
	P=C	15
	C=P	0		idlen-1
	P=	0
	C=C+1	A		idlen
	C=C+1	A		idlen+1
	A=C	A	idlen+1
	C=C+C	A
	C=C+C	A		4*idlen+4
	A=A+C	A	5*idlen+5
	C=R0			hash table
	A=A+C	A	hashtable + 5*idlen+5
	RTN

** NxtHash? *****************************************************************
* Entry:
*	D0: ->ids
*	B[S]: idlen-1
* Exit:
*	CC: No ids of idlen until semi
*	CS: Found match,
* Uses:
****************************************************************************

* CPU				A	C	D0
NxtHash?
	A=DAT0	A	** Is idnt?
	LC(5)	=DOIDNT
	?A=C	A
	GOYES	MaybeHash
	RTNCC		** End of ids, no match found
MaybeHash
	D0=D0+	5				->idlen
	A=DAT0	B		idlen
	?A#0	B		** NULLID causes error
	GOYES	Non0Hash
	LC(5)	(RomID)*256+10	** Found 0-id (should never happen?)
	GONC	HashErr
HashBigErr
	LC(5)	(RomID)*256+3	** Hashname too long
HashErr
	A=C	A
	GOSUBL	GetPtr
	C=A	A
	GOVLNG	=ErrjmpC
Non0Hash
	LC(2)  16		** Longest allowed hashname
	?C<A	B
	GOYES	HashBigErr	** Too long hashname?
	A=A-1	B		** Decrement to get 1 nibble for cmp
	ASRC			** A[S]=idlen-1
	?A=B	S		** Equal to wanted size?
	RTNYES
	D=D+1	A		** Increase cmdnum
	D0=D0-	5				->id
	GOSUBL	SkipOb				->idnext
	GOTO	NxtHash?	** Try the next id
  ENDCODE
;

** {}- **********************************************************************
* Interface :	( {1} {2} --> {1-2} )
* Description : LISP {}-
*****************************************************************************

NULLNAME	{}-
::
    DUPNULL{}? caseDROP
    SWAP				( --> {2} {1} )
    DUPNULL{}? case SWAPDROP

    INNERDUP #2+ROLL ZERO ROT		( --> on .. ox .. o1 {2} #0 #n )
    ZERO_DO (DO)
	DUP #3+PICK			( --> on .. ox .. o1 {2} #x ox )
	3PICKSWAP

    CODE
	GOTO	EqualPosComp
    ENDCODE
					( --> on .. ox .. o1 {2} #x t/f )
	#0=ITE
	    #1+
	::  DUP #3+ ROLLDROP
	;
    LOOP

    SWAPDROP {}N
;

** EqualPosComp *************************************************************
* Interface :	( comp ob --> #pos | #0 )
* Description : Replacement for slow RPL EQUALPOSCOMP. Returns the index of
*		the first object in comp matching (EQUAL) ob.
* Uses :
* Calls :	SavPtr SkipOb
* Defines :	Psh#Lp
*****************************************************************************

ASSEMBLE
EqualPosComp
* CPU			A	B	C	D	D0	D1	xx
	A=DAT1	A	->ob
	R1=A								R1:->ob
	AD1EX
	C=DAT1	A			ob prologue
	R2=C								R2:ob prol
	D1=A
	D1=D1+	5
	D=D+1	A
	A=DAT1	A	->comp
	D1=D1+	5
	D=D+1	A
	GOSUBL	SavPtr

	B=A	A		->comp

	C=R1				->ob
	D=C	A				->ob
	D0=C						->ob
	GOSUBL	SkipOb					->past ob
	CD0EX				->past ob
	D=C-D	A				ob len

	A=B	A	->comp

	D0=A						->comp
	D0=D0+	5	** skip comp prol
	C=0	A	** init. cnt
	GONC	EqLpEn	** BET

NotFnd	A=0	A	** ob not in comp, push #0
	R0=A
	GOTO	Psh#Lp

EqLp	GOSUBL	SkipOb					->nxt

	C=R0.F	A			cnt
EqLpEn	C=C+1	A			++cnt
	R0=C.F	A							R0:cnt'

	A=DAT0	A	->cob|prol
	LC(5)	=SEMI			SEMI
	?A=C	A	** list due ?
	GOYES	NotFnd	** yes, push #0

	D1=A							->cob|prlg
	A=DAT1	A	[->cob|prlg]
	LC(5)	=PRLG			PRLG
	?C#A	A	** [->cob|prlg] # PRLG ?
	GOYES	InDir	** yes, indirect

	AD0EX		->cob
	D0=A						->comp
	D1=A							->cob
	A=DAT1	A	cob prol

InDir	C=R2.F	A			ob prol
	?A#C	A	** prol not equal ?
	GOYES	EqLp	** yes, next ob

	CD1EX				->cob
	B=C	A		->cob
	D1=C							->cob
	CD0EX				->comp		->cob
	RSTK=C		** save ->comp

* CPU
*	D0: ->cob	R0: cnt
*	D1: ->cob	R1: ->ob
*	B:  ->cob	R2: ob
*	D:  ob len	RSTK: ->comp

	GOSUBL	SkipOb					->past cob
	CD0EX				->past cob
	C=C-B	A			cob len

	?C#D	A	** equal lengths ?
	GOYES	NotEq	** no, loop

	A=R1.F	A	->ob
	D0=A						->ob

	B=C	A		ob len
	BSR	A		reg count
	P=C	0	** P: nibble count

Comp16	B=B-1	A		--rcnt
	GOC	CompP	** check rest

	A=DAT0	W
	C=DAT1	W
	D0=D0+	16
	D1=D1+	16

	?A=C	W
	GOYES	Comp16

NotEq0	P=	0
NotEq	C=RSTK
	D0=C
	GOTO	EqLp

CompP	P=P-1
	GOC	FndEq

	A=DAT0	WP
	C=DAT1	WP

	?A#C	WP
	GOYES	NotEq0

FndEq	P=	0
	C=RSTK
Psh#Lp	GOVLNG	=PUSH#LOOP


** D0=RAM *******************************************************************
* Entry :	RSTK points to GX var, followed by SX var
* Exit :	D0 address of RAM variable
* Uses :	D0 C[A]
* Stack levels: 0
*****************************************************************************

* CPU				C	D0

D0=RAM	D0=(5)	(=addrADISP)+6	magic location
	C=DAT0	B		N
	?CBIT#1 3
	GOYES	isSX				carry set if SX

	C=RSTK			->1st
	D0=C				->1st
	C=DAT0	A		1st
	D0=D0+	10			->ret
	CD0EX			->ret	1st
	PC=C

isSX	C=RSTK			->1st
	D0=C				->1st
	D0=D0+	5			->2nd
	C=DAT0	A		2nd
	D0=D0+	5			->ret
	CD0EX			->ret	2nd
	PC=C
RPL

** xL->DIR ******************************************************************
* Interface :	( %  --> dir )
*		( id --> dir )
*		( rp --> ob )
* Description : Disassemble library with LID % or name id; extract rp
* Uses :	RomID -13
* Calls :	L->D
* Defines :	ChkLid
* Ed. Hist. :
*     2.000 16.12.1991 RH	Release
*	001 03.01.1992 DM	beautyfy
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	LDIR
::
    CK1&Dispatch
    real
    ::
	NULLNAME	ChkLid
	::
	    COERCEDUP
	    EvalSG: NEXTROMPID NEXTROMPID_G
	    ?SKIP SETNOLIBERR
	    OVER#= ?SEMI
	    SETNOLIBERR
	;

	' L->D
	fQuiet TestSysFlag
	NOTcase EVAL
	DoffEval
    ;
    id					( *Undocumented feature* )
    ::
	NULLNAME	EnshureSX
	::
	    EvalSG: NOP NoG
	;

	ROMPARTID			( *SX only* )
	?SKIP SETNOLIBERR
	L->D
    ;
    rompointer
    ::
	DUP ROMPTR># DROP [#] RomID
	#=case SETROMPERR

	ROMPTR@ ?SEMI
	SETROMPERR
    ;
;

** L->D *********************************************************************
* Interface :	( #lid --> dir )
* Description : Create a directory from the library with the ID #lid
* Uses :	RomID 6 7
* Defines :
* Calls :	A->
* Ed. Hist. :
*     1.000 xx.xx.1991 RH	alpha
*	100 09.02.1992 DM	modified
*****************************************************************************

DEFINE	WantHidd?	SEVEN TestUserFlag
DEFINE	Want$Lst?	SIX TestUserFlag

DEFINE	L->Dlams	SIX

DEFINE	@libid		6GETLAM
DEFINE	@special	5GETLAM 	( *Todo* )
DEFINE	!special	5PUTLAM
DEFINE	@hid		4GETLAM
DEFINE	!hid		4PUTLAM
DEFINE	@vis		3GETLAM
DEFINE	!vis		3PUTLAM

DEFINE	Sethid		:: FOUR 2PUTLAM ;
DEFINE	IsVis?		2GETLAM #3=
DEFINE	@ID{}		2GETLAM GETLAM
DEFINE	!ID{}		2GETLAM PUTLAM

DEFINE	!AddCId 	2PUTLAM 	( *For later usage* )
DEFINE	AddCId: 	2GETEVAL

DEFINE	@leadc		1GETLAM 	( *@hashes later* )
DEFINE	!leadc		1PUTLAM
DEFINE	@hashes 	1GETLAM
DEFINE	!hashes 	1PUTLAM


NULLNAME	L->D
::
    [#] RomID
    OVER#=case SETNOLIBERR

    BlankDA2
    "Analyzing\1F" DISPROW4

    NULL{} DUPDUP TOTEMPOB		( *Special, Hidden, Visible {}* )
    THREE				( *ID{} lambda* )

    5PICK GetTitle
    ITE 				( *leadc* )
    ::	ID>$ DUPNULL$?
	NOTcase CAR$
	DROP CHR_x
    ;
	CHR_x

    ' NULLLAM L->Dlams NDUPN DOBIND     ( #id f {h} {v} :: c --> )

    HXS 3 000 ONE			( --> hxs #n )

    @libid GetLink
    IT
    ::	LENHXS FIVE #/ SWAPDROPDUP
	ZERO_DO (DO)
	    ?ATTNQUIT
	    @libid INDEX@ #>ROMPTR
	    EvalSG: ROMPTRDECOMP G_ROMPTRDECOMP
	    ITE
	    ::	IsVis? WantHidd? ANDcase NOP

		DUP ID>$ DISPROW5

		@ID{} OVER >TCOMP !ID{}
	    ;
	    ::	INDEX@ #>$ @leadc >H$

		DUP DISPROW5

		$>ID
		WantHidd? NOT?SEMI
		@hid OVER >TCOMP !hid
	    ;
	    SWAP
	LOOP

	DUP OVER#2+UNROL {}N !hashes

	"Splitting\1F" DISPROW4

	ZERO_DO (DO)
	    ?ATTNQUIT
	    ::	@libid INDEX@ #>ROMPTR
		DUPROMPTR@		( --> .. #n rp ob )
		NOTcasedrop Sethid

		SWAPDROP		( --> .. #n ob )
		@hashes INDEX@ #1+
		NTHCOMPDROP ID>$	( --> .. #n ob $ )
		DUP DISPROW5

		CHR_LeftPar >T$
		$>ID SWAP		( --> .. #n id' ob )

		NULLNAME RompConv	( ob --> ob' )
		::
		    INHARDROM? case
		    ::	DUPROM-WORD? case PTR>ROMPTR
			TOTEMPOB
		    ;
		    @hashes @libid TRUE Convert
		;

					( --> .. #n id' ob' )
		3PICK #2+UNROLL 	( --> hxs ob' idn .. ob0 #i id' )
		OVER #2+UNROLL		( --> hxs id' ob' idn .. ob0 #i )
		#2+
	    ;
	LOOP
    ;

    NULL$ DISPROW5
    "Control Vars\1F" DISPROW4          ( --> hxs idn obn .. id0 ob0 #c )

    ( *AddCId, next in prevprev is id assuming 2GETEVAL is used
       hxs idn obn .. id0 ob0 #n ob --> hxs id ob idn obn .. id0 ob0 #n'* )
    '
    ::	RDROP 'R Want$Lst? ITE
	::  3PICK #2+UNROLL		( *Add to end of dir* )
	    OVER #1+UNROLL
	;
	    SWAPROT			( *Add to start of dir* )
	#2+
    ;

    !AddCId

    @libid GetConfig
    IT
    ::	RompConv AddCId: ID $CONFIG(
    ;

    @libid GetMesg
    IT
    ::	A-> CARCOMP COERCE {}N AddCId: ID $MESSAGE(
    ;

    @hid DUPNULL{}?
    ITE_DROP
    ::	AddCId: ID $HIDDEN(
    ;

    WantHidd? ?SKIP
    ::	@vis AddCId: ID $VISIBLE(
    ;

    @libid GetTitle IT
    ::	ID>$ AddCId: ID $TITLE(
    ;

    @libid UNCOERCE TOTEMPOB AddCId: ID $ROMID(
    ABND
    "\8DDir\1F" DISPROW4

    P{}N {}>DIR
;

** xMCFG ********************************************************************
* Interface :	( --> )
* Description : Get the current ROM ID and generate a $CONFIG for autoattach
* Calls :	GetRID x$config
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	MCFG
::
    CK0

    GetRID
    ' TOSRRP                    ( --> # ob )
    2Ob>Seco			( --> :: # ob ; )

    x$config ?STO_HERE
;

** xML->D *******************************************************************
* Interface :	( --> ::; )
* Defines :	{}->LD GenLDComp
* Calls :	=POP# =Loop
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	MLD
::
    CK0

    list
    '                                   ( {} --> ld )
    ::	>HCOMP				( --> { #rid ... } )
	DUP OSIZE #5-			( --> {} #sz )

    NULLNAME {}->LD
    CODE				( {} #sz --> LibDat )
* CPU			A	C	D1
	GOSBVL	=POP#	sz		->stk
	C=A	A		sz
	RSTK=C		** Save size
	A=DAT1	A	->{}
	AD1EX		->stk		->{}
	LC(5)	=DOEXT0 	LD
	DAT1=C	A	** {}prlg becomes LDprlg
	D1=D1+	5			->#prlg
	C=RSTK			sz
	DAT1=C	A	** #prlg becomes length
	D1=A				->stk
	GOVLNG	=Loop
    ENDCODE
    ;

    NULLNAME GenLDComp
    ::
	GetRID >HCOMP			( --> #t ::#rid b; )
	'
	::  CK1NoBlame
	    CK&DISPATCH1
	;
	ROT >TCOMP			( --> ::# b; ::c #; )
	SWAP >TCOMP
    ;
;

** xMD->L *******************************************************************
* Interface :	( --> ::; )
* Defines :	loop
* Calls :	GenLDComp =Loop
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	MDL
::
    CK0

    #AF 				( *Library Data* )
    '                                   ( ld --> {} )
    ::	SWAP TOTEMPSWAP			( --> ld #rid )

	CODE				( ob --> ob f/t )
*			A	B	C	D1
	GOSUBL	Pop#	rid
	GOSBVL	=SAVPTR
	B=A	A		rid
	C=DAT1	A			->ld	->stk
	D1=C					->ld
	A=DAT1	A	prlg

	LC(5)	=DOEXT0			LDprlg
	?C#A	A
	GOYES	gpptfl				** ob not ld
*						** ob is ld, check lid
	D1=D1+	10				->lid
	A=DAT1	A		lid

	?B#A	A
	GOYES	gpptfl				** not our ld
*						** convert ld -> {}
	D1=D1-	5				->len
	LC(5)	=DOBINT 		#prlg
	DAT1=C	A	** len becomes #prlg

	D1=D1-	5				->prlg
	LC(5)	=DOLIST 		{}prlg
	DAT1=C	A	** LDprlg becomes {}prlg
*						** CC
gpptfl	GOVLNG	=GPPushT/FLp

	ENDCODE

	case SETSIZEERR

	CDRCOMP				( {} --> {}-1st )
    ;

    GenLDComp
;

*** xOB-> *******************************************************************
* Interface :	( arry|seco|symb|romptr|dir|ld|bak --> ob1 .. obn % )
* Description : Split composite objects
* Defines :	loop A->
* Calls :	{#}>{%}
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	OB
::
    CK1&Dispatch
    arry
    NULLNAME	A->
    ::
	ARRYLP_DO (DO)
	    INDEX@ OVER GETATELN DROPSWAP
	LOOP
	DIMLIMITS {#}>{%}
    ;
    seco
	XEQLIST>
    symb
	XEQLIST>
    rompointer
    ::	ROMPTR># UNCOERCE2
    ;
    rrp
    ::	ZERO SWAPOVER
	BEGIN
	    ?ATTNQUIT
	    NEXTRRPOB
	WHILE
	    DUP TOTEMPOB
	    SWAP RAM-WORDNAME
	    5ROLL #1+ 5ROLL 5ROLL
	REPEAT
	DROP UNCOERCE
    ;
    backup
    ::	DUP BAK>OB
	SWAP BAKNAME DROP
    ;
    id
	ID>$
    THIRTYONE				( *#* )
    CODE
*  CPU			A	C	D1
	C=DAT1	A		&#	->Stk
	CD1EX			->Stk	->#
	D1=D1+	5			->adr
	A=DAT1	A	->ob

	D1=C				->Stk
	DAT1=A	A			*Stk = ->ob
loop	GOVLNG	=Loop
    ENDCODE
    #1F 				( *Binary interger* )
    ::	EvalSG: ?Cov#> xOBJ>
    ;
    #AF 				( *Library Data* )
    ::	TOTEMPOB

	CODE
*			A	C	D0	D1
	GOSUB	SavPtr

	C=DAT1	A		->ld		->stk
	D1=C					->ld
	D1=D1+	5				->len
	A=DAT1	A	len
	C=C+A	A		->last(5)
	D0=C				->last(5)
	A=DAT0	A	last(5)
	LC(5)	=SEMI
	?C#A	A
	GOYES	GPPT
*						** convert ld -> {}
	LC(5)	=DOBINT 	#prlg
	DAT1=C	A	** len becomes #prlg

	D1=D1-	5				->prlg
	LC(5)	=DOLIST 	{}prlg
	DAT1=C	A	** LDprlg becomes {}prlg
*			** CC
GPPT	GOTO	gpptfl

	ENDCODE

	case SETSIZEERR

	DUP CDRCOMP
	SWAP CARCOMP UNCOERCE
    ;
    #BF 				( *Access pointer* )
    ::	EvalSG: xOBJ> ?ACCPTR>
    ;
    any
	xOBJ>
;

** PosHxs *******************************************************************
* Interface :	( hxs(1) hxs(2) # --> #0/#pos )
* Description : Starting at offset #, search the 1st occurence of hxs(2)
*		in hxs(1).
* Calls :	Pop# SavPtr =PUSH#ALOOP
* Defines :	PshALp
*****************************************************************************

NULLNAME	PosHxs
CODE
ENDCODE
ASSEMBLE
* CPU			A	B	C	D	D0	D1	Rx
	GOSUB	Pop#	pos
	C=DAT1	A		&hxs[f]
	R1=C	A							1:&hxs[f]
	D1=D1+	5
	D=D+1	A	    *** Pop hxs[f]

	C=DAT1	A		&hxs[s]
	R3=C	A							3:hxs[s]
	D1=D1+	5
	D=D+1	A	    *** Pop hxs[s]

	GOSUB	SavPtr

	?A=0	A	    *** Start = 0 ?
	GOYES	Match
	A=A-1	A	--pos

	C=R3	A			&hxs[s]
	D0=C						&hxs[s]
	D0=D0+	5					&ls
	C=DAT0	A			ls
	C=C-CON A,5
	?C=0	A	    *** len[s] = 0 ?
	GOYES	NoMatch
	B=C	A		ls
	D0=D0+	5					&s
	CD0EX				&s
	R3=C	A							3:&s
	C=C+A	A			&s
	D0=C						&s

	C=R1	A			&hxs[f]
	D1=C							&hxs[f]
	D1=D1+	5						&lf
	C=DAT1	A			lf
	C=C-CON A,5
	?C=0	A	    *** len[fnd] = 0 ?
	GOYES	NoMatch

	D1=D1+	5						&f
	CD1EX				&f			lf
	R1=C	A							1:&f
	CD1EX				lf			&f

	?C>B	A	    *** lf > ls ?
	GOYES	NoMatch

	C=C-1	A		lf-1
	R2=C	A							2:lf-1
	B=B-C	A		ls-lf+1
	?A>=B	A	    *** pos >= len[s] ?
	GOYES	NoMatch

	B=B-A	A		ls-lf-pos

	A=0	B
	C=0	B

* CPU			xx	trys	x	x	&s	&f
*			R0:x	R1:&f	R2:lf-1 R3:&s

	GONC	SEntry	    *** BET

NoMatch A=0	A
Match
PshALp	GOVLNG	=PUSH#ALOOP

SLoop	A=DAT0	1
	C=DAT1	1
	D0=D0+	1					++s
	?A=C	B
	GOYES	Match?
SEntry	B=B-1	A		--trys
	GONC	SLoop
	GOC	NoMatch     *** BET

Match?	CD0EX				&ns
	D0=C
	R0=C.F	A							0:&ns
	C=R2.F	A			lf-1
	D=C	A
	C=0	B
	GOC	MEntry	    *** BET

MLoop	A=DAT0	1
	C=DAT1	1
	?A=C	B
	GOYES	MNxt

	C=R0.F	A
	D0=C						&s
	C=R1.F	A
	D1=C							&f
	C=0	B
	GONC	SEntry	    *** BET

MNxt	D0=D0+	1
MEntry	D1=D1+	1
	D=D-1	A
	GONC	MLoop

	A=R0	A	&ns
	C=R3	A			&s
	A=A-C	A	pos
	GONC	Match	    *** BET
RPL

** ob>hxs *******************************************************************
* Interface :	( ob --> hxs )
* Description : Move ob into body of a hxs
* Calls :	SavPtr SkipOb Mk$n MoveD =GPOverWrR0Lp
* Defines :
*****************************************************************************

NULLNAME	ob>hxs
CODE
ENDCODE
ASSEMBLE
* CPU			A	C	D0	D1	R0	R1
	GOSUB	SavPtr
	A=DAT1	A	->ob
	R1=A							->ob
	D0=A				->ob
	GOSUB	SkipOb	xx	xx	->past ob
	CD0EX			  ->past ob
	A=R1		    ->ob
	C=C-A	A			len ob
	GOSUB	Mk$n	len val ->stk	->body	->stk	->$
	D0=D0-	10			->$
	LC(5)	=DOHSTR 	hxs
	DAT0=C	A	    We want HXS !
	D0=D0+	10	->body
	AD0EX		    ->body		len val
	D1=A				->body
	D0=D0-	5		len
	CD0EX			  len
	A=R1		    ->ob
	D0=A				->ob
	GOSUB	MoveD
	GOVLNG	=GPOverWrR0Lp

*****************************************************************************
*		1st Assembler Jumptable
*****************************************************************************

Pop#	GOVLNG	=POP#
SavPtr	GOVLNG	=SAVPTR
SkipOb	GOVLNG	=SKIPOB
MoveD	GOVLNG	=MOVEDOWN
Mk$n	GOVLNG	=MAKE$N

RPL

** x->DIR *******************************************************************
* Interface :	( ob1 id .. obn id %n --> rrp )
* Calls :	SavPtr =GPMEMERR =SETTYPEERR =GPGotoC SkipOb =CREATETEMP
*		DoGarb =GPOverWrALp MoveD GetPtr =OverWrALoop
* Defines :	MemErr
* Ed. Hist. :
*     1.000 02.01.1992 DM	alpha
*	100 15.02.1992 DM	change to Rick's assembler version
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	DIR
::
    CK1 CKREAL
    COERCE
    DEPTH OVER #2* #>?SKIP SETSTACKERR

    CODE
* CPU			A	B	C	D	D0	D1	Rx
	GOSUB	SavPtr
	CD1EX				&stk			el
	D1=C							&stk
	A=DAT1	A	&#n
	D0=A						&#n
	D0=D0+	5					&n
	A=DAT0	A	n

	C=0	A
	LC(1)	13	    *** Dir header = 13 nib
	D=C	A				DSiz
	C=A	A			n
	R0=C								0:n
	GONC	SizEntr     *** BET

MemErr	GOVLNG	=GPMEMERR
TypErr	LC(5)	=SETTYPEERR
	GOVLNG	=GPGotoC

SizLoop R1=C								1:n
	D1=D1+	5						&&nxtID
	A=DAT1	A	&nxtID
	D0=A						&nxtID
	LC(5)	=DOIDNT
	A=DAT0	A	*nxtID
	?A#C	A
	GOYES	TypErr

	D0=D0+	5					&len(ID)
	C=0	A			0
	C=DAT0	B			len(ID)
	?C=0	B
	GOYES	NoIDadd

	C=C+1	A
	C=C+C	A			len+1*=2

NoIDadd C=C+CON A,7			len(name)
	D=D+C	A				DSiz+=len(name)
	GOC	MemErr

	D1=D1+	5						&&nxt(ob)
	A=DAT1	A	&nxt(ob)
	B=A	A		&nxt(ob)
	D0=A						&nxt(ob)
	GOSUB	SkipOb	xxx		xxx		&past(ob)
	CD0EX				&past(ob)
	C=C-B	A			len(ob)
	D=D+C	A				DSiz+=len(ob)
	GOC	MemErr

	C=R1				n
SizEntr C=C-1	A			--n
	GONC	SizLoop

	C=D	A			DSiz
	R1=C								1:DSiz
	ST=0	=sGarbage   *** Garbage not collected

GetMem	GOSBVL	=CREATETEMP	siz+6	des.siz+6	&hole	&link
	GONC	NoGarb

	GOSUBL	DoGarb	xxx	xxx	xxx	xxx	xxx	xxx
	C=R1				DSiz
	GONC	GetMem	    *** BET

NoGarb	CD0EX				&hole
	R1=C								1:&hole
	D1=C							&hole
	LCHEX	000007FF02A96
	DAT1=C	13	    *** Write DORRP, empty lib.link, null len
	D1=D1+	13
	C=R0				n
	?C#0	A	    *** Null Directory ?
	GOYES	No0Dir

	A=R1		&dir
	GOVLNG	=GPOverWrALp

No0Dir	D=C	A				n
	CD1EX				&data
	D1=C							&data
	R2=C								2:&start
	GOSBVL	=D0=DSKTOP  &stk			    &stk
	C=A	A			&stk
	GOC	MovEntr     *** BET

CpyLoop D0=C						&stk
	RSTK=C								r:&stk
	AD1EX		&link
	C=R2				&start
	D1=A							&link
	A=A-C	A	&link-&start
	DAT1=A	A	    *** link
	D1=D1+	5						&ID
	AD1EX		&ID
	R2=A								2:&ID
	D1=A							&ID

	D0=D0+	5					&&nxt(ID)
	A=DAT0	A	&nxt(ID)
	D0=A						&nxt(ID)
	D0=D0+	5					&len(ID)
	C=0	A			0
	C=DAT0	B			len(ID)
	?C=0	B	    *** Null ID ?
	GOYES	NoIDmov

	RSTK=C								r:len(ID)
	C=C+1	A
	C=C+C	A			len(ID)+1*=2
	GOSUB	MoveD	xxx		xxx		&past(ID) &2nd(len)
	C=RSTK				len(ID)

NoIDmov DAT1=C	B	    *** Write 2nd len
	D1=D1+	2						&nxt(ob)
	C=RSTK				&stk
	C=C+CON A,10			&&ob
	D0=C						&&ob
	RSTK=C				&&ob
	A=DAT0	A	&ob
	B=A	A		&ob
	D0=A						&ob
	GOSUB	SkipOb	xxx		xxx		&past(ob)
	C=B	A			&ob
	CD0EX				&past(ob)	&ob
	C=C-B	A			len(ob)
	GOSUB	MoveD	xxx		xxx		&past(ob) &nxt(lnk)
	C=RSTK				&&ob

MovEntr D=D-1	A				--n
	GONC	CpyLoop

	C=R1				&dir
	C=C+CON A,8			&len(dir)
	D1=C							&len(dir)
	A=R2		&past(dir)
	A=A-C	A	len(dir)
	DAT1=A	A	    *** Insert len into len(dir)
	GOSUBL	GetPtr

	C=R0				n
	C=C+C	A			n*=2
	D=D+C	A				MEM+=n*2
	A=C	A	n*2
	C=C+C	A
	C=C+C	A
	C=C+A	A			n*=10
	AD1EX		&stk
	A=A+C	A	&stk+=n*10
	D1=A							&stk
	A=R1		&dir
	GOVLNG	=OverWrALoop

    ENDCODE
;

** x->PRG *******************************************************************
* Interface :	( ob1 .. obn %n --> ::; )
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	PRG
::
    CKN ::N
;

** x->XLIB ******************************************************************
* Interface :	( % % | hxs hxs --> rp )
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	XLIB
::
    CK2&Dispatch
    2REAL
    ::	COERCE2 #>ROMPTR
    ;
    2HXS
    ::	HXS>#2	#>ROMPTR
    ;
;

** x->ARR *******************************************************************
* Interface :	( ob1 .. obn %n --> arry )
*		( ob1 .. obn { %d1 .. %di } --> arry )
* Calls :	SavPtr PshALp
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	ARR
::
    CK1
    DUPTYPEREAL? IT ONE{}N		( *Check for % | {}* )
    DUPTYPELIST? NcaseTYPEERR
    DUPNULL{}? caseSIZEERR

    INNERCOMP ONESWAP			( --> ... #1 i )
    ZERO NULL{} ' NULLLAM DUPTWO DOBIND ( *spare lam;{} of dim, i = dim cnt* )

    ZERO_DO (DO)
	ISTOP-INDEX #1+ROLL		( *Get nth element* )
	CKREAL COERCE			( --> ... #n #d )
	1GETLAM OVER >HCOMP 1PUTLAM	( *Add dim d to {}* )
	#*				( --> ... #n*d )
    LOOP

    DUP#2+ DEPTH #> caseSIZEERR 	( *Check for corr. meta size* )

    1GETLAM INNERDUP #>HXS SWAP 	( --> ...#n ... hxs[dim] #dim )
    ZERO_DO (DO)
	SWAP #>HXS !!append$		( *HXS, dimension cnt, dimensions* )
    LOOP

    3PICK				( --> ...#n hxs ob )
    '
    CODE
* CPU			A	D1
	GOSUB	SavPtr
	A=DAT1	A	->ob
	D1=A			->ob
	A=DAT1	A	[ob]
	GOTO	PshALp
    ENDCODE

    DUP 2PUTLAM EVAL 1PUTLAM

    ob>hxs ONE FIVE SUBHXS		( --> ...#n hxs hxs[prol] )
    SWAP&$ OVER 			( --> ...#n hxs #n )

    ZERO_DO (DO)
	ISTOP-INDEX #2+PICK		( --> ...#n hxs obi )
	2GETEVAL 1GETLAM #= NcaseTYPEERR ( *Not same type* )
	ob>hxs SIX MINUSONE SUBHXS !append$
    LOOP

    1PUTLAM NDROP 1GETABND		( *Because of error handling system* )
    [#] DOARRY ChgType
;

** x->ALG *******************************************************************
* Interface :	( ob1 .. obn %n --> symb )
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	ALG
::
    CKN DUP#0= caseSIZEERR
    SYMBN
;

** x->LD ********************************************************************
* Interface :	( {} % --> ld )
* Calls:	{}->LD
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	LD
::
    CK2&Dispatch
    LISTREAL
    ::	COERCE TOTEMPOB >HCOMP		( --> { #rid ... } )
	DUP OSIZE #5-			( --> {} #sz )
	{}->LD
    ;
;

** x->BAK *******************************************************************
* Interface :	( ob $ --> bak )
* Description : Create BACKUP object
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	BAK
::
    CK2 DUPTYPEIDNT? NcaseTYPEERR
    SWAP OB>BAK
;

** x->ID ********************************************************************
* Interface :	( $ --> id )
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	ID
::
    CK1&Dispatch
    str
    ::	DUPLEN$ 127 #> caseSIZEERR
	$>ID
    ;
;

*** xADRp *******************************************************************
* Interface :	( ob --> ob hxs(addr) )
* Description : Get address of ob.
* Calls :	SavPtr PHxsLp
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	ADRp
::
    CK1
    CODE
* CPU			A
	GOSUB	SavPtr
	A=DAT1	A	&obj
	P=	4
	GOLONG	PHxsLp
    ENDCODE
;

** x$xxx ********************************************************************
* Interface :	( --> '$xxx' )
* Description : Just put the name of a control variable onto the stack
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	$romid		:: ' ROMID ;
ASSEMBLE
	CON(1)	8
RPL
xNAME	$visible	:: ' VISIBLE ;
ASSEMBLE
	CON(1)	8
RPL
xNAME	$nocompress	:: ' NOCOMPRESS ;
ASSEMBLE
	CON(1)	8
RPL
xNAME	$title		:: ' TITLE ;
ASSEMBLE
	CON(1)	8
RPL
xNAME	$config 	:: ' CONFIG ;
ASSEMBLE
	CON(1)	8
RPL
xNAME	$vars		:: ' VARS ;
ASSEMBLE
	CON(1)	8
RPL
xNAME	$hidden 	:: ' HIDDEN ;
ASSEMBLE
	CON(1)	8
RPL
xNAME	$message	:: ' MESSAGE ;


** xLBCRC *******************************************************************
* Interface :	( lib | bak --> lib' | bak' )
* Description : Recalc and patch new CRC
* Calls :	SavPtr LBCrc
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	LBCRC
::
    CK1&Dispatch
    # 8F				( *library* )
    CODE
* CPU			C	D1
BCrc	GOSUB	SavPtr
	C=DAT1	A	&ob
	D0=C			&ob
	GOLONG	LBCrc
    ENDCODE

    backup
    CODE
	GOTO	BCrc
    ENDCODE
;

** xRNLIB *******************************************************************
* Interface :	( lib $ --> lib' )
* Description:	Rename library.
* Calls :	ob>hxs
*		LCrc
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RNLIB
::
    CK2&Dispatch
    # 8F3				( *libstr* )
    ::	DUPNULL$? ITE
	::  DROP HXS 2 00 TOTEMPSWAP	( --> hxs lib )
	;
	::  $>ID ob>hxs 		( --> lib hxs[id] )
	    SIX MINUSONE SUBHXS 	( *Strip prolog* )
	    DUPONE TWO SUBHXS &$	( *Append idlen* )
	    SWAP			( --> hxs lib )
	;

	DUPONE TWO SUBHXS HXS># 	( --> hxs lib #tl )
	DUP#0=ITE
	::  DROP THREE			( --> hxs lib #idst )
	;
	::  #2* #5+			( --> hxs lib #idst )
	;

	MINUSONE SUBHXS !append$

    CODE
	GOLONG	LCrc
    ENDCODE
    ;
;

** xCHLID *******************************************************************
* Interface :	( lib % --> lib' )
* Description:	Change the library id of the given library (lib) to the given
*		value (%).
*		The config program is not changed !!!
*		Proberty list fields are not changed !!!
* Calls :	PosHxs
*		Pop# SavPtr Trav+ PHxsLp LCrc
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	CHLID
::
    CK2&Dispatch
    libreal
    ::
	COERCE
	# 7FF OVER#< case
	    $RidOutOR
	SWAP CKREF OVER 		( --> #[new id] lib # )

    CODE			( *Extract the old lid and patch the new one* )
* CPU			A	B	C	B	D0
	GOSUBL	Pop#	newid
	GOSUBL	SavPtr
	C=DAT1	A			->lib
	D0=C						->lib
	D0=D0+	10					->title
	B=A	X				newid
	GOSUB	Trav+	xxx		xxx		->lid		CC
	A=B	X	newid
	C=0	A			0
	C=DAT0	3			oldid
	DAT0=A	3	    ** Patch new LID
	A=C	X
	P=	2
	GOLONG	PHxsLp
    ENDCODE

	ROT #>hxs3			( --> lib hxs[oid] hxs[nid] )
	HXS 5 29E20			( *DOROMP* )
	SWAPROT 3PICK SWAP&$		( --> lib hxs[rp] nid rpoid )
	UNROT &$			( --> lib rpoid rpnid )
					( *Replace all ROMPTR* )
	UNROT 2DUP ONE PosHxs		( --> $r lib $f #p )
	DUP#0=ITE
	::  2DROP SWAPDROP
	;
	::  SWAP DUP LENHXS		( --> $r lib #p $f #lf )
	    5UNROLL 5UNROLL		( --> $f #lf $r lib #p )
	    NULLHXS UNROT		( --> $f #lf $r lib' lib #p )
	    BEGIN
		2DUP 7PICK #+		( --> $f #lf $r lib' lib #p lib #p' )
		MINUSONE SUBHXS 	( --> $f #lf $r lib' lib #p libh )
		5UNROLL 		( --> $f #lf libh $r lib' lib #p )
		#1-1SWAP SUBHXS !append$ ( --> $f #lf libh $r lib'' )
		OVER !append$ ROTDUP	( --> $f #lf $r lib' libh libh )
		6PICK ONE PosHxs	( --> $f #lf $r lib' libt #p )
		DUP#0=
		?ATTNQUIT
	    UNTIL
	    DROP &$			( --> $f #lf $r lib' )
	    4UNROLL 3DROP		( --> lib' )
	;

    CODE
	GOLONG	LCrc
    ENDCODE
    ;
;

** xRHASH *******************************************************************
* Interface :	( % --> hxs / % )
* Description : Get (pointer to) hash table
* Defines :	RCtrl:
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RHASH
::
    CK1

    NULLNAME	RCtrl:
    ::
	CKREAL
	DUP ChkLid
	'REVAL NOT?SEMI
	SWAPDROP
    ;

    NULLNAME	GetHash
    ::
	EvalSG:
	::  GETHASH NOTcaseFALSE
	    ?Cov#> TRUE
	;
	::  GETHASH_G NOTcaseFALSE
	    ?ACCPTR> TRUE
	;
    ;
;

** xRLINK *******************************************************************
* Interface :	( % --> hxs / % )
* Description : Get (pointer to) link table
* Calls :	RCtrl:
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RLINK
::
    CK1 RCtrl:

    NULLNAME	GetLink
    ::
	EvalSG:
	::  GETLINK NOTcaseFALSE
	    ?Cov#> TRUE
	;
	::  GETLINK_G NOTcaseFALSE
	    ?ACCPTR> TRUE
	;
    ;
;

** xRCFG ********************************************************************
* Interface :	( % --> ::; / % )
* Description : Get (pointer to) config code
* Calls :	RCtrl:
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RCFG
::
    CK1 RCtrl:

    NULLNAME	GetConfig
    ::
	EvalSG:
	::  GETCONFIG NOTcaseFALSE
	    ?Cov#> TRUE
	;
	::  GETCONFIG_G NOTcaseFALSE
	    ?ACCPTR> TRUE
	;
    ;
;

** xRMSG ********************************************************************
* Interface :	( % --> arry / % )
* Description : Get (pointer to) message table
* Calls :	RCtrl:
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RMSG
::
    CK1 RCtrl:

    NULLNAME	GetMesg
    ::
	EvalSG:
	::  GETMESG NOTcaseFALSE
	    ?Cov#> TRUE
	;
	::  GETMESG_G NOTcaseFALSE
	    ?ACCPTR> TRUE
	;
    ;
;

** xRTITLE ******************************************************************
* Interface :	( % --> $ / % )
* Description : Recall library title
* Calls :	RCtrl:
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RTITLE
::
    CK1  CKREAL
    DUP ChkLid

    NULLNAME	GetTitle
    ::
	EvalSG: ROMPARTNAME ROMPARTNAME_G
    ;

    NOT?SEMI
    SWAPDROP ID>$
;

*** xRPORT ******************************************************************
* Interface :	( % --> ob1 .. obn )
* Description : Recall vars from port % (0,1,2) onto stack
* Ed. History :
*     1.000 xx.xx.1991 RH	alpha
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RPORT
::
    CK1 CKREAL
    COERCE GetBVars #1+ROLL DROP
;

*****************************************************************************
*		2nd Assembler Jumptable
*****************************************************************************

ASSEMBLE

GetPtr	GOVLNG	=GETPTR
DoGarb	GOVLNG	=DOGARBAGE
PopASP	GOVLNG	=PopASavptr
Trav+	GOVLNG	=TRAVERSE+

RPL

** xRLIB ********************************************************************
* Interface :	( %LID	     --> lib0 %0 .. lib2 %2 )
*		( %Port:%LID --> lib )
* Description : Recalls a library from a given port or all libraries with
*		same LID from all ports.
* Defines :	Tag>LidP
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	RLIB
::
    CK1&Dispatch
    real
    ::
	COERCE ZEROSWAP 		( --> #0 #lid )
	EvalSG: THREE THIRTYFOUR
	ZERO_DO (DO)
	    INDEX@

	    NULLNAME	x@
	    ::
		EvalSG: X@ X@_G
	    ;

	    IT		( --> #c #l lib )
	    ::	ROT#1+ ROT		( --> lib #c #l )
		INDEX@ UNCOERCE UNROT	( --> lib %port #c #l )
	    ;
	LOOP
	DROP #0=case SETNOLIBERR
    ;
    THIRTEEN				( *tagged* )
    ::
	FALSE
	NULLNAME	Tag>LidP
	::
	    SWAP			( --> f ::ob )
	    EvalSG: TAG> TAG>_G 	( --> ob $ )

	    DEPTH 1LAMBIND
	    palparse NcaseTYPEERR
	    DEPTH 1GETABND #<>case SETTYPEERR
	    CKREAL COERCEDUP
	    EvalSG: TWO THIRTYTHREE
	    #>case SETPORTNOTAV

	    ROT ?SEMI

	    SWAP CKREAL COERCESWAP
	;
	::  DUP#0= ?SEMI
	    DUP PORTSTATUS		( --> #lid #p r.f w.f sR.f #s #a )
	    4ROLL 3DROP NOTAND ?SEMI	( --> #lid #p r&!sR.f )
	    SETPORTNOTAV		( *Port merged or absent* )
	;

	x@ case SWAPDROP
	SETNOLIBERR
    ;
;

** xPGLIB *******************************************************************
* Interface :	( % | tag --> )
* Description : Purge a library
* Uses :	RomID
* Defines :	PgLidP
* Calls :	PgLidP Tag>LidP
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	PGLIB
::
    CK1&Dispatch
    real
    ::
	COERCE				( --> #lid )

	EvalSG: THREE THIRTYFOUR
	ZERO_DO (DO)
	    INDEX@ x@ IT
	    ::	INDEX@ SWAP		( --> #lid #port lib )
		ExitAtLOOP
	    ;
	LOOP

	DUPTYPEBINT? case SETNOLIBERR

	NULLNAME	PgLidP
	::
	    3PICK [#] RomID
	    #=ITE			( *selfpurging* )
		0LASTOWDOB!
	    ::	REFERENCED? NOT?SEMI
		SETOBINUSE		( *Somebody use it* )
	    ;

	    ::	OVER DUP#0= caseDROP
		PORTSTATUS
		2DROP NOTAND AND ?SEMI
		SETPORTNOTAV		( *Port merged, absent or r/o* )
	    ;

	    DROPOVER OFFSRRP

	    OVER UNCOERCE SWAP		( --> #lid %lid #p )
	    #>$ >TAG			( --> #lid :p:% )

	    ' :: XEQXPURGE TOSRRP ;     ( *Remember selfpurging :*)
	    TOTEMPOB RDROPCOLA EVAL
	;
    ;
    THIRTEEN				( *tagged* )
    ::	FALSE Tag>LidP			( --> #lid #port )
	2DUP x@ NOTcase SETNOLIBERR	( --> #lid #p #lid lib )
	SWAPDROP			( --> #lid #p lib )
	PgLidP
    ;
;

** xSTLIB *******************************************************************
* Interface :	( lib %port --> )
* Description : Stores lib into %port, add it to ROMPART table and execute
*		its config code - if user flag #5 is clear, the cfg code isn't
*		executed; instead a TOSRRP is done.
*		The new lib superseeds any other lib with the same LID in the
*		system.
* Detail :	1. Fetch LID, store lib it into given port (checks for double
*		   install automatically), get addr
*		2. (CODE) Get ->lid, LID, ->ROMPTAB. If ROMPTAB is full,
*		   error out.
*		3. Search position in ROMPTAB to add LID, ->lid.
*		4. Create hole in ROMPTAB (error exit if no room), adjust
*		   display pointer in RAM and 1LT8.
*		5. insert lib into ROMPTAB (ENDCODE)
*		6. Execute libs config code in HOME context
*		On a G we'll have more fun, the ROMPTAB is extended, and we
*		have to take care of ACCPRTs...
* Uses :	=ROMPTAB =sGarbage 5
* Defines :	GpLp
* Calls :	PopASP Trav+ MemErr =MOVERSU DoGarb =ADJDISPUP =disprange
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	STLIB
::
    CK2&Dispatch
    libreal
    ::
	OVER				( --> lib %p lib )

    CODE
* CPU			A	B	C	D	D0
	GOSUB	PopASP	->lib
	D0=A						->lib
	B=A	A		->lib
	D0=D0+	10					->title
	GOSUB	Trav+	*		*		->lid		CC
	A=0	A
	A=DAT0	X	LID
	R0=A		** for PUSH#
	AD0EX		->lid
	A=A-B	A	#offs
	R4=A		** for PshALp
	GOSUB	GetPtr
	GOSBVL	=PUSH#
	GOSUBL	SavPtr
	A=R4
	GOLONG	PshALp
    ENDCODE
					( --> lib %p #lid #loff )
	4UNROLL 			( --> #loff lib %p #lid )

	UNROTDUP UNROT			( --> #loff #lid %p lib %p )
	STOLB				( *LBSTO* )
	COERCE				( --> #loff #lid #port )
	x@ NOTcase SETNOLIBERR		( --> #loff #lid lib )
			( * ^ Should be impossible...* )
	ROT				( --> #lid lib #loff )

	EvalSG:

    CODE
* CPU			A	B	C	D	D0	D1	x
	GOSUBL	Pop#	loff
	R4=A								4:lof

	GOSUB	PopASP	->lib
	C=R4
	C=C+A	A			->lid
	D0=C						->lid
	R4=C								4:->lid

	A=DAT0	3	lid

	D0=(5)	=ROMPTAB				->ROMPTAB
	C=DAT0	3			cnt
	B=C	X		cnt
	C=C+1	X
	GONC	FndPos
	GOLONG	MemErr

FndPos	D0=D0+	3					->1st
	GONC	FndEntr     ** BET

FndLoop C=DAT0	3			lid
	?C>=A	X
	GOYES	FndIt

	D0=D0+	8					->nxt
FndEntr B=B-1	X		--cnt
	GONC	FndLoop

FndIt	AD0EX		->dst
	R3=A								3:->dst
	ST=0	=sGarbage   *** Garbage not collected

MkHole	LC(5)	8			need:8 nibs
	GOSBVL	=MOVERSU *	->dst	*	*	*	*
	GONC	GotHole

	GOSUB	DoGarb	*	*	*	*	*	*	CC
	A=R3		->dst
	GONC	MkHole	    ** BET

GotHole LC(5)	8	*		adj:8 nibs		*	CC
	GOSBVL	=ADJDISPUP A:*				*
	GOSBVL	=disprange DREND *	DRSTART *	*	*	CC

	A=R3		->dst
	D0=A						->dst
	C=R4		->lid
	D1=C							->lid
	A=DAT1	3	LID
	DAT0=A	3	    ** Write LID
	D0=D0+	3					->addr
	DAT0=C	A	    ** Write addr

	D0=(5)	=ROMPTAB				->ROMPTAB
	C=DAT0	3			cnt
	C=C+1	X			cnt+1
	DAT0=C	3	    ** Write new cnt

GpLp	GOVLNG	=GETPTRLOOP

    ENDCODE
					( --> #lid lib #loff )
    CODE
* CPU			A	B	C	D	D0	D1	xx
	GOSUBL	Pop#	#loff
	R3=A								3:lof
	GOSUB	PopASP	->lib
	R4=A								4:acc
	GOSUBL	Pop#	#lid
	R2=A								2:lid

	A=R4		->lib
	D1=A							->lib

	A=DAT1	A	->ob
	LC(5)	=DOACPTR		ACPTR
	?A#C	A
	GOYES	NPtr

	D1=D1+	5						->addr
	C=DAT1	A			adr
	D1=D1+	5						->mth
	A=DAT1	A	mth
	GONC	APtr	** BET

NPtr	CD1EX				adr
	A=0	A	mth

APtr	R1=A								1:mth
	A=R3		loffs
	A=A+C	A	->lib
	R0=A								0:adr

	D0=(5)	=ROMPTAB_G				->ROMPTAB
	C=DAT0	3			cnt
	B=C	X		cnt
	C=C+1	X
	GONC	gFndPos
	GOLONG	MemErr

gFndPos A=R2		lid
	D0=D0+	3					->1st
	GONC	gFndEntr    ** BET

gFndLoop
	C=DAT0	3			lid
	?C>=A	X
	GOYES	gFndIt

	D0=D0+	16					->nxt
gFndEntr
	B=B-1	X		--cnt
	GONC	gFndLoop

gFndIt	AD0EX		->dst
	R3=A								3:dst

	ST=0	=sGarbage   *** Garbage not collected

gMkHole LC(5)	16			need:16 nibs
	GOSBVL	=MOVERSU *	->dst	*	*	*	*
	GONC	gGotHole

	GOSUB	DoGarb	*	*	*	*	*	*	CC
	A=R3		->dst
	GONC	gMkHole     ** BET

gGotHole
	LC(5)	16	*		adj:16 nibs		*	CC
	GOSBVL	=ADJDISPUP_G A:*				*
	GOSBVL	=disprange DREND *	DRSTART *	*	*	CC

	D0=(5)	=RSKTOP_G				->->rstk
	A=DAT0	A	->rstk
	B=A	A		tail
	A=R3		head
	LC(5)	16			offs
	GOSUB	ClrCry	    ** rev R fix
	GOSBVL	=UPDATESRRu ** adjust SRRP pointers

	A=R3		->dst
	D0=A						->dst

	C=R2				LID
	DAT0=C	3	    ** Write LID
	D0=D0+	3					->addr
	C=R0				->lib
	DAT0=C	A	    ** Write adr
	D0=D0+	5
	C=R1				->mth
	DAT0=C	A	    ** Write mth

	D0=(5)	=ROMPTAB_G				->ROMPTAB
	C=DAT0	3			cnt
	C=C+1	X			cnt+1
	DAT0=C	3	    ** Write new cnt

gplp	GOTO	GpLp
ClrCry	RTNCC		    ** rev R fix
    ENDCODE

	NULLNAME	InstLib
	::
	    DUP OFFSRRP 		( *Remove old ROMPART from SRRP* )
	    fRunCfg TestUserFlag
	    NOTcase TOSRRP

	    GetConfig NOT?SEMI

	    CONTEXT@ 1LAMBIND
	    DUPDUP DUPDUP 4DROP 	( *Force 20 nibs to be free* )
	    SYSCONTEXT			( *HOME* )
	    0LASTOWDOB! 		( *No LASTROMWD for cfg-code* )
	    ERRSET
	    ::	ZEROSWAP		( *0-meta object* )
		ONE
		ZERO_DO (DO)		( *Simulate config LOOP* )
		    EVAL		( *Execute config code* )
		LOOP
		DROP
	    ;
	    ERRTRAP
	    ::	1GETABND CONTEXT!
		AtUserStack
		ERRJMP
	    ;

	    1GETABND CONTEXT!

	    BlankDA1
	    "Config Code Passed" DISPROW1
	    SetDA1Temp
	;
    ;
;

** xACLIB *******************************************************************
* Interface :	( :%port:%LID --> )
* Description : Activate Library, enshure that the given lib is visible to
*		the system. NOTE: Not ported to ROM > J yet !
* Uses :	=ROMPTAB
* Calls :	Tag>LidP InstLib
*		PopASP Trav+ =GPGotoC =SETNOLIBERR GpLp
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	ACLIB
::
    CK1
    EnshureSX
    DUPTYPETAG? NcaseTYPEERR


    FALSE Tag>LidP			( --> #lid #port )
    x@ ?SKIP SETNOLIBERR		( --> #lid lib )

    ' InstLib ROMPTR@ DROPSWAP          ( --> #lid InstLib lib )
	( * ^^^^^^^^^^^ just in case I want to switch between <-LIB->s*)

    CODE
* CPU			A	B	C	D	D0	D1	x
	GOSUB	PopASP	->lib
	D0=A						->lib
	D0=D0+	10					->title
	GOSUB	Trav+	*		*		->lid		CC

	C=DAT0	3			LID
	D=C	X				LID
	AD0EX		->lid

	D0=(5)	=ROMPTAB				->ROMPTAB
	C=DAT0	3			cnt
	B=C	X		cnt

	D0=D0+	6					->1st addr
	GONC	F1Entr	    ** BET

F1Loop	C=DAT0	A			addr
	?C=A	A
	GOYES	FndAddr

	D0=D0+	8					->nxt
F1Entr	B=B-1	X		--cnt
	GONC	F1Loop

	LC(5)	=SETNOLIBERR
	GOVLNG	=GPGotoC

FndAddr CD0EX				->addr
	D0=C						->src
	D1=C							->addr
	D1=D1-	3						->LID
	C=D	X			LID

F2Loop	D1=D1-	8						->prev LID
	A=DAT1	3	LID'
	?C=A	X
	GOYES	F2Loop

	D1=D1+	11						->1.addr

	C=DAT0	A			act.addr.
	A=DAT1	A	1st.addr.
	DAT0=A	A
	DAT1=C	A

gpLp	GOTO	GpLp
    ENDCODE

    EVAL
;

** xLIBp ********************************************************************
* Interface :	( % --> $ )
* Description : Get library layout
* Calls :	ChkLid
*		=PopASavptr PHxsLp
*****************************************************************************

DEFINE	Lplams	FOUR			( *Below done by 4NULLLAM{} !!!* )

DEFINE	@lid	4GETLAM
DEFINE	@base	3GETLAM
DEFINE	Adr>$	2GETEVAL
DEFINE	@lines	1GETLAM
DEFINE	!lines	1PUTLAM
DEFINE	++lin	@lines #1+ !lines

ASSEMBLE
	CON(1)	8
RPL
xNAME	LIBp
::
    CK1
    CKREAL ChkLid			( --> #lid )

    DUP
    EvalSG: ROMPARTADDR ROMPARTADDR_G DROP
    EvalSG: NOP
    CODE
	GOTO	aDr>$
    ENDCODE

    TEN #-				( --> #lid #base )

    '
    ::	'
	::  #>HXS hxs>$ THREE LAST$
	    "0000" OVERLEN$ LAST$ SWAP&$
	;

	SWAPDUP
	NULLNAME	?AccPtr>
	::
	    EvalSG: NOP ?ACCPTR>
	;

	OSIZE SWAP			( --> :: #s ob )

    CODE
* CPU			A	C	D1
aDr>$	GOSUBL	PopASP

	D1=A				->->ob

	A=DAT1	A	->ob
	LC(5)	=DOACPTR	ACPTR
	?A#C	A
	GOYES	nPtr

	D1=D1+	5			->addr
	A=DAT1	A	adr
	GONC	aPtr	** BET

nPtr	AD1EX		adr

aPtr	GOLONG	PshALp

    ENDCODE				( --> :: #s #a )

	@base #-DUP			( --> :: #s #o #o )
	4PICK EVAL			( --> :: #s #o $ )
	APPEND_SPACE
	UNROT #+-1			( --> :: $ #l )
	ROT EVAL
	APPEND_SPACE
	&$ ++lin
    ;

    ZERO				( --> lid base Adr>$ lines )
    4NULLLAM{} BIND

    BlankDA2

    @lid GetTitle
    ITE
    ::	ID>$ DUP DISPROW4 NEWLINE$&$	( --> $title\n )
    ;
	NULL$				( --> $ )

    @base DUP				( --> $ #b #b )

    #>HXS hxs>$ THREE LAST$ APPEND_SPACE ( --> $ #b $'xxxxx ' )
    SWAP @lid
    EvalSG: ROMPARTSIZE ROMPARTSIZE_G
    DROP #10+ #+-1			( --> $ $ #last )
    #>HXS hxs>$ THREE LAST$ &$
    " LID " &$ @lid #>$ &$
    DUP DISPROW5
    &$ NEWLINE$&$ NEWLINE$&$		( --> $'title\nstart stop lid no\n\n )

    @lid EvalSG: GETHASH GETHASH_G
    IT
    ::	Adr>$ "Hash table\n" &$
    ;

    @lid EvalSG: GETMESG GETMESG_G
    IT
    ::	Adr>$ "Message table\n" &$
    ;

    @lid EvalSG: GETCONFIG GETCONFIG_G
    IT
    ::	DUP Adr>$ "Config  " &$SWAP
	?AccPtr> GET_THE_TYPE NEWLINE$&$
    ;

    @lid EvalSG: GETLINK GETLINK_G
    IT
    ::	DUP Adr>$ "Link table\n" &$SWAP
	?AccPtr> LENHXS FIVE #/ SWAPDROP

	ZERO_DO (DO)
	    ?ATTNQUIT
	    ::	@lid INDEX@ #>ROMPTR
		DUP
		EvalSG:
		    ROMPTR@
		::  ERRSET
		    ::	RP@NoCopy
			TRUE
		    ;
		    ERRTRAP
			FALSE
		;
		NOTcaseDROP
		DUP Adr>$
		INDEX@ #>$
		"  " OVERLEN$ LAST$ SWAP&$
		&$ APPEND_SPACE
		ROT
		EvalSG: ROMPTRDECOMP G_ROMPTRDECOMP
		IT
		::  ID>$ &$ APPEND_SPACE
		;
		APPEND_SPACE SWAP ?AccPtr> GET_THE_TYPE NEWLINE$&$
		DUP DISPROW6
	    ;
	LOOP
    ;

    @lines #0=?SKIP
    ::	@lines #1=?SKIP
	::  "Sorting\1F" DISPROW6
	    @lines
	    #1+_ONE_DO (DO)
		?ATTNQUIT
		@lines ROLL
		ZERO INDEX@
		BEGIN
		    2DUP SWAP#- #2/
		DUP#0<>
		WHILE
		    OVERSWAP #-DUP #4+PICK 5PICK
		    STR<STR COERCE
		    #0=ITE
			ROTDROPSWAP
			SWAPDROP
		REPEAT
		DROPSWAPDROP UNROLL
	    LOOP
	;

	@lines
	ZERO_DO (DO)
	    !append$
	LOOP
    ;

    ABND
;

** xINSTp *******************************************************************
* Interface :	( --> {} )
* Description : Create a list of %, representing all LIDs installed on the
*		current directory
* Defines :	{#}>{%}
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	INSTp
::
    CK0
    CONTEXT@
    EvalSG: ROMPART ROMPART_G
    NOTcase NULL{}
    DUPTYPELIST? ?SKIP ONE{}N

    NULLNAME	{#}>{%}
    ::
	INNERDUP
	ZERO_DO (DO)
	    DUP #1+ROLL UNCOERCE SWAP
	LOOP
	{}N
    ;
;

** xLIBSp *******************************************************************
* Interface :	( --> {} )
* Description : Create a list of %, containing all LIDs installed on the
*		ROMPART table
* Calls :	{#}>{%}
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	LIBSp
::
    CK0
    EvalSG: CATROMPID CATROMPID_G
    {#}>{%}
;

*** xfEVAL ******************************************************************
* Interface :	( ob --> ? )
* Description : Fast eval, execute <ob> with display off. Add. speed ~11%
* Defines :	DoffEval
* Calls :	SavPtr gpLp =DisableIntr =OffNoBlush =AllowIntr =DispOn
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	fEVAL
::
    CK1
    '
    ::	'EvalNoCK: xEVAL
    ;
    NULLNAME	DoffEval
    ::
    CODE
	GOSUBL	SavPtr
	GOSBVL	=DisableIntr
	GOSBVL	=OffNoBlush
	GOSBVL	=AllowIntr
Gplp	GOTO	gpLp
    ENDCODE

	ERRSET
	    EVAL
	ERRTRAP
	::
    CODE
	GOTO	DOn
    ENDCODE
	    ERRJMP
	;

    CODE
DOn	GOSUBL	SavPtr
	GOSBVL	=DispOn
	GOTO	gpLp
    ENDCODE
    ;
;

*** xsto ********************************************************************
* Interface :	( lib/bak %port --> )
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	sto
::
    CK2&Dispatch
    THIRTEEN				( *ob tagged* )
    ::	DUP TRUE Tag>LidP SWAP		( --> ob tag #p ob' )

	DUPTYPEREAL?
	casedrop
	::  SWAPDROP UNCOERCE		( --> ob %p )
	    ' xsto ROMPTR@ DROP
	    COLA EvalNoCK
	;

	DUPTYPEIDNT? OVER TYPELAM?
	ORcase				( --> ob tag #p ob' )
	::  ROTDROP ROT 		( --> #p id ob )
	    OB>BAK SWAP
	    UNCOERCE STOLB
	;

	SETTYPEERR
    ;
    # 009f1				( *backup real* )
	STOLB
    # 008f1				( *library real* )
	STOLB
    any
	xSTO
;

NULLNAME	STOLB
::
    EvalSG:
    ::  RDROP
	'EvalNoCK: xSTO
    ;

    CODE
* CPU			A	C	D0
	AD0EX		->rs
	D0=(5)	=UPDATESRRu		->
	C=DAT0	A		*udsu
	D0=A				->rs
	LA(5)	#AF6F7
	?A#C	A
	GOYES	isGXR
isGXR	GOVLNG	=PushT/FLoop
    ENDCODE

    case				( *We've a rev >= R, so call* )
	LBSTO				( *build-in LBSTO           * )

    COERCESWAP				( --> # ob )

    CKREF

    SWAPDUP THIRTYTHREE #>case SETPORTNOTAV

    OVER
    ::	NOTBAKcase LIB>#_G
	BAKNAME
    ;

    DROPSWAP				( lib/bak id/#' # )
    ZERO #=casedrop XSTOp0_G

    '
    ::					( backup_ob id port_number	 --> )
					( library library_id port_number --> )
					( ob id port_number		 --> )
	ROT ?>ROMPTR UNROT OVER dvarlsBIND
	DUP4UNROLL			( # ob id # )

	::  PORTSTATUS	( ob id readable writeable systemRAM size start.acc )
	    FIVEUNROLL FIVEUNROLL
	    NOTAND ANDNOTcase SETPORTNOTAV
					( ob id size start.acc )
	    ROTOVER			( ob size start.acc id start.acc )
	;

	BEGIN
	    DUP NEXTLIBBAK
( ob size start.acc id acc lib/bak/acc acc' TRUE / ob size start.acc id acc FALSE  )
	WHILE
	    ROTDROP
	    UNROT		( ob size start.acc acc' id lib/bak/acc  )
	    XNAMEMATCH_G	( ob size start.acc acc' id lib/bak/acc flag )
	    case SETOBINUSE
	    DROPSWAP		( ob size.acc start.acc id acc' )
	REPEAT			( ob size start id end.acc )

	XSTOpMore

	#5+				( end.acc room# ob obsize# )

	SWAP				( end.acc room# obsize# ob  )
	::  NOTBAKcase
	    ::	NOTLIBcase
		::  SWAP 1GETLAM OSIZE
		    ::	SEVEN #=casedrop SETTYPEERR
		    ;
		    #+ SEVENTEEN #+
		;
		SWAP
	    ;
	    SWAP
	;

	ROTOVER #<case SETNOROOM	( end.acc ob obsize# )
	ROTSWAP 			( # ob end obsize )
	4ROLL				( ob end.acc obsize# # )
	1GETABND FIVEUNROLL		( id ob end.acc obsize# # )

    CODE				( id ob location obsize port# --> )

	GOSBVL	=POP2#
	R4=C.F	A
	R3=A.F	A
	GOSBVL	=POPACCPTR
	C=R0.F	A
	R2=C.F	A
	D1=D1+	10
	D=D+1	A
	D=D+1	A
	GOSBVL	=SAVPTR
	D1=D1-	10
	C=DAT1	A
	D0=C
	D1=A
	A=DAT0	A
	LC(5)	=DOLIB
	?A=C	A
	GOYES	xstolb

	LC(5)	=DOBAK
	?A=C	A
	GOYES	xstolb

	GOVLNG	=XSTONLB

xstolb
	C=R3.F	A
	C=C-CON A,5
	GOSBVL	=MOVEDOWNcov
*v*
	CD1EX			save ->
	RSTK=C

	C=R2.F	A		mth
	?C=0	A
	GOYES	nouncov 	don't uncover

	P=	0
	GOSUB	pcisC		uncover area

nouncov
	C=RSTK
	D1=C
*^*

	C=0	A
	DAT1=C	A		write zero mark
	C=R2.F	A
	?C=0	A
	GOYES	WREOS0
	P=	1
	GOSUB	pcisC
WREOS0
	A=R4.F	A
	C=A	A
	A=A+A	A
	A=A+A	A
	A=A+C	A
	LC(5)	=PORT0EOS_G
	C=C+A	A
	CD1EX
WREOS
	DAT1=C	A
	GOVLNG	=GETPTRLOOP

pcisC
	RSTK=C
	RTN

    ENDCODE

    ;

    TOTEMPOB GARBAGE COLA_EVAL
;

*** xpinit ******************************************************************
* Interface :	( --> )
* Description : Initialize each of the possible ports (1-33) by storing and
*		purging a small object, to avoid "Invalid Card Data" error
*		message.
*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	pinit
::
    CK0
    EvalSG: TWO THIRTYTHREE

    ONE_DO (DO)
	?ATTNQUIT
	ID 't DUPZERO           ( --> ID't id #0 )
	OB>BAK			( --> id bak )

	INDEX@ #>$		( --> id bak $port )
	ROTSWAP >TAG SWAP	( --> :port:'t bak )
	INDEX@ UNCOERCE 	( --> :port:'t bak %p )

	ERRSET
	::
	    STOLB		( --> :p:id )
	    XEQXPURGE		( --> )
	;
	ERRTRAP
	    DropSysObs
    LOOP
;

*******************************************************************************
**			     End of LIB.S
*******************************************************************************



*******************************************************************************
**			     Start of BZ.S
*******************************************************************************

* Patterns:
* 1[MBITS][OBITS]	Match
* 0[NBITS]		Literals
* Notes:
* - The bit count for offset is
*   determined by the max possible
*   offset, limited by traversed
*   size.
* - The 1-bit id for matches is
*   unnecessary after a literal
*
ASSEMBLE

sMNEXT	EQU 9	Match expected?
sGARB	EQU 10

NBITS	EQU 4	Literal length
NMASK	EQU 2^(NBITS)-1
NBITS2	EQU 6
NMASK2	EQU 2^(NBITS2)-1
MBITS	EQU 5	Match length
MMASK	EQU 2^(MBITS)-1
MBITS2	EQU 7
MMASK2	EQU 2^(MBITS2)-1

=OffNoBlush	EQU #01D44
=ABORT		EQU #04EA4
=WIPEOUT	EQU #0675C
=GETPTREVALC	EQU #15C77
=aATTNFLG	EQU #4226C

* RPL

* ASSEMBLE
	CON(1)	8
RPL
xNAME	BZ
::
 GARBAGE
 CK1NOLASTWD
 DUPTYPECSTR? ITE
 :: DUP #1 #2 SUB$ "BZ" EQUAL ;
 FALSE
 case
 CODE
*	TITLE	JAZZ Uncompressor

	STITLE	Preparation
	ST=0	sGARB
reungz	GOSBVL	=SAVPTR
	A=DAT1	A
	D1=A
	D1=D1+	10
	A=DAT1	4
	D1=D1+	4
	LCSTR	'BZ'
	P=	3
	?C=A	WP
	GOYES	upkok
	P=	0
	LC(5)	=SETTYPEERR
	GOVLNG	=GETPTREVALC
upkok	P=	0
	C=DAT1	A
	RSTK=C
	GOSBVL	=CREATETEMP
	GONC	ugzmemok
	?ST=1	sGARB
	GOYES	ugzmerr
	GOSUB	PassGC
	CON(5)	=DOCOL
	CON(5)	=GARBAGE
	CON(5)	=COLA
	CON(5)	=DOCODE
	REL(5)	UGZEND
	ST=1	sGARB
	GOTO	reungz
PassGC	C=RSTK
	GOVLNG	=GETPTREVALC
ugzmerr	GOVLNG	=GPMEMERR
ugzmemok
	C=RSTK
	AD0EX
	R0=A	A
	C=C+A	A
	R1=C	A	->obend
	GOSBVL	=D1=DSKTOP
	C=DAT1	A
	D0=C
	D0=D0+	5+5
	D0=D0+	4+5
	C=DAT0	A
	AD0EX
	D0=A
	D0=D0+	5	->pats
	C=C+A	A
	R2=C.F	A	->lits
	
	A=R0	A
	DAT1=A	A	->stk1
	R3=A.F	A	->ob
	D1=A

	STITLE	Uncompress Loop

	ST=0	sMNEXT
	A=0	S
	R3=A.F	S	bits
UPKLOOP	GOSUB	Decod
	?D#0	A
	GOYES	upkpat
* Safety:
*	AD1EX
*	C=R1.F	A
*	C=C-A	A
*	AD1EX
*	?A<=C	A
*	GOYES	blaa
*	A=C	A	
*blaa
	CD0EX
	CR2EX.F	A
	CD0EX
	C=A	A
	GOSBVL	=MOVEDOWN
	CD0EX
	CR2EX.F	A
	CD0EX
upkcont	AD1EX
	D1=A
	C=R1.F	A
	?A<C	A
	GOYES	UPKLOOP
	GOVLNG	=GETPTRLOOP

upkpat
* Safety:
*	AD1EX
*	C=R1.F	A
*	C=C-A	A
*	AD1EX
*	?D<=C	A
*	GOYES	buh
*	D=C	A
*buh
	CD1EX
	D1=C
	C=C-A	A	->src
	CD0EX
	CDEX	A
	A=0	P
	?A=0	A
	GOYES	upslow
	GOSBVL	=MOVEDOWN
uppcnt	C=D	A
	D0=C
	GOTO	upkcont
upslow	C=C-1	A
upkplp	A=DAT0	B
	DAT1=A	1
	D0=D0+	1
	D1=D1+	1
	C=C-1	A
	GONC	upkplp
	GOC	uppcnt

UGZEND
ENDCODE

*  ZERO FOURTEEN BLANKIT
*  ABUFF #42 #7
*  "BZ V1.2 (400)" MINUSONE
*  CENTER$3x5 DROP  

  DUP OSIZE SWAP
  SysTime 1LAMBIND
  GARBAGE
  SysTime 1PUTLAM

CODE
*	TITLE JAZZ Compressor

*	Effect of HSHSIZE:	(sample file was an earlier BZ.S )
*
*	HSHSIZE	Time	MemNeed:
*	#1000	14.54	26624
*	 #800	15.77	16384
*	 #400	17.56	11264 !!
*	 #200	21.26	 8704
*	 #100	28.59	 7424
*	  #80	42.78	 6784
*	  #40	69.97	 6464

HSHSIZE	EQU #400	See source before changing!
WINSIZE	EQU #1000

RINGMEM	EQU 3*(WINSIZE)
HASHMEM	EQU 10*(HSHSIZE)
ALLMEM	EQU (RINGMEM)+(HASHMEM)
MINMEM	EQU 200+(ALLMEM)
MINADD	EQU 100+(ALLMEM)

MINMAT	EQU 6	Minimum match lenght

	STITLE	Startup
*********************************
* For speed following registers
* have priority over anything else
* R0[A]	->out
* R2[A] ->buffer
* R3[A] ->ob
* Assiging other improtant variables
* to [A] fields we get:
* R0	->out	->$start
* R1	free
* R2	->buffer
* R3	->ob		bits
* R4	->obend	->obsave
* D0	->obptr
* bits determines how many bits
* are valid in current ->out
* eg 0 <= bits <= 2
*********************************

	GOSBVL	=SAVPTR
*	GOSBVL	=GARBAGECOL
	CLRST
*	ST=0	sMNEXT
	A=0	W
	R0=A
	R1=A
	R2=A
	R3=A		R3[S]=0!
	R4=A

	GOSBVL	=D1=DSKTOP
	A=DAT1	A
	R3=A.F	A	->ob	(temporary)
	D0=A
	GOSBVL	=SKIPOB
	AD0EX
	R4=A.F	A	->obend
	C=R3.F	A	->ob
	A=A-C	A	obsize
	GOC	argerr
	LC(5)	10
	?A>=C	A
	GOYES	argok
argerr	
  LC(5)	=SETTYPEERR
gpevalc	
  GOVLNG	=GETPTREVALC

memerr	
  GOSBVL	=DispOn
	GOVLNG	=GPMEMERR

argok	GOSBVL	=ROOM
	A=C	A
	LC(5)	MINMEM
	A=A-C	A
	GOC	memerr
	LC(5)	MINADD
	C=C+A	A
	R1=C.F	A	free
	GOSBVL	=MAKE$N
	A=R0.F	A
	GOSBVL	=ASLW5
	AD0EX
	R0=A
	D1=A		->out
	C=R1.F	A	free
	GOSBVL	=WIPEOUT
	AD1EX
	LC(5)	HASHMEM
	A=A-C	A
	R2=A.F	A	          ->buffer
	A=R1.F	A	          free
	LC(5)	ALLMEM	      THIS WAS BUGGED! (only HASHMEM substracted)
	A=A-C	A
	A=A-CON	A,16	      buffering safety!
	R1=A.F	A
	GOSBVL	=DisableIntr
*	GOSBVL	=OffNoBlush
	GOSBVL	=AllowIntr	
	GOTO	packnow

*********************************
* R0	->out	->$start
* R1	free	(adjusted for buffer)
* R2	->buffer
* R3	->ob		bits
* R4	->obend	(->obsave)
*********************************
packnow	
  C=R1.F	A
	C=C-CON	A,4+5+5	"BZ" and oblen
	R1=C.F	A
*	GOC	memerr	Never
	C=R0.F	A
	D0=C
	LCSTR	'BZ'
	DAT0=C	4
	D0=D0+	4
	A=R4.F	A	->obend
	C=R3.F	A	->ob
	A=A-C	A	obsize
	DAT0=A	A
	D0=D0+	10
	CD0EX		D0 = ->ob
	R0=C.F	A	->out

	STITLE	Compressor Loop
*********************************
* R0	->out	->$start
* R1	free
* R2	->buffer
* R3	->ob		bits
* R4	->obend	(->obsave)
*********************************

PackLoop
	GOSUB	PackInfo
	GOSUB	PackAbort?
* Save start address of scan
	AD0EX
	D0=A
	GOSBVL	=ASLW5
	A=R4.F	A
	R4=A
	GOSUB	FindMax
	C=R4
	GOSBVL	=CSRW5	->obsave
	AD0EX		->match
	D0=A
	A=A-C	A	skipped nibbles
	GOSUB	Encod
* Pattern is out, update history
	?D=0	A
	GOYES	packcont
	D0=D0+	1	1st one is in already
	D=D-1	A	1st not included
	D=D-1	A	GONC test
patadd	GOSUB	RemoveOld
	GOSUB	AddNew
	D0=D0+	1
	D=D-1	A
	GONC	patadd
* Prepare next loop
packcont
	AD0EX
	D0=A
	C=R4.F	A	->obend
	?A>=C	A
	GOYES	PackNibs
	GOTO	PackLoop

*********************************
* Append literal nibbles
* according to packed directives
*********************************
PackNibs
	C=R0
	A=R3.F	S
	?A=0	S
	GOYES	outok!
	C=C+1	A
	R0=C
outok!	GOSBVL	=CSRW5
	D0=C
	D0=D0+	5+5
	D0=D0+	4+5
	C=R0.F	A	->out
	AD0EX
	D0=A
	C=C-A	A	off to lit
	DAT0=C	A
	D0=D0+	5	->pats
	
	C=R3.F	A	->ob
	D1=C
	A=R1.F	A	free++
	LC(5)	ALLMEM
	A=A+C	A
	R1=A.F	A
	ST=0	sMNEXT
	A=0	S
	R3=A.F	S	bits
NibsLoop
	GOSUB	Decod
	?D#0	A
	GOYES	apppat
	CR1EX.F	A
	C=C-A	A
	CR1EX.F	A
	GOC	apperr
	C=R0.F	A
	CD1EX
	CD0EX
	R0=C.F	A
	C=A	A
	GOSBVL	=MOVEDOWN
	C=R0.F	A
	CD0EX
	CD1EX
	R0=C.F	A
	GONC	appcont
apperr	GOTO	memerr
apppat	CD1EX
	C=C+D	A
	CD1EX

appcont	C=R4.F	A	->obend
	AD1EX
	D1=A
	?A<C	A
	GOYES	NibsLoop
* Exit compressor
PackDone
	GOSBVL	=DispOn
	C=R0
	D0=C
	GOSBVL	=CSRW5
	R0=C
	GOSBVL	=Shrink$
	GOVLNG	=GPOverWrR0Lp

	STITLE	Match Encoder
*********************************
* Output match
*	D[A]  = length
*	D[A1] = match loc
*	D0    = ->match
*	R0[A] = ->out
*	R3[A] = ->ob
*	R3[S] = bits
*	R1[A] = free
*	A[A]  = skipped
*********************************
Encod	?A#0	A
	GOYES	outlit
	GOTO	outmat?

outlit	ST=1	sMNEXT
	LC(5)	NMASK
	?A>C	A
	GOYES	outlit2
	A=A+A	A
	P=	(NBITS)+1
	GOSUB	OutBits
	GOTO	outmat?
outlit2	A=A-C	A
	B=A	A
	A=0	A
	P=	(NBITS)+1
	GOSUB	OutBits
	LC(5)	NMASK2
	?B>C	A
	GOYES	outlit5
	A=B	A
	P=	NBITS2
	GOSUB	OutBits
	GOTO	outmat?
outlit5	A=0	A
	P=	NBITS2
	GOSUB	OutBits
	A=B	A
	GOSUB	OutA[A]
********
outmat?	?D=0	A
	RTNYES
	D=D-CON	A,(MINMAT)-1
	LC(5)	MMASK
	?D>C	A
	GOYES	outmat2
	C=D	A
	A=C	A
	P=	MBITS
	?ST=1	sMNEXT
	GOYES	otm1
	A=A+A	A
	A=A+1	A
	P=	(MBITS)+1
otm1	GOSUB	OutBits
	GOTO	outoff
outmat2	D=D-C	A
	A=0	A
	P=	MBITS
	?ST=1	sMNEXT
	GOYES	otm3
	A=A+1	A
	P=	(MBITS)+1
otm3	GOSUB	OutBits
	LC(5)	MMASK2
	?D>C	A
	GOYES	outmat5
	C=D	A
	A=C	A
	P=	MBITS2
	GOSUB	OutBits
	GOTO	outfxm
outmat5	A=0	A
	P=	MBITS2
	GOSUB	OutBits
	C=D	A
	A=C	A
	GOSUB	OutA[A]
outfxm	LC(5)	MMASK
	D=D+C	A

outoff	D=D+CON	A,(MINMAT)-1
	ST=0	sMNEXT
	C=D	W
	GOSBVL	=CSRW5	->matchloc
	AD0EX
	D0=A
	A=A-C	A	offset

	C=R3.F	A	->ob
	AD0EX
	C=A-C	A	maxoff
	AD0EX
	B=C	A	maxoff
	LC(5)	#7FF
	P=	12
otoflp	?B>C	A
	GOYES	OutBits
	CSRB.F	A
	P=P-1
	GONC	otoflp	BET

*********************************
OutA[A]	B=A	A
	P=	8
	GOSUB	OutBits
	A=B	A
	ASR	A
	ASR	A
	P=	12
*********************************
OutBits	A=R3.F	S
	C=P	15
	C=C+A	S
	A=C	S
	C=0	A
	P=	3
	CPEX	15
	CPEX	0
	A=A&C	S
	AR3EX.F	S
	P=	0
	CSRB.F	P
	CSRB.F	P
	AR1EX.F	A
	A=A-C	A
	AR1EX.F	A
	GOC	outerr
	AR0EX.F	A
	D1=A
	A=A+C	A
	AR0EX.F	A
	A=A-1	S
	GOC	noshf
shflp	A=A+A	A
	A=A-1	S
	GONC	shflp
noshf	C=0	A
	C=DAT1	P
	C=C!A	A
	DAT1=C	A
	RTN
outerr	GOTO	memerr
*********************************

	STITLE	Match Decoder
*********************************
* Decode directive from stream
* In:	D0	= ->in
*	D1	= ->obptr
*	R3[S]	= bits (used)
*	R3[A]	= ->ob
* Out:	A[A]=nlen D[A]=0
*	A[A]=offs D[A]=mlen
*********************************
Decod	?ST=1	sMNEXT
	GOYES	dcmat
	P=	1
	GOSUB	GetBits
	?ABIT=1	0
	GOYES	dcmat
	ST=1	sMNEXT
	P=	NBITS
	GOSUB	GetBits
	D=0	A
	?A#0	A
	RTNYES
	P=	NBITS2
	GOSUB	GetBits
	?A#0	A
	GOYES	fxlit
	GOSUB	GetA[A]
fxlit	LC(5)	NMASK
	A=A+C	A
	RTN
	
dcmat	ST=0	sMNEXT
	P=	MBITS
	GOSUB	GetBits
	?A#0	A
	GOYES	dcoff
	P=	MBITS2
	GOSUB	GetBits
	?A#0	A
	GOYES	fxmat
	GOSUB	GetA[A]
fxmat	LC(5)	MMASK
	A=A+C	A
dcoff	C=A	A
	D=C	A	mlen
	D=D+CON	A,(MINMAT)-1
	AD1EX
	D1=A
	C=R3.F	A	->ob
	A=A-C	A	maxoff
	LC(5)	#7FF
	P=	12
dcoflp	?A>C	A
	GOYES	GetBits
	CSRB.F	A
	P=P-1
	GONC	dcoflp	BET

*********************************
GetA[A]	P=	12
	GOSUB	GetBits
	B=A	X
	P=	8
	GOSUB	GetBits
	ASL	A
	ASL	A
	ASL	A
	A=B	X
	RTN
*********************************
* Get P bits
*********************************
GetBits	A=DAT0	A
	A=R3.F	S
	A=A-1	S
	GOC	gb0
gbshf	ASRB.F	A
	A=A-1	S
	GONC	gbshf
gb0	C=P	15
	C=C-1	S
	C=0	A
gbmlp	C=C+C	A
	C=C+1	A
	C=C-1	S
	GONC	gbmlp
	A=A&C	A

	A=R3.F	S
	C=P	15
	C=C+A	S
	A=C	S
	C=0	A
	P=	3
	CPEX	15
	CPEX	0
	A=A&C	S
	R3=A.F	S
	P=	0
	CSRB.F	P
	CSRB.F	P
	AD0EX
	A=A+C	A
	AD0EX
	RTN

*********************************

	STITLE	Match Finder
*********************************
* Find next match causing a pack
* In:
*	D0	->pos
*	R2[A]	->buffer
*	R3[A]	->ob
*	R4[A]	->obend
* Out:
*	D0	->newpos
*	D[A]	matchlen
*	D[A1]	matchpos
* Uses:	A[W] B[A] C[W] D[W]
*********************************
FindMax	GOSUB	RemoveOld
	GOSUB	AddNew
	GOC	nxtmat
	GOSUB	ScanThis
	?D#0	A
	GOYES	gotmax?
nxtmat	AD0EX
	A=A+1	A
	D0=A
	C=R4.F	A
	?C>A	A
	GOYES	FindMax
	D=0	W
	RTNSC
gotmax?	LC(5)	MINMAT
	?D<C	A
	GOYES	nxtmat
	AD0EX
	D0=A
	C=R4.F	A
	C=C-A	A
	?D<=C	A
	RTNYES
	D=C	A
	LC(5)	MINMAT
	?D<C	A
	GOYES	nxtmat
	RTN

	STITLE	Ring Buffer Match Finder
*********************************
* Scan buffer for the longest
* match for D0. Note that no
* obend test is needed
* In:
*	D0	->pos
*	B[A]	->FLlink
*	R2[A]	->buffer
*	R3[A]	->ob
* Out:	D[A,A1]	match
* Uses:	A[W] B[A] C[W] D[W]
*********************************
ScanThis
	D=0	W
	C=B	A
	D1=C		->FLlink
	A=DAT1	A
scanloop
	D1=A
	GOSUB	Count
	?D>C	A
	GOYES	nextmat
*	?C=0	A
*	GOYES	nextmat
	CD1EX
	D=C	A
	CD1EX
	P=	9
	DSL	WP
	DSL	WP
	DSL	WP
	DSL	WP
	DSL	WP
	P=	0
	D=C	A
* Get next loc from buffer
nextmat	AD1EX
	B=0	A
	B=A	X
	C=R2.F	A
	C=C-B	A
	C=C-B	A
	C=C-B	A	->slot
	D1=C
	D1=D1-	3	Nonzero!
	C=A	A
	A=DAT1	X
	?C<A	A
	GOYES	scaok
	LC(5)	WINSIZE
	A=A+C	A
scaok	CD0EX
	D0=C
	?C>A	A
	GOYES	scanloop
	RTN

	STITLE	Match Length Counter
*********************************
* Compare nibbles
* In:	D0 D1
* Out:	C[A] = match length
* Uses:	A[W] B[A] C[A]
*********************************
Count	B=0	A
	A=DAT0	W
	C=DAT1	W
	?C#A	W
	GOYES	cntwp
cntwlp	D0=D0+	16
	D1=D1+	16
	B=B+1	A
	A=DAT0	W
	C=DAT1	W
	?C=A	W
	GOYES	cntwlp
	BSL	A
	CD0EX
	C=C-B	A
	CD0EX
	CD1EX
	C=C-B	A
	CD1EX
cntwp	P=	8-1
	?C=A	WP
	GOYES	cntP8
	P=	4-1
	?C=A	WP
	GOYES	cntPlp
	P=	1-1
	GONC	cnpP+
cntP8	P=	12-1
	?C=A	WP
	GOYES	cntPlp
	P=	8-1
cntPlp	P=P+1
cnpP+	?C=A	P
	GOYES	cntPlp
	C=B	A
	CPEX	0
	RTNCC

	STITLE	Ring Buffer Addition
*********************************
* Add current location to ring
* In:	D0
*	R2[A]	->buffer
* Out:	B[A]	->FLlink
*	CS:	no previous ones
* Uses:	A[A] B[A] C[A] D1
*********************************
AddNew
* Compute hash
	A=DAT0	A
	C=A	A
	CSR	A
	CSR	A
	CSRB.F	X
	CSRB.F	X
	B=A	X
	A=A!C	X
	C=C&B	X
	A=A-C	X	hash
* Uncomment if less than 12 bits:
	LC(3)	(HSHSIZE)-1
	C=C&A	X

	A=R2.F	A
	C=C+C	A	2*
	A=A+C	A
	C=C+C	A	4*
	C=C+C	A	8*
	A=A+C	A	10*
	B=A	A	->FLlink
	D1=A
	D1=D1+	5
	A=DAT1	A	LastAddr
	CD0EX
	DAT1=C	A	New LastAddr
	D0=C
	?A=0	A
	GOYES	add1st
* Add to end
addok	C=0	A
	C=A	X
	A=R2.F	A
	A=A-C	A
	A=A-C	A
	A=A-C	A	->lastslot
	D1=A
	D1=D1-	3	Nonzero!
	AD0EX
	DAT1=A	X	link it to D0
	D0=A
	RTNCC
* No previous ones
add1st	D1=D1-	5
	DAT1=C	A
	RTNSC

	STITLE	Ring Buffer Remove
*********************************
* Remove old location from buffer
* In:	D0	->obptr
*	R3[A]	->ob
* Uses:	A[A] B[A] C[A] D1
*********************************
RemoveOld
	AD0EX
	D0=A
	LC(5)	WINSIZE
	A=A-C	A
	C=R3.F	A	->ob
	?C>A	A
	RTNYES
* Old one is in ring, remove it
	D1=A
* Compute hash
	A=DAT1	A
	C=A	A
	CSR	A
	CSR	A
	CSRB.F	X
	CSRB.F	X
	B=A	X
	A=A!C	X
	C=C&B	X
	A=A-C	X	hash
* Uncomment if less than 12 bits:
	LC(3)	(HSHSIZE)-1
	C=C&A	X

	A=R2.F	A
	C=C+C	A	2*
	A=A+C	A
	C=C+C	A	4*
	C=C+C	A	8*
	A=A+C	A	10*
	AD1EX
	B=A	A	->oldpos
	A=DAT1	A
	D1=D1+	5
	C=DAT1	A
	?C<=A	A
	GOYES	removeall
	D1=D1-	5
	C=0	A
	C=B	X
	A=R2.F	A	->buffer
	A=A-C	A
	A=A-C	A
	A=A-C	A	->1stslot
	AD1EX
	D1=D1-	3	Nonzero!
	C=B	A
	C=DAT1	X	1stlink
	D1=A
	?B<C	A
	GOYES	remok
	B=C	A
	LC(5)	WINSIZE
	C=C+B	A
remok	DAT1=C	A
	RTNCC
removeall
	C=0	A
	DAT1=C	A
	D1=D1-	5
	DAT1=C	A
	RTN

	STITLE	Annunciator Flash
*********************************
PackInfo
	D1=(5)	=ANNCTRL
	A=DAT1	B
	A=A+A	B
	ABIT=0	6
	?A#0	B
	GOYES	inf00
	A=A+1	B
inf00	ABIT=1	7
	DAT1=A	B
	RTNCC

	STITLE	Abort Check
*********************************
PackAbort?
	D1=(5)	=aATTNFLG
	A=DAT1	A
	D1=A
	A=DAT1	A
	?A=0	A
	RTNYES
	A=R0
	GOSBVL	=ASRW5
	R0=A
	D0=A
	D0=D0+	10
	GOSBVL	=Shrink$
	GOSBVL	=DispOn
	LC(5)	=ABORT
	GOTO	gpevalc
*********************************
ENDCODE

  SysTime 1GETLAM bit-
  SysTime 1PUTLAM
  SysTime 1GETLAM bit- bit-
  ABND
  HXS>% % 8192 %/ %3 RNDXY UNROT
  DUP4UNROLL OSIZE
  ( $bz %time #len1 #len2 )
  UNCOERCE2 2DUP %CH
  %2 RNDXY a%>$
  "%CH: " !insert$
  4ROLL a%>$ "   Time: " !insert$
  !append$
  ZERO FOURTEEN BLANKIT
  ABUFF #42 #A 4ROLL MINUSONE
  CENTER$3x5 DROP  
  %2 %/ a%>$ SWAP %2 %/ a%>$
  "Size: " !insert$
  " \8D " !append$ !insert$
  ABUFF #42 ZERO 4ROLL MINUSONE
  CENTER$3x5 DROP
  SetDA1Temp
;



*******************************************************************************
**			     Start of UBZ
*******************************************************************************

*ASSEMBLE
*	CON(1)	8
*RPL
*xNAME	ubz
NULLNAME ubz
::
'
CODE
	ST=0	10
L71ABB	GOSBVL	=SAVPTR
	A=DAT1	A
	D1=A
	D1=D1+	10
	A=DAT1	4
	D1=D1+	4
	LC(4)	#5A42
	P=	3
	?C=A	WP
	GOYES	L71AEF
	P=	0
	LC(5)	=SETTYPEERR
	GOVLNG	#15C77
L71AEF	P=	0
	C=DAT1	A
	RSTK=C
	GOSBVL	=CREATETEMP
	GONC	L71B39
	?ST=1	10
	GOYES	L71B32
	GOSUB	L71B29
	CON(5)	=DOCOL
	CON(5)	=GARBAGE
	CON(5)	=COLA
	CON(5)	=DOCODE
	REL(5)	L71D1F
	ST=1	10
	GOTO	L71ABB
L71B29	C=RSTK
	GOVLNG	#15C77
L71B32	GOVLNG	=GPMEMERR
L71B39	C=RSTK
	AD0EX
	R0=A
	C=C+A	A
	R1=C
	GOSBVL	=D1=DSKTOP
	C=DAT1	A
	D0=C
	D0=D0+	10
	D0=D0+	9
	C=DAT0	A
	AD0EX
	D0=A
	D0=D0+	5
	C=C+A	A
	R2=C.F	A
	A=R0
	DAT1=A	A
	R3=A.F	A
	D1=A
	ST=0	9
	A=0	S
	R3=A.F	S
L71B88	GOSUB	L71C06
	?D#0	A
	GOYES	L71BCA
	CD0EX
	CR2EX.F	A
	CD0EX
	C=A	A
	GOSBVL	=MOVEDOWN
	CD0EX
	CR2EX.F	A
	CD0EX
L71BB2	AD1EX
	D1=A
	C=R1.F	A
	?C>A	A
	GOYES	L71B88
	GOVLNG	=GETPTRLOOP
L71BCA	CD1EX
	D1=C
	C=C-A	A
	CD0EX
	DCEX	A
	A=0	P
	?A=0	A
	GOYES	L71BEF
	GOSBVL	=MOVEDOWN
L71BE6	C=D	A
	D0=C
	GOTO	L71BB2
L71BEF	C=C-1	A
L71BF1	A=DAT0	B
	DAT1=A	1
	D0=D0+	1
	D1=D1+	1
	C=C-1	A
	GONC	L71BF1
	GOC	L71BE6
L71C06	?ST=1	9
	GOYES	L71C42
	P=	1
	GOSUB	L71CB2
	?ABIT=1	0
	GOYES	L71C42
	ST=1	9
	P=	4
	GOSUB	L71CB2
	D=0	A
	?A#0	A
	RTNYES
	P=	6
	GOSUB	L71CB2
	?A#0	A
	GOYES	L71C37
	GOSUB	L71C98
L71C37	LC(5)	#F
	A=A+C	A
	RTN
L71C42	ST=0	9
	P=	5
	GOSUB	L71CB2
	?A#0	A
	GOYES	L71C68
	P=	7
	GOSUB	L71CB2
	?A#0	A
	GOYES	L71C5F
	GOSUB	L71C98
L71C5F	LC(5)	#1F
	A=A+C	A
L71C68	C=A	A
	D=C	A
	D=D+CON	A,5
	AD1EX
	D1=A
	C=R3.F	A
	A=A-C	A
	LC(5)	#7FF
	P=	12
L71C89	?C<A	A
	GOYES	L71CB2
	CSRB.F	A
	P=P-1
	GONC	L71C89
L71C98	P=	12
	GOSUB	L71CB2
	B=A	X
	P=	8
	GOSUB	L71CB2
	ASL	A
	ASL	A
	ASL	A
	A=B	X
	RTN
L71CB2	A=DAT0	A
	A=R3.F	S
	A=A-1	S
	GOC	L71CCC
L71CC1	ASRB.F	A
	A=A-1	S
	GONC	L71CC1
L71CCC	C=P	15
	C=C-1	S
	C=0	A
L71CD5	C=C+C	A
	C=C+1	A
	C=C-1	S
	GONC	L71CD5
	A=A&C	A
	A=R3.F	S
	C=P	15
	C=C+A	S
	A=C	S
	C=0	A
	P=	3
	CPEX	15
	CPEX	0
	A=A&C	S
	R3=A.F	S
	P=	0
	CSRB.F	P
	CSRB.F	P
	AD0EX
	A=A+C	A
	AD0EX
	RTN
L71D1F
ENDCODE
;
