	TITLE Supported ROM Entry Points 1.104 w/Kalinowski additions

** Fin: Own additions

**********************************************************************
*			IO Page
**********************************************************************
=BITOFFSET	EQU #00100 =	[DON OFF2 OFF1 OFF0]
=CONTRAST	EQU #00101 =	[CON3 CON2 CON1 CON0]
=DTEST	EQU #00102 =	[VDIG LID TRIM CON4]
=DSPCTL	EQU #00103 =	[LRT LRTD LRTC BIN]
*=CRC		EQU #00104 =	4-nibble CRC register
=LPD		EQU #00108 = R	[LB2 LB1 LB0 VLBI]
=LPE		EQU #00109 =	[ELBI EVLBI GRST RST]
=CMODE	EQU #0010A =	Mode register
*=ANNCTRL	EQU #0010B =	[A4 A3 A2 A1] [AON XTRA A6 A5]
=BAU		EQU #0010D =	[UCK BD2 BD1 BD0]
=CARDCTL	EQU #0010E =	[ECDT RCDT SMP SWINT]
=CARDSTAT	EQU #0010F =	[P2W P1W P2C P1C]
*=IOC		EQU #00110 =	[SON ETBE ERBF ERBZ]
*=RCS		EQU #00111 =	[RX RER RBZ RBF]
*=TCS		EQU #00112 =	[BRK LPB TBZ TBF]
*=CRER	EQU #00113 =	Writing clears RER
*=RBR		EQU #00114 =	Receive buffer register
*=TBR		EQU #00116 =	Transmit buffer register
=SRQ1		EQU #00118 =	[KDN TSRQ ISRQ VSRQ]
=SRQ2		EQU #00119 =	[KDN NINT2 NINT LSRQ]
*=IRC		EQU #0011A =	[IRI EIRU EIRI IRE]
=UNUSED_IO1	EQU #0011B =	Unused nibble
=LCR		EQU #0011C =	[LED ELBE LBZ LBF]
=LBR		EQU #0011D =	[? ? ? dibit]
=SAVE_D1[0]	EQU #0011E =	Save for D1[0] (interrupt system)
*=IRAM@	EQU #0011F =	Hi nib of RAM address
=DISP1CTL	EQU #00120 = W	Display start
=LINENIBS	EQU #00125 = W	Nibble offset (low bit ignored)
=LINECOUNT	EQU #00128 =	[LC3 LC2 LC1 LC0] [DA19 M32 LC5 LC4]
=UNUSED_IO4	EQU #0012A =	Unused 4 nibbles
*=TIMERCTRL.1 EQU #0012E =	[SRQ WKE INT XTRA]
*=TIMERCTRL.2 EQU #0012F =	[SRQ WKE INT RUN]
=DISP2CTL	EQU #00130 = W	Menu display start
*=TIMER1	EQU #00137 =	4-bit timer
*=TIMER2	EQU #00138 =	32-bit timer

**********************************************************************
*		Unsupported Prologs
**********************************************************************

** File:    SupRomEntr.a Version 1.104, 03/29/94
** Machine: Charlemagne

=!!append$	EQU #623A0 *
=!!append$?	EQU #62312 *
=!!insert$	EQU #62394 *
=!append$	EQU #62376 *
=!append$SWAP	EQU #62F2F *
=!insert$	EQU #622E5 *
=#*	EQU #03EC2 *
=#*OVF	EQU #191B9 *
=#+	EQU #03DBC *
=#+-1	EQU #63808 *
=#+DUP	EQU #627D5 *
=#+OVER	EQU #63051 *
=#+PICK	EQU #61184 *
=#+ROLL	EQU #612DE *
=#+SWAP	EQU #62DFE *
=#+UNROLL	EQU #6133E *
=#-	EQU #03DE0 *
=#-#2/	EQU #624FB *
=#-+1	EQU #637CC *
=#-DUP	EQU #627F8 *
=#-OVER	EQU #63065 *
=#-PICK	EQU #61172 *
=#-ROLL	EQU #612CC *
=#-SWAP	EQU #62E12 *
=#-UNROLL	EQU #6132C *
=#/	EQU #03EF7 *
=#0<>	EQU #03CC7 *
=#0=	EQU #03CA6 *
=#0=?SEMI	EQU #61A18 *
=#0=?SKIP	EQU #6333A *
=#0=ITE	EQU #63E89 *
=#0=UNTIL	EQU #62B6F *
=#0=case	EQU #61896 *
=#1+	EQU #03DEF *
=#1+'	EQU #639CA *
=#1+DUP	EQU #62809 *
=#1+LAST$	EQU #63281 *
=#1+NDROP	EQU #62F75 *
=#1+PICK	EQU #611A3 *
=#1+ROLL	EQU #612F3 *
=#1+ROT	EQU #1DABB *
=#1+SWAP	EQU #62E26 *
=#1+UNROLL	EQU #61353 *
=#1+_ONE_DO	EQU #073DB *
=#1-	EQU #03E0E *
=#1--	EQU #637CC *
=#1-1SWAP	EQU #62E4E *
=#1-DUP	EQU #6281A *
=#1-ROT	EQU #62FD9 *
=#1-SUB$	EQU #63245 *
=#1-SWAP	EQU #5E4A9 *
=#1-UNROT	EQU #28558 *
=#1-{}N	EQU #631A5 *
=#10*	EQU #6264E *
=#10+	EQU #625DA *
=#12+	EQU #625EA *
=#1<>	EQU #622B6 *
=#1=	EQU #622A7 *
=#1=?SKIP	EQU #63353 *
=#1=case	EQU #63D26 *
=#2*	EQU #03E6F *
=#2+	EQU #03E2D *
=#2+PICK	EQU #611BE *
=#2+ROLL	EQU #61318 *
=#2+UNROLL	EQU #61365 *
=#2-	EQU #03E4E *
=#2/	EQU #03E8E *
=#2<>	EQU #636C8 *
=#2=	EQU #6229A *
=#3+	EQU #6256A *
=#3+PICK	EQU #611D2 *
=#3-	EQU #625FA *
=#3=	EQU #62289 *
=#4+	EQU #6257A *
=#4+PICK	EQU #611E1 *
=#4-	EQU #6260A *
=#5+	EQU #6258A *
=#5-	EQU #6261A *
=#5=	EQU #636B4 *
=#6*	EQU #62691 *
=#6+	EQU #6259A *
=#6-	EQU #6262A *
=#7+	EQU #625AA *
=#8*	EQU #62674 *
=#8+	EQU #625BA *
=#9+	EQU #625CA *
=#:>$	EQU #167D8 *
=#<	EQU #03CE4 *
=#<3	EQU #63673 *
=#<>	EQU #03D4E *
=#<>case	EQU #63D3A *
=#<ITE	EQU #63E9D *
=#<case	EQU #63D12 *
=#=	EQU #03D19 *
=#=?SKIP	EQU #6336C *
=#=ITE	EQU #62C2D *
=#=POSCOMP	EQU #6448A *
=#=case	EQU #6186C *
=#=casedrop	EQU #618D3 *
=#=casedrpfls	EQU #63547 *
=#>	EQU #03D83 *
=#>$	EQU #167E4 *
=#>%	EQU #5435D *
=#>1	EQU #636F0 *
=#>2case	EQU #63D4E *
=#>?SKIP	EQU #63399 *
=#>CHR	EQU #05A75 *
=#>HXS	EQU #059CC *
=#>ITE	EQU #63EB1 *
=#>ROMPTR	EQU #07E50 *
=#>case	EQU #63D67 *
=#AND	EQU #03EB1 *
=#FIVE#FOUR	EQU #642E3 *
=#MAX	EQU #624C6 *
=#MIN	EQU #624BA *
=#ONE#27	EQU #6428A *
=#THREE#FOUR	EQU #642D1 *
=#TWO#FOUR	EQU #642BF *
=#TWO#ONE	EQU #6429D *
=#TWO#TWO	EQU #642AF *
=#ZERO#ONE	EQU #64209 *
=#ZERO#SEVEN	EQU #6427A *
=#_102	EQU #64E3C *
=$1-+	EQU #63808 *
=$5x7	EQU #11D8F *
=$>BIGGROB	EQU #11CF3 *
=$>GROB	EQU #11D00 *
=$>ID	EQU #05B15 *
=$>grob	EQU #11F80 *
=$_EXIT	EQU #65769 *
=$_GRAD	EQU #657A7 *
=$_RAD	EQU #65797 *
=%%*	EQU #2A99A *
=%%*ROT	EQU #62FED *
=%%*SWAP	EQU #62EA3 *
=%%*UNROT	EQU #63C18 *
=%%+	EQU #2A943 *
=%%-	EQU #2A94F *
=%%/	EQU #2A9E8 *
=%%/>%	EQU #63B82 *
=%%1	EQU #2A4E0 *
=%%>%	EQU #2A5B0 *
=%*	EQU #2A9BC *
=%+	EQU #2A974 *
=%+SWAP	EQU #51BE4 *
=%-	EQU #2A981 *
=%-1	EQU #2A386 *
=%-MAXREAL	EQU #2A487 *
=%.1	EQU #494B4 *
=%.5	EQU #650BD *
=%/	EQU #2A9FE *
=%0	EQU #2A2B4 *
=%0<	EQU #2A738 *
=%0<>	EQU #2A7CF *
=%0=	EQU #2A76B *
=%0=case	EQU #5F127 *
=%0>	EQU #2A799 *
=%0>=	EQU #2A7F7 *
=%1	EQU #2A2C9 *
=%1+	EQU #50262 *
=%1-	EQU #50276 *
=%1/	EQU #2AAAF *
=%10	EQU #650E7 *
=%10*	EQU #62BF1 *
=%100	EQU #415F1 *
=%15	EQU #1CC85 *
=%180	EQU #650FC *
=%1=case	EQU #5F181 *
=%2	EQU #2A2DE *
=%3	EQU #2A2F3 *
=%360	EQU #65126 *
=%4	EQU #2A308 *
=%5	EQU #2A31D *
=%6	EQU #2A332 *
=%7	EQU #2A347 *
=%8	EQU #2A35C *
=%80	EQU #320B1 *
=%<	EQU #2A871 *
=%<=	EQU #2A8B6 *
=%<>	EQU #2A8CC *
=%=	EQU #2A8C1 *
=%>	EQU #2A88A *
=%>#	EQU #543F9 *
=%>%%SWAP	EQU #62E8F *
=%>=	EQU #2A8A0 *
=%>HMS	EQU #2A673 *
=%ABS	EQU #2A900 *
=%ABSCOERCE	EQU #18CD7 *
=%ACOS	EQU #2ACF1 *
=%ALOG	EQU #2ABBA *
=%ASIN	EQU #2ACC1 *
=%ATAN	EQU #2AD21 *
=%CHS	EQU #2A920 *
=%COS	EQU #2AC40 *
=%D>R	EQU #2A622 *
=%EXP	EQU #2AB2F *
=%EXPM1	EQU #2AB42 *
=%FACT	EQU #2B0C4 *
=%FLOOR	EQU #2AF86 *
=%FP	EQU #2AF4D *
=%HMS+	EQU #2A6A0 *
=%HMS-	EQU #2A6C8 *
=%HMS>	EQU #2A68C *
=%IP	EQU #2AF60 *
=%IP>#	EQU #2EC11 *
=%LN	EQU #2AB6E *
=%LNP1	EQU #2ABA7 *
=%LOG	EQU #2AB81 *
=%MAXREAL	EQU #2A472 *
=%MAXorder	EQU #62D81 *
=%MOD	EQU #2ABDC *
=%PI	EQU #2A443 *
=%POL>%REC	EQU #2B4BB *
=%R>D	EQU #2A655 *
=%RAN	EQU #2AFC2 *
=%REC>%POL	EQU #2B48E *
=%SGN	EQU #2A8D7 *
=%SIN	EQU #2ABEF *
=%SQRT	EQU #2AB09 *
=%TAN	EQU #2AC91 *
=%^	EQU #2AA70 *
=&$	EQU #05193 *
=&$SWAP	EQU #63F6A *
=&COMP	EQU #0521F *
=&HXS	EQU #0518A *
='	EQU #06E97 *
='DoBadKey	EQU #3FDFE *
='DoBadKeyT	EQU #3FE12 *
='ERRJMP	EQU #63155 *
='LAMLNAMESTO	EQU #63A3D *
='LamKPSto	EQU #2D441 *
='NOP	EQU #632BD *
='R	EQU #06EEB *
='R'R	EQU #639DE *
='REVAL	EQU #06F66 *
='RRDROP	EQU #639FC *
='RSAVEWORD	EQU #62474 *
='RSaveRomWrd	EQU #62474 *
='Rapndit	EQU #2520A *
='x*	EQU #63B5A *
='xDER	EQU #63B6E *
='xDEREQ	EQU #63A56 *
=1/X15	EQU #2B789 *
=10GETLAM	EQU #614AC *
=10PUTLAM	EQU #61675 *
=10UNROLL	EQU #6312D *
=11GETLAM	EQU #614BC *
=11PUTLAM	EQU #61685 *
=12GETLAM	EQU #614CC *
=12PUTLAM	EQU #61695 *
=13GETLAM	EQU #614DC *
=13PUTLAM	EQU #616A5 *
=14GETLAM	EQU #614EC *
=14PUTLAM	EQU #616B5 *
=15GETLAM	EQU #614FC *
=15PUTLAM	EQU #616C5 *
=16GETLAM	EQU #6150C *
=16PUTLAM	EQU #616D5 *
=17GETLAM	EQU #6151C *
=17PUTLAM	EQU #616E5 *
=18GETLAM	EQU #6152C *
=18PUTLAM	EQU #616F5 *
=19GETLAM	EQU #6153C *
=19PUTLAM	EQU #61705 *
=1ABNDSWAP	EQU #62DB3 *
=1GETABND	EQU #634B6 *
=1GETLAM	EQU #613B6 *
=1GETSWAP	EQU #62F07 *
=1LAMBIND	EQU #634CF *
=1NULLLAM{}	EQU #34D2B *
=1PUTLAM	EQU #615E0 *
=1_#1-SUB	EQU #63259 *
=1_#1-SUB$	EQU #63259 *
=2#0=OR	EQU #6362D *
=2'RCOLARPITE	EQU #61AE9 *
=20GETLAM	EQU #6154C *
=20PUTLAM	EQU #61715 *
=21GETLAM	EQU #6155C *
=21PUTLAM	EQU #61725 *
=22GETLAM	EQU #6156C *
=22PUTLAM	EQU #61735 *
=2@REVAL	EQU #61B45 *
=2DROP	EQU #03258 *
=2DROP00	EQU #6254E *
=2DROPFALSE	EQU #62B0B *
=2DUP	EQU #031AC *
=2DUP#+	EQU #63704 *
=2DUP#<	EQU #6289B *
=2DUP#=	EQU #628B5 *
=2DUP#>	EQU #628D1 *
=2DUP5ROLL	EQU #63C40 *
=2DUPEQ	EQU #635D8 *
=2DUPSWAP	EQU #611F9 *
=2EXT	EQU #64E0A *
=2GETEVAL	EQU #632E5 *
=2GETLAM	EQU #613E7 *
=2GROB	EQU #64DE2 *
=2HXSLIST?	EQU #51532 *
=2LIST	EQU #64C66 *
=2OVER	EQU #63FBA *
=2Ob>Seco	EQU #63FFB *
=2PUTLAM	EQU #615F0 *
=2RDROP	EQU #6114E *
=2REAL	EQU #04099 *
=2SWAP	EQU #62001 *
=2skipcola	EQU #626E5 *
=3@REVAL	EQU #61B55 *
=3DROP	EQU #60F4B *
=3GETLAM	EQU #6140E *
=3PICK	EQU #611FE *
=3PICK#+	EQU #63740 *
=3PICK3PICK	EQU #63C68 *
=3PICKOVER	EQU #630B5 *
=3PICKSWAP	EQU #62EDF *
=3PUTLAM	EQU #61600 *
=3RDROP	EQU #61160 *
=3REAL	EQU #64E64 *
=3UNROLL	EQU #60FAC *
=3skipcola	EQU #626DC *
=4DROP	EQU #60F7E *
=4DropLoop	EQU #60F83 *
=4GETLAM	EQU #61438 *
=4PICK	EQU #6121C *
=4PICK#+	EQU #63754 *
=4PICK#+SWAP	EQU #62DE5 *
=4PICK+SWAP	EQU #62DE5 *
=4PICKOVER	EQU #630C9 *
=4PICKSWAP	EQU #62EF3 *
=4PUTLAM	EQU #61615 *
=4ROLL	EQU #60FBB *
=4ROLLDROP	EQU #62864 *
=4ROLLOVER	EQU #630A1 *
=4ROLLROT	EQU #63001 *
=4ROLLSWAP	EQU #62ECB *
=4UNROLL	EQU #6109E *
=4UNROLL3DROP	EQU #6113C *
=4UNROLLDUP	EQU #62D09 *
=4UNROLLROT	EQU #63015 *
=5DROP	EQU #60F72 *
=5GETLAM	EQU #6145C *
=5PICK	EQU #6123A *
=5PUTLAM	EQU #61625 *
=5ROLL	EQU #60FD8 *
=5ROLLDROP	EQU #62880 *
=5UNROLL	EQU #610C4 *
=5skipcola	EQU #626AE *
=6DROP	EQU #60F66 *
=6GETLAM	EQU #6146C *
=6PICK	EQU #6125E *
=6PUTLAM	EQU #61635 *
=6ROLL	EQU #61002 *
=6UNROLL	EQU #610FA *
=7DROP	EQU #60F54 *
=7GETLAM	EQU #6147C *
=7PICK	EQU #61282 *
=7PUTLAM	EQU #61645 *
=7ROLL	EQU #6106B *
=7UNROLL	EQU #62BC4 *
=8GETLAM	EQU #6148C *
=8PICK	EQU #612A9 *
=8PUTLAM	EQU #61655 *
=8ROLL	EQU #6103C *
=8UNROLL	EQU #63119 *
=9GETLAM	EQU #6149C *
=9PUTLAM	EQU #61665 *
=::N	EQU #05445 *
=::NEVAL	EQU #632D1 *
=<DelKey	EQU #3E3E1 *
=<SkipKey	EQU #3E2DD *
=>DelKey	EQU #3E4CA *
=>H$	EQU #0525B *
=>LASTRAM-WOR	EQU #648BD *
=>R	EQU #06F9F *
=>Review$	EQU #41422 *
=>SkipKey	EQU #3E35F *
=>T$	EQU #052EE *
=>TAG	EQU #05E81 *
=>TCOMP	EQU #052FA *
=?>ROMPTR	EQU #62A61 *
=?ATTNQUIT	EQU #4243E *
=?CARCOMP	EQU #6317D *
=?CaseKeyDef	EQU #3FF1B *
=?CaseRomptr@	EQU #3FF48 *
=?FlashAlert	EQU #386D8 *
=?GOTO	EQU #619E0 *
=?Ob>Seco	EQU #63FCE *
=?ROMPTR>	EQU #62A84 *
=?SEMI	EQU #61A3B *
=?SEMIDROP	EQU #638E4 *
=?SKIP	EQU #0712A *
=?SKIPSWAP	EQU #62D9F *
=?STO_HERE	EQU #18513 *
=?SWAP	EQU #62F1B *
=?SWAPDROP	EQU #62F5C *
=@	EQU #0797B *
=@LAM	EQU #07943 *
=ABND	EQU #07497 *
=ABORT	EQU #04EA4 *
=ABUFF	EQU #12655 *
=ACK_INIT	EQU #30914 *
=ADJMEM	EQU #069F7 *
=AGAIN	EQU #071AB *
=AINRTN	EQU #0115A =
=ALARM?	EQU #422A1 *
=ALARMxcp	EQU #42113 *
=AND	EQU #03B46 *
=ANDITE	EQU #63E61 *
=ANDNOTcase	EQU #63DDF *
=ANDcase	EQU #63CEA *
=ANNCTRL	EQU #0010B =
=APPEND_SPACE	EQU #62BB0 *
=APPprompt1!	EQU #47984 *
=APPprompt2	EQU #479A7 *
=ARRYREAL	EQU #64BE4 *
=ARSIZE	EQU #03562 *
=ASLW5	EQU #0D5F6 *
=ASRW5	EQU #0D5E5 *
=ATTN?	EQU #42262 *
=ATTNFLGCLR	EQU #05068 *
=ATTNchk	EQU #0CA60 *
=ATTNxcp	EQU #420F5 *
=AdjEdModes	EQU #42EC7 *
=AllowIntr	EQU #010E5 =
=AllowPrlcdCl	EQU #324A6 *
=AtUserStack	EQU #40BC9 *
=Attn#	EQU #34301 *
=BEGIN	EQU #071A2 *
=BIND	EQU #074D0 *
=BINT253	EQU #64E1E *
=BINT255d	EQU #64E28 *
=BINT40h	EQU #64BDA *
=BINT80h	EQU #64D10 *
=BINTC0h	EQU #64DD8 *
=BINT_115d	EQU #64CE8 *
=BINT_116d	EQU #64CF2 *
=BINT_122d	EQU #64D06 *
=BINT_130d	EQU #64D1A *
=BINT_131d	EQU #64D24 *
=BINT_65d	EQU #64BE4 *
=BINT_91d	EQU #64C84 *
=BINT_96d	EQU #64C8E *
=BLANKIT	EQU #126DF *
=BUILDKPACKET	EQU #2E108 *
=BigCursor	EQU #66EA5 *
=BindMatVars	EQU #44F42 *
=Blank$	EQU #45676 *
=BlankDA12	EQU #3A578 *
=BlankDA2	EQU #3A55F *
=Box/StdLabel	EQU #3EC99 *
=CACHE	EQU #61CE9 *
=CAR$	EQU #050ED *
=CARCOMP	EQU #05089 *
=CCSB1	EQU #2BEE1 *
=CDR$	EQU #0516C *
=CDRCOMP	EQU #05153 *
=CHANGETYPE	EQU #05AB3 *
=CHECKKEY	EQU #04708 *
=CHOOSE_INIT	EQU #30B1D *
=CHR>#	EQU #05A51 *
=CHR>$	EQU #6475C *
=CHR_#	EQU #65433 *
=CHR_*	EQU #6543A *
=CHR_+	EQU #65441 *
=CHR_,	EQU #65448 *
=CHR_-	EQU #6544F *
=CHR_->	EQU #65639 *
=CHR_.	EQU #65456 *
=CHR_...	EQU #65425 *
=CHR_0	EQU #65464 *
=CHR_00	EQU #6541E *
=CHR_:	EQU #654AA *
=CHR_;	EQU #654B1 *
=CHR_D	EQU #654E2 *
=CHR_F	EQU #654F0 *
=CHR_LeftPar	EQU #65663 *
=CHR_Newline	EQU #6566A *
=CHR_R	EQU #65544 *
=CHR_RightPar	EQU #65678 *
=CHR_S	EQU #6554B *
=CHR_Space	EQU #65686 *
=CHR_Z	EQU #6557C *
=CHR_c	EQU #65591 *
=CHR_k	EQU #655C9 *
=CHR_m	EQU #655D7 *
=CHR_n	EQU #655DE *
=CHR_o	EQU #655E5 *
=CHR_p	EQU #655EC *
=CINRTN	EQU #01160 =
=CK0	EQU #18A1E *
=CK0ATTNABORT	EQU #23768 *
=CK0NOLASTWD	EQU #18A15 *
=CK1	EQU #18AA5 *
=CK1&Dispatch	EQU #18ECE *
=CK1NOLASTWD	EQU #18AB2 *
=CK2	EQU #18A80 *
=CK2&Dispatch	EQU #18EDF *
=CK2NOLASTWD	EQU #18A8D *
=CK3	EQU #18A5B *
=CK3&Dispatch	EQU #18EF0 *
=CK4&Dispatch	EQU #18F01 *
=CKLBCRC	EQU #0A00E *
=CKN	EQU #18C34 *
=CKREAL	EQU #63B2D *
=CKREF	EQU #37B44 *
=CKSYMBTYPE	EQU #1F05B *
=CLCD10	EQU #01F6D *
=CLEARLCD	EQU #01FA7 *
=CLEARVDISP	EQU #134AE *
=CLKTICKS	EQU #0EB81 *
=CLRFRC	EQU #2BBE2 *
=COERCE	EQU #18CEA *
=COERCE2	EQU #194F7 *
=COERCEDUP	EQU #62CE1 *
=COERCEFLAG	EQU #5380E *
=COERCESWAP	EQU #62E7B *
=COLA	EQU #06FD1 *
=COLACOLA	EQU #6296D *
=COLAITE	EQU #6381C *
=COLANOTcase	EQU #629A1 *
=COLARPITE	EQU #61A8E *
=COLASKIP	EQU #633B2 *
=COLA_EVAL	EQU #61A6D *
=COLAcase	EQU #62986 *
=COMPCONFCRC	EQU #09B73 *
=CONTEXT!	EQU #08D08 *
=CONTEXT@	EQU #08D5A *
=CREATEDIR	EQU #184E1 *
=CREATETEMP	EQU #06AD8 *
=CRLF$		EQU #2E4F0 *
=CROSSGROB	EQU #5053C *
=CRUNCH	EQU #1578D *
=CSLW5	EQU #0D618 *
=CSRW5	EQU #0D607 *
=CURSOR1	EQU #13D8C *
=ChkLowBat	EQU #325AA *
=Ck&DecKeyLoc	EQU #41CA2 *
=Clr16	EQU #0E06F *
=ClrAlphaAnn	EQU #1133A *
=ClrDA1IsStat	EQU #39531 *
=ClrDA3Bad	EQU #39507 *
=ClrDA3OK	EQU #3912B *
=ClrDAsOK	EQU #39144 *
=ClrLeftAnn	EQU #1136E *
=ClrRightAnn	EQU #11354 *
=ClrServMode	EQU #2D9B2 *
=ClrSysFlag	EQU #53761 *
=ClrUserFlag	EQU #53755 *
=CodePl>%rc.p	EQU #41D92 *
=Connecting	EQU #6506C *
=CopyColsLeft	EQU #4651C *
=CopyColsRght	EQU #4677E *
=CopyRowsDown	EQU #46625 *
=CopyRowsUp	EQU #46409 *
=CtlAlarm!	EQU #4248E *
=D0->Row1	EQU #01C31 *
=D0->Sft1	EQU #01C58 *
=D0=DSKTOP	EQU #6384E *
=D1=DSKTOP	EQU #6385D *
=DA3OK?	EQU #38EB5 *
=DATE	EQU #0CC0E *
=DAY#	EQU #0D4AD *
=DCHXW	EQU #0D62F *
=DDAYS	EQU #0CC39 *
=DECODE	EQU #30D31 *
=DECOMP$	EQU #15B13 *
=DEEPSLEEP	EQU #041ED *
=DEPTH	EQU #0314C *
=DIMLIMITS	EQU #035A9 *
=DISP@01	EQU #1245B *
=DISP@09	EQU #1246B *
=DISP@17	EQU #1247B *
=DISP@25	EQU #1248B *
=DISPN	EQU #12429 *
=DISPROW1	EQU #1245B *
=DISPROW1*	EQU #12725 *
=DISPROW2	EQU #1246B *
=DISPROW3	EQU #1247B *
=DISPROW4	EQU #1248B *
=DISPROW5	EQU #1249B *
=DISPROW7	EQU #124BB *
=DISPSTATUS2	EQU #1270C *
=DIV2	EQU #2BBB5 *
=DIVF	EQU #2B977 *
=DO	EQU #073F7 *
=DO$EXIT	EQU #15048 *
=DO>LCD	EQU #50438 *
=DO>STR	EQU #14088 *
=DOARRY	EQU #029E8 =
=DOBEEP	EQU #1415A *
=DOBIN	EQU #53C43 *
=DOBINT	EQU #02911 =
=DOBUFLEN	EQU #2EDE1 *
=DOCHAR	EQU #029BF =
=DOCHR	EQU #140F1 *
=DOCLLCD	EQU #5046A *
=DOCMP	EQU #02977 =
=DOCODE	EQU #02DCC =
=DOCOL	EQU #02D9D =
=DOCSTR	EQU #02A2C =
=DODEC	EQU #53C5B *
=DODELAY	EQU #31FFD *
=DODISP	EQU #140AB *
=DOENG	EQU #166FB *
=DOEXT	EQU #02ADA =
=DOEXT0	EQU #02B88 =
=DOFALSE	EQU #620DC *
=DOFIX	EQU #166E3 *
=DOGARBAGE	EQU #0554C *
=DOGROB	EQU #02B1E =
=DOHEX	EQU #53C37 *
=DOHSTR	EQU #02A4E =
=DOHXS	EQU #02A4E =
=DOIDNT	EQU #02E48 =
=DOLAM	EQU #02E6D =
=DOLCD>	EQU #503D4 *
=DOLIB	EQU #02B40 =
=DOLIST	EQU #02A74 =
=DOOCT	EQU #53C4F *
=DOOPENIO	EQU #2EB37 *
=DOPRLCD	EQU #31EE2 *
=DORANDOMIZE	EQU #2B07B *
=DORCLE	EQU #1572B *
=DOREAL	EQU #02933 =
=DOROMP	EQU #02E92 =
=DOSCI	EQU #166EF *
=DOSRECV	EQU #2EE97 *
=DOSTD	EQU #16707 *
=DOSTR>	EQU #14137 *
=DOTRUE	EQU #620C3 *
=DOTVARS%	EQU #186E8 *
=DOVARS	EQU #18779 *
=DPRADIX?	EQU #167BF *
=DROP	EQU #03244 *
=DROP#1-	EQU #637F4 *
=DROP'	EQU #6394D *
=DROPDUP	EQU #627A7 *
=DROPFALSE	EQU #6210C *
=DROPLOOP	EQU #63466 *
=DROPNDROP	EQU #63FA6 *
=DROPNULL$	EQU #04D3E *
=DROPONE	EQU #62946 *
=DROPOVER	EQU #63029 *
=DROPRDROP	EQU #632F9 *
=DROPROT	EQU #62FC5 *
=DROPSWAP	EQU #6270C *
=DROPSWAPDROP	EQU #62726 *
=DROPTRUE	EQU #62103 *
=DROPZERO	EQU #62535 *
=DTYPEARRY?	EQU #62193 *
=DTYPECOL?	EQU #621E7 *
=DTYPECSTR?	EQU #62154 *
=DTYPELIST?	EQU #62211 *
=DTYPEREAL?	EQU #62169 *
=DUMP	EQU #61EA7 *
=DUP	EQU #03188 *
=DUP#0<>	EQU #622D4 *
=DUP#0<>WHILE	EQU #633F8 *
=DUP#0=	EQU #62266 *
=DUP#0=IT	EQU #63E48 *
=DUP#0=ITE	EQU #63EC5 *
=DUP#0=case	EQU #61891 *
=DUP#0=csDROP	EQU #63CBD *
=DUP#0=csedrp	EQU #618A8 *
=DUP#0_DO	EQU #6347F *
=DUP#1+	EQU #628EB *
=DUP#1+PICK	EQU #6119E *
=DUP#1-	EQU #6292F *
=DUP#1=	EQU #622C5 *
=DUP#2+	EQU #626F7 *
=DUP#<7	EQU #63687 *
=DUP$>ID	EQU #63295 *
=DUP%0=	EQU #63BAA *
=DUP'	EQU #63925 *
=DUP1LAMBIND	EQU #634CA *
=DUP3PICK	EQU #611F9 *
=DUP3PICK#+	EQU #63704 *
=DUP4PUTLAM	EQU #61610 *
=DUP4UNROLL	EQU #61099 *
=DUP@	EQU #62C05 *
=DUPDUP	EQU #62CB9 *
=DUPEQ:	EQU #635EC *
=DUPGROBDIM	EQU #5179E *
=DUPINCOMP	EQU #631E1 *
=DUPINDEX@	EQU #63411 *
=DUPLEN$	EQU #627BB *
=DUPLENCOMP	EQU #63231 *
=DUPNULL$?	EQU #63209 *
=DUPNULLCOMP?	EQU #6321D *
=DUPNULL{}?	EQU #63A6F *
=DUPONE	EQU #63A9C *
=DUPPICK	EQU #630DD *
=DUPROLL	EQU #630F1 *
=DUPROM-WORD?	EQU #61FA9 *
=DUPROMPTR@	EQU #62C19 *
=DUPROT	EQU #62FB1 *
=DUPSAFE@	EQU #62A2F *
=DUPTEMPENV	EQU #61745 *
=DUPTWO	EQU #63AD8 *
=DUPTYPEARRY?	EQU #62193 *
=DUPTYPEBINT?	EQU #6212A *
=DUPTYPECHAR?	EQU #62020 *
=DUPTYPECMP?	EQU #6217E *
=DUPTYPECOL?	EQU #621E7 *
=DUPTYPECSTR?	EQU #62154 *
=DUPTYPEEXT?	EQU #6204A *
=DUPTYPEGROB?	EQU #621FC *
=DUPTYPEHSTR?	EQU #6213F *
=DUPTYPEIDNT?	EQU #62035 *
=DUPTYPELAM?	EQU #62115 *
=DUPTYPELIST?	EQU #62211 *
=DUPTYPEREAL?	EQU #62169 *
=DUPTYPEROMP?	EQU #621A8 *
=DUPTYPERRP?	EQU #621BD *
=DUPTYPESYMB?	EQU #621D2 *
=DUPTYPETAG?	EQU #62226 *
=DUPUNROT	EQU #61380 *
=DUPZERO	EQU #63A88 *
=DZP	EQU #00003 =
=DaDGNTc	EQU #25223 *
=Day>Date	EQU #0D744 *
=DeepSleep	EQU #04292 *
=DisableIntr	EQU #01115 =
=Disp5x7	EQU #3A4CE *
=DispDir?Time	EQU #3988B *
=DispMenu	EQU #3A1E8 *
=DispMenu.1	EQU #3A1FC *
=DispOff	EQU #01BBD *
=DispOn	EQU #01B8F *
=DispTimeReq?	EQU #39AF1 *
=DispVarsUtil	EQU #153FC *
=Do1st/2nd+:	EQU #3EE1A *
=DoBadKey	EQU #3FDD1 *
=DoCAlarmKey	EQU #42475 *
=DoFirstRow	EQU #3B211 *
=DoNameKeyLRS	EQU #40350 *
=DoNameKeyRS	EQU #40337 *
=DoNextRow	EQU #3A71C *
=DoPrevRow	EQU #3A735 *
=DoSolvrMenu	EQU #3BE54 *
=DropLoop	EQU #03249 *
=DropSysObs	EQU #18308 *
=DupAndThen	EQU #641CC *
=EDITDECOMP$	EQU #15A0E *
=EIGHT	EQU #0403F *
=EIGHTEEN	EQU #040A3 *
=EIGHTROLL	EQU #6103C *
=EIGHTY	EQU #64C34 *
=EIGHTYONE	EQU #64C3E *
=ELEVEN	EQU #0405D *
=ENCODE1PKT	EQU #30BBE *
=ENTERCODE	EQU #00019 =
=EQ	EQU #03B2E *
=EQ:	EQU #635F1 *
=EQIT	EQU #63E2F *
=EQITE	EQU #63E75 *
=EQLookup	EQU #64593 *
=EQOR	EQU #63605 *
=EQOVER	EQU #6303D *
=EQUAL	EQU #03B97 *
=EQUALNOT	EQU #635C4 *
=EQUALNOTcase	EQU #63DF3 *
=EQUALOR	EQU #63619 *
=EQUALPOSCOMP	EQU #644A3 *
=EQUALcase	EQU #63CFE *
=EQUALcasedro	EQU #517F3 *
=EQUALcasedrp	EQU #63CA4 *
=EQcase	EQU #61933 *
=EQcasedrop	EQU #618BA *
=ERRBEEP	EQU #141E5 *
=ERRJMP	EQU #04ED1 *
=ERROR@	EQU #04CE6 *
=ERROROUT	EQU #6383A *
=ERRORSTO	EQU #04D0E *
=ERRSET	EQU #04E5E *
=ERRTRAP	EQU #04EB8 *
=EVAL	EQU #06F8E *
=EXAB0	EQU #2BE99 *
=EXAB2	EQU #2BEA7 *
=EXPAND	EQU #61C1C *
=EXT	EQU #0407B *
=EXTOBOB	EQU #6508A *
=EXTREAL	EQU #64DF6 *
=EXTSYM	EQU #64E00 *
=EditExstCase	EQU #63DCB *
=Embedded?	EQU #64127 *
=EqList?	EQU #152FF *
=ErrFixEIRU	EQU #32B08 *
=Errjmp	EQU #05023 *
=ErrjmpC	EQU #10F80 *
=EvalNoCK	EQU #18F23 *
=ExitAction!	EQU #419C4 *
=ExitAtLOOP	EQU #6400F *
=FALSE	EQU #03AC0 *
=FALSE'	EQU #639B6 *
=FALSETRUE	EQU #6350B *
=FIFTEEN	EQU #04085 *
=FIFTY	EQU #64B4E *
=FIFTYEIGHT	EQU #64B9E *
=FIFTYFIVE	EQU #64B80 *
=FIFTYFOUR	EQU #64B76 *
=FIFTYNINE	EQU #64BA8 *
=FIFTYONE	EQU #64B58 *
=FIFTYSEVEN	EQU #64B94 *
=FIFTYSIX	EQU #64B8A *
=FIFTYTHREE	EQU #64B6C *
=FIFTYTWO	EQU #64B62 *
=FIVE	EQU #04021 *
=FIVEFOUR	EQU #64C5C *
=FIVEROLL	EQU #60FD8 *
=FIVESIX	EQU #64C70 *
=FIVETHREE	EQU #64C52 *
=FIVEUNROLL	EQU #610C4 *
=FLOAT	EQU #0D6D8 *
=FLUSH	EQU #00D71 =
=FLUSHKEYS	EQU #00D71 =
=FLUSHRSBUF	EQU #3136C *
=FORTY	EQU #0417F *
=FORTYEIGHT	EQU #64B3A *
=FORTYFIVE	EQU #64B1C *
=FORTYFOUR	EQU #64B12 *
=FORTYNINE	EQU #64B44 *
=FORTYONE	EQU #04189 *
=FORTYSEVEN	EQU #64B30 *
=FORTYSIX	EQU #64B26 *
=FORTYTHREE	EQU #0419D *
=FORTYTWO	EQU #04193 *
=FOUR	EQU #04017 *
=FOURFIVE	EQU #64C0C *
=FOURROLL	EQU #60FBB *
=FOURROLLROT	EQU #63001 *
=FOURTEEN	EQU #0407B *
=FOURTHREE	EQU #64BF8 *
=FOURTWO	EQU #64BEE *
=FOURTY	EQU #0417F *
=FOURUNROLL	EQU #6109E *
=FalseFalse	EQU #2F934 *
=FalseTrue	EQU #6350B *
=Find1stT.1	EQU #644EE *
=Find1stTrue	EQU #644D0 *
=FixEIRU	EQU #32B1A *
=FlashWarning	EQU #38926 *
=Flush	EQU #00D57 =
=FlushAttn	EQU #00D8E =
=GARBAGE	EQU #05F42 *
=GARBAGECOL	EQU #0613E *
=GBUFF	EQU #12665 *
=GETAB0	EQU #2BFFD *
=GETAB1	EQU #2BFE3 *
=GETATELN	EQU #0371D *
=GETCD0	EQU #2C031 *
=GETDF	EQU #04A41 *
=GETKEY	EQU #42159 *
=GETKEY*	EQU #420A0 *
=GETLAM	EQU #075A5 *
=GETLAMPAIR	EQU #617D8 *
=GETPIX	EQU #138EF
=GETPIX3	EQU #138F2
=GETPROC	EQU #04A0B *
=GETPTR	EQU #067D2 *
=GETPTRFALSE	EQU #26FAE *
=GETPTRLOOP	EQU #05143 *
=GETPTRTRUE	EQU #25CE1 *
=GETSERIAL	EQU #314E5 *
=GETTHEMESG	EQU #04D64 *
=GETTOUCH	EQU #04714 *
=GOTO	EQU #619CB *
=GPMEMERR	EQU #065AA *
=GPOverWrALp	EQU #03672 *
=GPOverWrFLp	EQU #62096 *
=GPOverWrR0Lp	EQU #0366F *
=GPOverWrT/FL	EQU #62073 *
=GPOverWrTLp	EQU #62076 *
=GPPushA	EQU #54266 *
=GPPushFLoop	EQU #620D2 *
=GPPushT/FLp	EQU #620B6 *
=GPPushTLoop	EQU #620B9 *
=GROB!	EQU #11679 *
=GROB!ZERO	EQU #11A6D *
=GROB!ZERODRP	EQU #6389E *
=GROB+#	EQU #4F78C *
=GROB>GDISP	EQU #12F94 *
=GROBDIM	EQU #50578 *
=GROBDIMw	EQU #63C04 *
=GetChkPRTPAR	EQU #3205C *
=GetElt	EQU #45D1F *
=GetIOPAR	EQU #2EA4F *
=GetKermPkt#	EQU #2F39C *
=GetMat/Vec	EQU #45AE0 *
=GetNextToken	EQU #26162 *
=GetStrLen	EQU #2FFBA *
=GetStrLenStk	EQU #2FFB4 *
=GetTimChk	EQU #012EE =
=GetTime++	EQU #0130E =
=Grob>Menu	EQU #3A297 *
=GsstFIN	EQU #1518D *
=H/W>KeyCode	EQU #3FE44 *
=HARDBUFF	EQU #12635 *
=HEIGHTENGROB	EQU #12DD1 *
=HOMEDIR	EQU #08D92 *
=HXDCW	EQU #0DB91 *
=HXS>#	EQU #05A03 *
=HXS>$	EQU #54061 *
=HXS>HXS	EQU #54500 *
=ID>$	EQU #05BE9 *
=ID>TAG	EQU #05F2E *
=IDREAL	EQU #64C98 *
=INCOMPDROP	EQU #62B88 *
=INDEX@	EQU #07221 *
=INDEX@#-	EQU #63790 *
=INDEXSTO	EQU #07270 *
=INHARDROM?	EQU #1A2DA *
=INNER#1=	EQU #636A0 *
=INNERCOMP	EQU #054AF *
=INNERDUP	EQU #62C41 *
=INTEGER337	EQU #64F04 *
=INTEMNOTREF?	EQU #06B4E *
=INVGROB	EQU #122FF *
=IOC	EQU #00110 =
=IOCheckReal	EQU #2EC25 *
=IRC	EQU #0011A =
=ISTOP@	EQU #07249 *
=ISTOPSTO	EQU #07295 *
=IT	EQU #619BC *
=ITE	EQU #61AD8 *
=ITE_DROP	EQU #61A58 *
=ImmedEntry?	EQU #408AA *
=IncrLAMPKNO	EQU #2F383 *
=InitIOEnv	EQU #2E6BE *
=InitMenu	EQU #40F86 *
=InitMenu%	EQU #41679 *
=InitOldMat	EQU #45023 *
=InputLine	EQU #42F44 *
=JINDEX@	EQU #07258 *
=JUMPBOT	EQU #516AE *
=JUMPLEFT	EQU #516E5 *
=JUMPRIGHT	EQU #51703 *
=JUMPTOP	EQU #51690 *
=JstGETTHEMSG	EQU #04D87 *
=KDispRow2	EQU #2D730 *
=KDispStatus2	EQU #2D74E *
=KERMOPEN	EQU #2EAE2 *
=KEYINBUFFER?	EQU #42402 *
=KILLGDISP	EQU #13061 *
=KINVISLF	EQU #3016B *
=KVIS	EQU #2FEDD *
=KVISLF	EQU #2FEC9 *
=KeepUnit	EQU #1553B *
=Key>StdKeyOb	EQU #3FB1A *
=KeyInBuff?	EQU #04999 *
=LAMKML	EQU #2F211 *
=LAMKMODE	EQU #2D46D *
=LAMKRM	EQU #2D493 *
=LAMLNAME	EQU #2D3FB *
=LAMPKNO	EQU #2D3A0 *
=LAMRETRY	EQU #2D3C6 *
=LAST$	EQU #6326D *
=LASTRAM-WORD	EQU #08326 *
=LEN$	EQU #05636 *
=LENCOMP	EQU #0567B *
=LENHXS	EQU #05616 *
=LINEON	EQU #50B17 *
=LISTCMP	EQU #64C48 *
=LISTLAM	EQU #64C7A *
=LISTREAL	EQU #64C3E *
=LOOP	EQU #07334 *
=LabelDef!	EQU #418F4 *
=List	EQU #24C0D *
=LoadTouchTbl	EQU #41175 *
=LockAlpha	EQU #40D25 *
=Lookup	EQU #6452F *
=Lookup.1	EQU #64548 *
=Loop	EQU #2D564 *
=MACRODCMP	EQU #62ABB *
=MAKE$	EQU #05B79 *
=MAKE$N	EQU #05B7D *
=MAKEARRY	EQU #03442 *
=MAKEGROB	EQU #1158F *
=MATCON	EQU #35CAE *
=MATREDIM	EQU #37E0F *
=MATTRN	EQU #3811F *
=MAXRETRY	EQU #2D396 *
=MDIMSDROP	EQU #62F9D *
=MEM	EQU #05F61 *
=MENoP&FixDA1	EQU #390A4 *
=MINUSONE	EQU #6509E *
=MOVEDOWN	EQU #0670C *
=MOVEUP	EQU #066B9 *
=MPY	EQU #53EE4 *
=MUL#	EQU #03991 *
=MULTF	EQU #2B91E *
=MakeBoxLabel	EQU #3A38A *
=MakeDirLabel	EQU #3A3EC *
=MakeInvLabel	EQU #3A44E *
=MakeLabel	EQU #3A4AB *
=MakeStdLabel	EQU #3A328 *
=MediumCursor	EQU #66ECD *
=MenuKeyLS!	EQU #41944 *
=MenuKeyNS!	EQU #41914 *
=MenuKeyRS!	EQU #41964 *
=MenuRow@	EQU #4185B *
=MenuRowAct!	EQU #418D4 *
=N+1DROP	EQU #62F75 *
=NDROP	EQU #0326E *
=NDUP	EQU #031D9 *
=NDUPN	EQU #5E370 *
=NEWLINE$	EQU #65238 *
=NEWLINE$&$	EQU #63191 *
=NEWLINE&$	EQU #63191 *
=NEXTCOMPOB	EQU #6480B *
=NINE	EQU #04049 *
=NINETEEN	EQU #040AD *
=NOP	EQU #06E8E *
=NOT	EQU #03AF2 *
=NOT?DROP	EQU #61B72 *
=NOT?GOTO	EQU #619F3 *
=NOT?SEMI	EQU #61A2C *
=NOT?SWAPDROP	EQU #62F43 *
=NOTAND	EQU #62C55 *
=NOT_IT	EQU #0712A *
=NOT_UNTIL	EQU #633C6 *
=NOT_WHILE	EQU #633DF *
=NOTcase	EQU #619AD *
=NOTcase2DROP	EQU #61984 *
=NOTcase2drop	EQU #61910 *
=NOTcaseDROP	EQU #61960 *
=NOTcaseFALSE	EQU #5FB49 *
=NOTcaseTRUE	EQU #638CB *
=NOTcasedrop	EQU #618E8 *
=NOTcsdrpfls	EQU #63AEC *
=NTHCOMDDUP	EQU #62D1D *
=NTHCOMPDROP	EQU #62B9C *
=NTHELCOMP	EQU #056B6 *
=NTHOF	EQU #644BC *
=NULL$	EQU #055DF *
=NULL$?	EQU #0556F *
=NULL$SWAP	EQU #62D59 *
=NULL$TEMP	EQU #1613F *
=NULL::	EQU #055FD *
=NULLHXS	EQU #055D5 *
=NULLLAM	EQU #34D30 *
=NULL{}	EQU #055E9 *
=NcaseSIZEERR	EQU #63B19 *
=NcaseTYPEERR	EQU #63B46 *
=NoAttn?Semi	EQU #4245C *
=NoIgnoreAlm	EQU #53AE4 *
=NullMenuKey	EQU #3EC71 *
=OCRC	EQU #05944 *
=ONE	EQU #03FF9 *
=ONE#>	EQU #636F0 *
=ONECOLA	EQU #63A15 *
=ONEDUP	EQU #63AC4 *
=ONEFALSE	EQU #63533 *
=ONEFALSE'	EQU #6399D *
=ONEHUNDRED	EQU #64CAC *
=ONEONE	EQU #63AC4 *
=ONESWAP	EQU #62E67 *
=ONE_DO	EQU #073CE *
=ONE_EQ	EQU #63385 *
=ONE{}N	EQU #23EED *
=OR	EQU #03B75 *
=OR$	EQU #18887 *
=ORNOT	EQU #635B0 *
=ORcase	EQU #629BC *
=OSIZE	EQU #05902 *
=OUTUART	EQU #30ED2 *
=OVER	EQU #032C2 *
=OVER#+	EQU #6372C *
=OVER#-	EQU #6377C *
=OVER#0=	EQU #6364B *
=OVER#2+UNROL	EQU #63105 *
=OVER#<	EQU #6365F *
=OVER#=	EQU #620EB *
=OVER#=case	EQU #6187C *
=OVER#>	EQU #636DC *
=OVER'	EQU #63961 *
=OVER5PICK	EQU #63C90 *
=OVERARSIZE	EQU #63141 *
=OVERDUP	EQU #62CCD *
=OVERINDEX@	EQU #63439 *
=OVERLEN$	EQU #05622 *
=OVERSWAP	EQU #62D31 *
=OVERUNROT	EQU #62D31 *
=Ob>Seco	EQU #63FE7 *
=OnKeyDown?	EQU #00C74 =
=OnKeyStable?	EQU #00C80 =
=OpenIO	EQU #2EB62 *
=OpenIOPrt	EQU #3187C *
=OpenUartClr	EQU #3161E *
=OverWrF/TLp	EQU #6207D *
=OverWrFLoop	EQU #620A0 *
=OverWrT/FLp	EQU #6209D *
=OverWrTLoop	EQU #62080 *
=PACK	EQU #29E46 *
=PALPTRDCMP	EQU #62B1F *
=PATHDIR	EQU #1848C *
=PICK	EQU #032E2 *
=PIXOFF	EQU #1383B *
=PIXON	EQU #1384A *
=POLKeyUI	EQU #38AEB *
=POLResUI&Err	EQU #38B77 *
=POLRestoreUI	EQU #38B90 *
=POLSaveUI	EQU #389BC *
=POLSetUI	EQU #38A64 *
=POP#	EQU #06641 *
=POP1%	EQU #29FDA *
=POP1%SPLITA	EQU #29FD0 *
=POP2#	EQU #03F5D *
=POP2%	EQU #2A002 *
=POPDATE%	EQU #0D92C *
=POPKEY	EQU #04840 *
=POPUART	EQU #31289 *
=PORTSTATUS	EQU #0AAB2 *
=POS$	EQU #645B1 *
=POS$REV	EQU #645BD *
=POSCHR	EQU #645B1 *
=POSCHRREV	EQU #645BD *
=POSCOMP	EQU #64426 *
=PREVRAM-WORD	EQU #08376 *
=PRINT	EQU #32161 *
=PRINTxNLF	EQU #32387 *
=PRLG	EQU #028FC =
=PSubErr	EQU #323E9 *
=PULLREALEL	EQU #355B8 *
=PURGE	EQU #08C27 *
=PUSH#	EQU #06537 *
=PUSH#ALOOP	EQU #0357C *
=PUSH#LOOP	EQU #0357F *
=PUSH%	EQU #2A188 *
=PUSH%LOOP	EQU #2A23D *
=PUSH2#	EQU #06529 *
=PUSHA	EQU #03A86 *
=PUSHhxsLoop	EQU #0596D *
=PUTAB0	EQU #2C04B *
=PUTEL	EQU #35628 *
=PUTLAM	EQU #075E9 *
=PUTLIST	EQU #1DC00 *
=PUTREALEL	EQU #3566F *
=PUTSERIAL	EQU #31444 *
=ParOuterLoop	EQU #38985 *
=PopASavptr	EQU #3251C *
=PopSavptr	EQU #3251F *
=PrintGrob	EQU #32B74 *
=PromptIdUtil	EQU #49709 *
=PuHiddenVar	EQU #6408C *
=Push#FLoop	EQU #2E31F *
=Push#TLoop	EQU #036F7 *
=Push2#Loop	EQU #03F14 *
=Push2#aLoop	EQU #627EB *
=PushF/TLoop	EQU #620C0 *
=PushFLoop	EQU #620DC *
=PushT/F	EQU #620D9 *
=PushT/FLoop	EQU #620D9 *
=PushTLoop	EQU #620C3 *
=PutSerialECk	EQU #30E4E *
=RADD1	EQU #2B7B0 *
=RADDF	EQU #2B7CA *
=RAM-WORDNAME	EQU #082E3 *
=RCAB0	EQU #2BEB5 *
=RCAB2	EQU #2BEC0 *
=RCCD0	EQU #2BECB *
=RCCD2	EQU #2BED6 *
=RCKBp	EQU #01AD7 * Routine changed for rev G
=RCLSYSF	EQU #1C637 *
=RDROP	EQU #06FB7 *
=RDROPCOLA	EQU #62958 *
=REALEXT	EQU #0411B *
=REALOB	EQU #0408F *
=REALOBOB	EQU #64E32 *
=REALREAL	EQU #04099 *
=REALSYM	EQU #040F3 *
=REALcase	EQU #63D8F *
=RECLAIMDISP	EQU #130AC *
=REMAP	EQU #323F9 *
=REPEAT	EQU #071E5 *
=REPEATER	EQU #40E88 *
=REPKEY?	EQU #047C7 *
=REPLACE	EQU #085D3 *
=REQcase	EQU #629D0 *
=REQcasedrop	EQU #629E9 *
=RESOROMP	EQU #62BD8 *
=RNDC[B]	EQU #2BEEC *
=RNDXY	EQU #2B529 *
=ROLL	EQU #03325 *
=ROLLDROP	EQU #62F89 *
=ROLLSWAP	EQU #62D45 *
=ROM-WORD?	EQU #61FB6 *
=ROMPANY	EQU #64E14 *
=ROMPTR@	EQU #07E99 *
=ROOM	EQU #06806 *
=ROT	EQU #03295 *
=ROT#+	EQU #63718 *
=ROT#+SWAP	EQU #62DCC *
=ROT#-	EQU #63768 *
=ROT#1+	EQU #637B8 *
=ROT#1+UNROT	EQU #5FB76 *
=ROT+SWAP	EQU #62DCC *
=ROT2DROP	EQU #62726 *
=ROT2DUP	EQU #62C7D *
=ROTAND	EQU #62C91 *
=ROTDROP	EQU #60F21 *
=ROTDROPSWAP	EQU #60F0E *
=ROTDUP	EQU #62775 *
=ROTOVER	EQU #62CA5 *
=ROTROT2DROP	EQU #6112A *
=ROTSWAP	EQU #60EE7 *
=ROTUntop&	EQU #63F2E *
=RSKIP	EQU #63880 *
=RSUB1	EQU #2B7A7 *
=RSWAP	EQU #60EBD *
=RclHiddenVar	EQU #64023 *
=RecvNextPkt	EQU #2F989 *
=RestVarRes	EQU #640FA *
=ReviewKey!	EQU #41984 *
=Rom-Word?	EQU #61FCF *
=RowElt#	EQU #45C2F *
=SAFE@	EQU #62A34 *
=SAFE@_HERE	EQU #1853B *
=SAFESTO	EQU #62A02 *
=SAVELAM	EQU #61D3A *
=SAVESTACK	EQU #61D41 *
=SAVPTR	EQU #0679B *
=SCROLLDOWN	EQU #4D16E *
=SCROLLLEFT	EQU #4D150 *
=SCROLLRIGHT	EQU #4D18C *
=SCROLLUP	EQU #4D132 *
=SEMI	EQU #0312B =
=SEMILOOP	EQU #61A47 *
=SENDACK	EQU #2FEA1 *
=SENDEOT	EQU #2D58C *
=SENDERROR	EQU #2E0C7 *
=SENDNAK	EQU #2E0A9 *
=SENDNULLACK	EQU #2FEB5 *
=SEND_PACKET	EQU #2D5E1 *
=SETCIRCERR	EQU #11016 *
=SETDEG	EQU #2A5D2 *
=SETGRAD	EQU #2A604 *
=SETMEMERR	EQU #04FB6 *
=SETRAD	EQU #2A5F0 *
=SETSIZEERR	EQU #18CA2 *
=SETTYPEERR	EQU #18CB2 *
=SEVEN	EQU #04035 *
=SEVENROLL	EQU #6106B *
=SEVENTEEN	EQU #04099 *
=SEVENTY	EQU #64C16 *
=SEVENTYFOUR	EQU #64C20 *
=SEVENTYNINE	EQU #64C2A *
=SIX	EQU #0402B *
=SIXROLL	EQU #61002 *
=SIXTEEN	EQU #0408F *
=SIXTY	EQU #64BB2 *
=SIXTYEIGHT	EQU #64C02 *
=SIXTYFOUR	EQU #64BDA *
=SIXTYONE	EQU #64BBC *
=SIXTYTHREE	EQU #64BD0 *
=SIXTYTWO	EQU #64BC6 *
=SIXUNROLL	EQU #610FA *
=SKIPOB	EQU #03019 =
=SLEEPxcp	EQU #42131 *
=SLOW	EQU #40EE7 *
=SPACE$	EQU #65254 *
=SPLITA	EQU #2BC4A *
=SPLTAC	EQU #2BCA0 *
=STAB0	EQU #2BE61 *
=STAB2	EQU #2BE6F *
=STCD0	EQU #2BE7D *
=STCD2	EQU #2BE8B *
=STO	EQU #07D27 *
=STO'	EQU #63975 *
=STOAPPLDATA	EQU #47467 *
=STOLAM	EQU #07D1B *
=STRIPTAGS	EQU #64775 *
=STRIPTAGSl2	EQU #647A2 *
=STRLIST	EQU #64B6C *
=SUB$	EQU #05733 *
=SUB$1#	EQU #30805 *
=SUB$SWAP	EQU #62D6D *
=SUBCOMP	EQU #05821 *
=SUBGROB	EQU #1192F *
=SUBHXS	EQU #05815 *
=SWAP	EQU #03223 *
=SWAP#-	EQU #62794 *
=SWAP#1+	EQU #62904 *
=SWAP#1+SWAP	EQU #51843 *
=SWAP#1-	EQU #637E0 *
=SWAP#1-SWAP	EQU #51857 *
=SWAP%%/	EQU #63BBE *
=SWAP%>C%	EQU #632A9 *
=SWAP&$	EQU #622EF *
=SWAP'	EQU #63939 *
=SWAP2DUP	EQU #6386C *
=SWAP3PICK	EQU #63C54 *
=SWAP4PICK	EQU #63C7C *
=SWAP4ROLL	EQU #63C2C *
=SWAPCKREF	EQU #63F7E *
=SWAPCOLA	EQU #63312 *
=SWAPDROP	EQU #60F9B *
=SWAPDROPDUP	EQU #62830 *
=SWAPDROPSWAP	EQU #6284B *
=SWAPDROPTRUE	EQU #21660 *
=SWAPDUP	EQU #62747 *
=SWAPINCOMP	EQU #631F5 *
=SWAPINDEX@	EQU #63425 *
=SWAPLOOP	EQU #6344D *
=SWAPONE	EQU #63AB0 *
=SWAPOVER	EQU #61380 *
=SWAPOVER#-	EQU #637A4 *
=SWAPROT	EQU #60F33 *
=SWAPROWS	EQU #3745E *
=SWAPTRUE	EQU #4F1D8 *
=SWAPUnDROP	EQU #638FD *
=SWAPUnNDROP	EQU #63911 *
=SWAPcompSWAP	EQU #5A01D *
=SWP1+	EQU #62904 *
=SYMBNUMSOLVE	EQU #32FF9 *
=SYMBREAL	EQU #64D38 *
=SYMBUNIT	EQU #64D56 *
=SYMCOLCT	EQU #57D90 *
=SYMEXT	EQU #64DBA *
=SYMID	EQU #64D92 *
=SYMLAM	EQU #64D9C *
=SYMOB	EQU #64D6A *
=SYMREAL	EQU #64D74 *
=SYMSYM	EQU #64DB0 *
=SYSCONTEXT	EQU #08D92 *
=SaveVarRes	EQU #640A0 *
=Seco>Menu	EQU #3A2C9 *
=SendSetup	EQU #2EEC4 *
=SetAlphaAnn	EQU #1132D *
=SetDA12Temp	EQU #3921B *
=SetDA1Temp	EQU #3902C *
=SetDA1Valid	EQU #38FD2 *
=SetDA2NoCh	EQU #3918A *
=SetDA2bValid	EQU #38FFF *
=SetDA3NoCh	EQU #39451 *
=SetDA3Valid	EQU #39018 *
=SetDA3ValidF	EQU #39301 *
=SetDAsTemp	EQU #3922F *
=SetHiddenRes	EQU #640BE *
=SetIOPARErr	EQU #2EC34 *
=SetISysFlag	EQU #539F9 *
=SetKeysNS	EQU #3FCAF *
=SetLeftAnn	EQU #11361 *
=SetRightAnn	EQU #11347 *
=SetSomeRow	EQU #3A9E7 *
=SetSysFlag	EQU #53731 *
=SetThisRow	EQU #410C6 *
=SetUserFlag	EQU #53725 *
=Sfkey1	EQU #00001 =
=Sfkey6	EQU #00006 =
=ShowInvRomp	EQU #0426A *
=Shrink$	EQU #16671 *
=Sig?ErrJmp	EQU #64190 *
=SolvMenuInit	EQU #151A6 *
=SrvcKbdAB	EQU #007B5 =
=StartupProc	EQU #3858E *
=Std/BoxLabel	EQU #3ED0C *
=StdIOPAR	EQU #2E99E *
=StdMenuKeyLS	EQU #401D4 *
=StdMenuKeyNS	EQU #4019D *
=StdPRTPAR	EQU #31F4A *
=StoHiddenVar	EQU #64078 *
=StoIOPAR	EQU #2E9CB *
=StoPRTPAR	EQU #31F7D *
=Str>Menu	EQU #3A2B5 *
=SubMetaOb	EQU #64345 *
=SubMetaOb1	EQU #643BD *
=Symb>HBuff	EQU #659DE *
=Sys@	EQU #2EA6A *
=SysITE	EQU #63EED *
=SysPtr@	EQU #08D66 *
=SysTime	EQU #0EB81 *
=TAGGED		EQU #04071 *
=TAGGEDANY	EQU #64DEC *
=TAGOBS	EQU #647BB *
=TBR	EQU #00116 =
=TCS	EQU #00112 =
=TEN	EQU #04053 *
=THIRTEEN	EQU #04071 *
=THIRTY	EQU #0411B *
=THIRTYEIGHT	EQU #0416B *
=THIRTYFIVE	EQU #0414D *
=THIRTYFOUR	EQU #04143 *
=THIRTYNINE	EQU #04175 *
=THIRTYONE	EQU #04125 *
=THIRTYSEVEN	EQU #04161 *
=THIRTYSIX	EQU #04157 *
=THIRTYTHREE	EQU #04139 *
=THIRTYTWO	EQU #0412F *
=THREE	EQU #0400D *
=THREE{}N	EQU #631CD *
=TIMEOUT?	EQU #4227F *
=TIMER2		EQU #00138 =
=TIMESTR	EQU #0D304 *
=TOADISP	EQU #1314D *
=TOD	EQU #0CBFA *
=TOP16	EQU #0E0AB *
=TOSRRP	EQU #07709 *
=TOTEMPOB	EQU #06657 *
=TOTEMPSWAP	EQU #62C69 *
=TRPACKETFAIL	EQU #2EFD7 *
=TRUE	EQU #03A81 *
=TRUE'	EQU #63989 *
=TRUEFALSE	EQU #634F7 *
=TST15	EQU #2BD76 *
=TURNMENUOFF	EQU #4E2CF *
=TURNMENUON	EQU #4E347 *
=TWELVE	EQU #04067 *
=TWENTY	EQU #040B7 *
=TWENTYEIGHT	EQU #04107 *
=TWENTYFIVE	EQU #040E9 *
=TWENTYFOUR	EQU #040DF *
=TWENTYNINE	EQU #04111 *
=TWENTYONE	EQU #040C1 *
=TWENTYSEVEN	EQU #040FD *
=TWENTYSIX	EQU #040F3 *
=TWENTYTHREE	EQU #040D5 *
=TWENTYTWO	EQU #040CB *
=TWO	EQU #04003 *
=TWO{}N	EQU #631B9 *
=TYPE	EQU #03C64 *
=TYPEARRY?	EQU #62198 *
=TYPEBINT?	EQU #6212F *
=TYPECARRY?	EQU #62256 *
=TYPECHAR?	EQU #62025 *
=TYPECMP?	EQU #62183 *
=TYPECOL?	EQU #621EC *
=TYPECSTR?	EQU #62159 *
=TYPEEXT?	EQU #6204F *
=TYPEGROB?	EQU #62201 *
=TYPEHSTR?	EQU #62144 *
=TYPEIDNT	EQU #03FA9 *
=TYPEIDNT?	EQU #6203A *
=TYPELAM?	EQU #6211A *
=TYPELIST?	EQU #62216 *
=TYPERARRY?	EQU #6223B *
=TYPEREAL	EQU #03F8B *
=TYPEREAL?	EQU #6216E *
=TYPEROMP?	EQU #621AD *
=TYPERRP?	EQU #621C2 *
=TYPESYMB?	EQU #621D7 *
=TYPETAGGED?	EQU #6222B *
=TakeOver	EQU #40788 *
=TempConv	EQU #0F41B *
=TestSysFlag	EQU #53784 *
=TestUserFlag	EQU #53778 *
=TogInsertKey	EQU #3E586 *
=TrueFalse	EQU #634F7 *
=TrueTrue	EQU #0BBED *
=TurnOff	EQU #041A7 *
=U>NCQ	EQU #0FE44 *
=UART?	EQU #42249 *
=UARTBUFLEN	EQU #3133B *
=UARTxcp	EQU #42145 *
=UM>U	EQU #0F33A *
=UMCONV	EQU #0F371 *
=UMU>	EQU #0F34E *
=UNCOERCE	EQU #18DBF *
=UNCOERCE%%	EQU #63B96 *
=UNCOERCE2	EQU #1950B *
=UNROLL	EQU #0339E *
=UNROT	EQU #60FAC *
=UNROT2DROP	EQU #6112A *
=UNROTDROP	EQU #6284B *
=UNROTDUP	EQU #62CF5 *
=UNROTOVER	EQU #6308D *
=UNROTSWAP	EQU #60F33 *
=UNROTSWAPDRO	EQU #60F0E *
=UNTIL	EQU #071C8 *
=UStackDepth	EQU #6416D *
=UnLockAlpha	EQU #40D39 *
=Unbr>U	EQU #10065 *
=UserITE	EQU #63ED9 *
=VERSTRING	EQU #30794 *
=VERYSLOW	EQU #40F02 *
=VERYVERYSLOW	EQU #40F12 *
=WHILE	EQU #071EE *
=WORDSIZE	EQU #54039 *
=WaitForKey	EQU #41F65 *
=Warmstart	EQU #01FBD *
=WithHidden	EQU #64037 *
=XEQ>ARRAY	EQU #1D054 *
=XEQSETLIB	EQU #21C6F *
=XEQSHOWLS	EQU #20B00 *
=XEQSTOID	EQU #18513 *
=XEQStoKey	EQU #40F22 *
=XEQTYPE	EQU #1CB90 *
=XHI	EQU #64D24 *
=XHI-1	EQU #64D1A *
=XOR	EQU #03ADA *
=XY>Y	EQU #60F9B *
=XYEX	EQU #2BE53 *
=XYGROBDISP	EQU #128B0 *
=XYZ>	EQU #60F4B *
=XYZ>Y	EQU #62726 *
=XYZ>YXZ	EQU #60EE7 *
=XYZ>YZ	EQU #60F21 *
=XYZ>Z	EQU #6112A *
=XYZ>ZCOLA	EQU #63326 *
=XYZ>ZTRUE	EQU #62EB7 *
=XYZ>ZX	EQU #6284B *
=XYZ>ZXY	EQU #60FAC *
=XYZ>ZY	EQU #60F0E *
=XYZ>ZYX	EQU #60F33 *
=XYZW>	EQU #60F7E *
=XYZW>W	EQU #6113C *
=XYZW>WXYZ	EQU #6109E *
=XYZW>YWZX	EQU #63C2C *
=XYZW>YZWX	EQU #60FBB *
=YMD>Ticks	EQU #0DB3A *
=ZERO	EQU #03FEF *
=ZEROFALSE	EQU #6351F *
=ZEROISTOPSTO	EQU #6400F *
=ZEROOVER	EQU #63079 *
=ZEROSWAP	EQU #62E3A *
=ZEROZERO	EQU #641FC *
=ZEROZEROONE	EQU #6431D *
=ZEROZEROTWO	EQU #64331 *
=ZEROZEROZERO	EQU #64309 *
=ZERO_DO	EQU #073C3 *
=a%>$	EQU #162B8 *
=a%>$,	EQU #162AC *
=aH>HMS	EQU #2B770 *
=aMODF	EQU #2B67D *
=allkeys	EQU #001FF =
=any		EQU #03FEF *
=apndvarlst	EQU #35491 *
=argtypeerr	EQU #00202 =
=argvalerr	EQU #00203 =
=arry		EQU #04017 *
=bit+	EQU #53EA0 *
=bit-	EQU #53EB0 *
=case	EQU #61993 *
=case2DROP	EQU #61970 *
=case2drop	EQU #6191F *
=case2drpfls	EQU #63583 *
=caseDEADKEY	EQU #63BEB *
=caseDROP	EQU #6194B *
=caseDoBadKey	EQU #63BEB *
=caseDrpBadKy	EQU #63BD2 *
=caseERRJMP	EQU #63169 *
=caseFALSE	EQU #6359C *
=caseSIZEERR	EQU #63B05 *
=caseTRUE	EQU #634E3 *
=casedrop	EQU #618F7 *
=casedrpfls	EQU #6356A *
=casedrptru	EQU #638B2 *
=cfC	EQU #10E82 *
=cfF	EQU #10E68 *
=char	EQU #64CC0 *
=cknumdsptch1	EQU #545A0 *
=clrtimeout	EQU #423D3 *
=cmp		EQU #04003 *
=constuniterr	EQU #00B02 =
=corner	EQU #137DC *
=dARRYcase	EQU #63DA3 *
=dIDNTNcase	EQU #63E07 *
=dLISTcase	EQU #63DB7 *
=dREALNcase	EQU #63E1B *
=docr	EQU #31854 *
=dostws	EQU #53CAA *
=dowait	EQU #1A7C9 *
=dowutil	EQU #0DB51 *
=dvarlsBIND	EQU #63A29 *
=failed	EQU #0BC01 *
=get1	EQU #61305 *
=getBPOFF	EQU #0D809 *
=getmatchtok	EQU #25452 *
=getnibs	EQU #6595A *
=grob		EQU #04067 *
=hxs		EQU #0405D *
=hxs>$	EQU #540BB *
=id	EQU #0402B *
=idnt	EQU #0402B *
=infreserr	EQU #00305 =
=intrptderr	EQU #00A03 =
=j%0=case	EQU #63D7B *
=jEQcase	EQU #63CD6 *
=kermpktmsg	EQU #00C10 =
=kermrecvmsg	EQU #00C0E =
=kermsendmsg	EQU #00C0D =
=lam		EQU #04035 *
=list	EQU #04021 *
=liteslp	EQU #04929 *
=makebeep	EQU #017A6 *
=matchob?	EQU #643EF *
=matchob?Lp	EQU #643F9 *
=metaROTDUP	EQU #63F1A *
=negunferr	EQU #00302 =
=nextpos	EQU #6443A *
=nmetasyms	EQU #54C63 *
=nohalt	EQU #14483 *
=nscknum2	EQU #5590E *
=nultrior	EQU #2534A *
=ofloerr	EQU #00303 =
=pZpargSWAPUn	EQU #63F92 *
=palparse	EQU #238A4 *
=palrompdcmp	EQU #62B5B *
=plDRPpZparg	EQU #63F56 *
=popflag	EQU #61A02 *
=posunferr	EQU #00301 =
=prtparerr	EQU #00C13 =
=psh	EQU #5EB1C *
=psh1&	EQU #5E706 *
=psh1&rev	EQU #5E7A5 *
=pshtop&	EQU #5E4D1 *
=pshzer	EQU #5E67A *
=pshzerpsharg	EQU #5EA9F *
=pull	EQU #5E4A9 *
=puretemp?	EQU #0F3E4 *
=putnibs	EQU #6594E *
=real	EQU #03FF9 *
=restoreiram	EQU #0C147 *
=reversym	EQU #5DE7D *
=roll2top&	EQU #63F42 *
=rolltwotop&	EQU #63F42 *
=sALLOWINTR	EQU #0000F =
=sBEG	EQU #00008 =
=sBPOFF	EQU #00004 =
=sFLUSH	EQU #00002 =
=sNEGATE	EQU #00002 =
=sTRUNC	EQU #00001 =
=seco	EQU #0403F *
=setbeep	EQU #141B2 *
=setflag	EQU #53B31 *
=settimeout	EQU #423BB *
=skipcola	EQU #626EE *
=sncknum2	EQU #558F5 *
=srvc_timer2	EQU #0131D *
=sscknum2	EQU #558DC *
=sstDISP	EQU #14C17 *
=str	EQU #0400D *
=sym	EQU #04053 *
=symb	EQU #04049 *
=symbn	EQU #5A310 *
=symcomp	EQU #5E652 *
=ticR	EQU #61B89 *
=toLEN_DO	EQU #63498 *
=tok,	EQU #65290 *
=tok-	EQU #652FC *
=tok.	EQU #6529C *
=tok0	EQU #6534C *
=tok1	EQU #65358 *
=tok8	EQU #653AC *
=tok8cktrior	EQU #0BD54 *
=tok9	EQU #653B8 *
=tok=	EQU #65308 *
=tokESC	EQU #651BE *
=tok_	EQU #65254 *
=tok_g	EQU #0FA69 *
=tok_m	EQU #0FA8E *
=tok_s	EQU #0FACE *
=tokexponent	EQU #651E2 *
=tokquote	EQU #65278 *
=toksharp	EQU #6518E *
=top&	EQU #5E415 *
=top&Cr	EQU #63F01 *
=um*	EQU #10B5E *
=um/	EQU #10B68 *
=umEND	EQU #10B86 *
=umP	EQU #10B7C *
=um^	EQU #10B72 *
=uncrunch	EQU #5A036 *
=undo	EQU #61F8F *
=unitob	EQU #0407B *
=w->W	EQU #1165A *
* =x+ EQU #1AB67 * dup
* =x<<	EQU #2361E * dup
* =x<?	EQU #1EBBE * dup
* =x>?	EQU #1EC5D * dup
* =xCON	EQU #1D186 * dup
* =xFCNAPPLY EQU #1F640 * dup
* =xFREE	EQU #213D1 * dup
* =xIFTE	EQU #1A3FE * dup
* =xMEM	EQU #20FAA * dup
* =xOBJ>	EQU #1CF7B * dup
* =xPUTI	EQU #1D5DF * dup
* =xRDM	EQU #1D0DF * dup
* =xSIZE	EQU #1C9B8 * dup
* =xSTOF	EQU #1C67F * dup
={}N	EQU #05459 *
=%11	EQU #1CC03 *
=%12	EQU #1CC1D *
=%13	EQU #1CC37 *
=%14	EQU #1CC51 *
=%16	EQU #1CD3A *
=%17	EQU #1CD54 *
=%20	EQU #1CC6B *
=%21	EQU #1CCA4 *
=%22	EQU #1CCC3 *
=%23	EQU #1CCE2 *
=%24	EQU #1CD01 *
=%25	EQU #1CD20 *
=%26	EQU #1CD73 *
=%27	EQU #1CD8D *
=LastNonNull	EQU #18621 *
=PrevNonNull	EQU #1863A *
=UPDIR	EQU #1A16F *
=CK5&Dispatch	EQU #18F12 *
=CK3NOLASTWD	EQU #18A68 *
=CK4NOLASTWD	EQU #18B9F *
=CK5NOLASTWD	EQU #18B7A *
=CK4	EQU #18B92 *
=CK5	EQU #18B6D *
=%%.1	EQU #2A562 *
=%%.4	EQU #2B3DD *
=%%.5	EQU #2A57C *
=%%0	EQU #2A4C6 *
=%%0<=	EQU #2A80B *
=%%0<>	EQU #2A7BB *
=%%0=	EQU #2A75A *
=%%0>	EQU #2A788 *
=%%0>=	EQU #2A7E3 *
=%%0<	EQU #2A727 *
=%%1/	EQU #2AA92 *
=%%10	EQU #2A596 *
=%%12	EQU #2B2DC *
=%%2	EQU #2A4FA *
=%%2PI	EQU #0F688 *
=%%3	EQU #2A514 *
=%%4	EQU #2A52E *
=%%5	EQU #2A548 *
=%%60	EQU #2B300 *
=%%7	EQU #2B1FF *
=%%<	EQU #2A81F *
=%%<=	EQU #2A8AB *
=%%>	EQU #2A87F *
=%%>=	EQU #2A895 *
=%%ABS	EQU #2A8F0 *
=%%ACOSRAD	EQU #2AD08 *
=%%ANGLE	EQU #2AD4F *
=%%ANGLEDEG	EQU #2AD6C *
=%%ANGLERAD	EQU #2AD7C *
=%%ASINRAD	EQU #2ACD8 *
=%%CHS	EQU #2A910 *
=%%COS	EQU #2AC57 *
=%%COSDEG	EQU #2AC68 *
=%%COSH	EQU #2ADC7 *
=%%COSRAD	EQU #2AC78 *
=%%EXP	EQU #2AB1C *
=%%FLOOR	EQU #2AF99 *
=%%H>HMS	EQU #2AF27 *
=%%INT	EQU #2AF99 *
=%%LN	EQU #2AB5B *
=%%LNP1	EQU #2AB94 *
=%%MAX	EQU #2A6DC *
=%%P>R	EQU #2B4C5 *
=%%R>P	EQU #2B498 *
=%%SIN	EQU #2AC06 *
=%%SINDEG	EQU #2AC17 *
=%%SINRAD	EQU #2AC27 *
=%%SINH	EQU #2AD95 *
=%%SQRT	EQU #2AAEA *
=%%TANRAD	EQU #2ACA8 *
=%%^	EQU #2AA5F *
=%-2	EQU #2A39B *
=%-3	EQU #2A3B0 *
=%-4	EQU #2A3C5 *
=%-5	EQU #2A3DA *
=%-6	EQU #2A3EF *
=%-7	EQU #2A404 *
=%-8	EQU #2A419 *
=%-9	EQU #2A42E *
=%-MINREAL	EQU #2A4B1 *
=%>%%	EQU #2A5C1 *
=%>%%-	EQU #2A95B *
=%>%%1/	EQU #2AA9E *
=%>%%ANGLE	EQU #2AD5B *
=%>%%SQRT	EQU #2AAF6 *
=%>C%	EQU #05C27 *
=%>TAG	EQU #22618 *
=%ACOSH	EQU #2AE13 *
=%ANGLE	EQU #2AD38 *
=%ASINH	EQU #2AE00 *
=%ATANH	EQU #2AE26 *
=%CEIL	EQU #2AF73 *
=%CH	EQU #2AA30 *
=%COMB	EQU #2AE62 *
=%COSH	EQU #2ADDA *
=%EXPONENT	EQU #2AE39 *
=%MANTISSA	EQU #2A930 *
=%MAX	EQU #2A6F5 *
=%MIN	EQU #2A70E *
=%MINREAL	EQU #2A49C *
=%NFACT	EQU #2AE4C *
=%NROOT	EQU #2AA81 *
=%OF	EQU #2A9C9 *
=%PERM	EQU #2AE75 *
=%RANDOMIZE	EQU #2B044 *
=%SINH	EQU #2ADAE *
=%SPH>%REC	EQU #2B4F2 *
=%T	EQU #2AA0B *
=%TANH	EQU #2ADED *
=%e	EQU #650A8 *
=2%%>%	EQU #2B470 *
=2%>%%	EQU #2B45C *
=C%>%	EQU #05D2C *
=PI/180	EQU #2A62C *
=USER$>TAG	EQU #225F5 *
=CK&DISPATCH0	EQU #18F9D *
=CENTER$3x5	EQU #1215E *
=RIGHT$3x6	EQU #1200C *
=+LOOP	EQU #073A5 *
=DISPROW6	EQU #124AB *
=DOPKT	EQU #2E8D1 *
=DoLabel	EQU #41904 *
=GETNAME	EQU #2E7EF *
=SENDLIST	EQU #2E6EB *
=XEQIOBACKUP	EQU #21B5A *
=VARSIZE	EQU #1A265 *
=XEQPGDIR	EQU #18595 *
=tok{	EQU #65176 *
=MDIMS	EQU #357A8 *
=PULLCMPEL	EQU #355C8 *
=PUTCMPEL	EQU #356F3 *
=CKNNOLASTWD	EQU #18C4A *
=CK&DISPATCH1	EQU #18FB2 *
=CHR_DblQuote	EQU #6542C *
=CHR_/	EQU #6545D *
=CHR_1	EQU #6546B *
=CHR_2	EQU #65472 *
=CHR_3	EQU #65479 *
=CHR_4	EQU #65480 *
=CHR_5	EQU #65487 *
=CHR_6	EQU #6548E *
=CHR_7	EQU #65495 *
=CHR_8	EQU #6549C *
=CHR_9	EQU #654A3 *
=CHR_<	EQU #654B8 *
=CHR_=	EQU #654BF *
=CHR_>	EQU #654C6 *
=CHR_A	EQU #654CD *
=CHR_B	EQU #654D4 *
=CHR_C	EQU #654DB *
=CHR_E	EQU #654E9 *
=CHR_G	EQU #654F7 *
=CHR_H	EQU #654FE *
=CHR_I	EQU #65505 *
=CHR_J	EQU #6550C *
=CHR_K	EQU #65513 *
=CHR_L	EQU #6551A *
=CHR_M	EQU #65521 *
=CHR_N	EQU #65528 *
=CHR_O	EQU #6552F *
=CHR_P	EQU #65536 *
=CHR_Q	EQU #6553D *
=CHR_T	EQU #65552 *
=CHR_U	EQU #65559 *
=CHR_V	EQU #65560 *
=CHR_W	EQU #65567 *
=CHR_X	EQU #6556E *
=CHR_Y	EQU #65575 *
=CHR_a	EQU #65583 *
=CHR_b	EQU #6558A *
=CHR_d	EQU #65598 *
=CHR_e	EQU #6559F *
=CHR_f	EQU #655A6 *
=CHR_g	EQU #655AD *
=CHR_h	EQU #655B4 *
=CHR_i	EQU #655BB *
=CHR_j	EQU #655C2 *
=CHR_l	EQU #655D0 *
=CHR_q	EQU #655F3 *
=CHR_r	EQU #655FA *
=CHR_s	EQU #65601 *
=CHR_t	EQU #65608 *
=CHR_u	EQU #6560F *
=CHR_v	EQU #65616 *
=CHR_w	EQU #6561D *
=CHR_x	EQU #65624 *
=CHR_y	EQU #6562B *
=CHR_z	EQU #65632 *
=CHR_<<	EQU #65640 *
=CHR_>>	EQU #65647 *
=CHR_Angle	EQU #6564E *
=CHR_Deriv	EQU #65655 *
=CHR_Integral	EQU #6565C *
=CHR_Pi	EQU #65671 *
=CHR_Sigma	EQU #6567F *
=CHR_UndScore	EQU #6568D *
=CHR_]	EQU #6569B *
=CHR_{	EQU #656A2 *
=CHR_}	EQU #656A9 *
=CHR_<=	EQU #656B0 *
=CHR_>=	EQU #656B7 *
=CHR_<>	EQU #656BE *
=$_R<<	EQU #656C5 *
=$_R<Z	EQU #656D5 *
=$_XYZ	EQU #656E5 *
=$_<<>>	EQU #656F5 *
=$_{}	EQU #65703 *
=$_''	EQU #6571F *
=$_::	EQU #6572D *
=$_LRParens	EQU #6573B *
=$_2DQ	EQU #65749 *
=$_ECHO	EQU #65757 *
=$_Undefined	EQU #6577B *
=CHR_[	EQU #65694 *
=$_[]	EQU #65711 *
=Clr8	EQU #0E083 *
=Clr8-15	EQU #0E097 *
=TOP8	EQU #0E0D3 *
=Rows8-15	EQU #0E0FB *
=HBUFF_X_Y	EQU #0E128 *
=WINDOWCORNER	EQU #137B6 *
=DISPROW2*	EQU #12748 *
=COERCE$22	EQU #12770 *
=SEP$NL	EQU #127A7 *
=BIGDISPN	EQU #123C8 *
=BIGDISPROW4	EQU #123E5 *
=BIGDISPROW3	EQU #123F5 *
=BIGDISPROW2	EQU #12405 *
=BIGDISPROW1	EQU #12415 *
=TOGDISP	EQU #13135 *
=FlashMsg	EQU #12B85 *
=SmallCursor	EQU #66EF1 *
=MARKGROB	EQU #5055A *
=CURSOR2	EQU #13DB4 *
=CKGROBFITS	EQU #4F7E6 *
=LINEOFF3	EQU #50ACC *
=TOGLINE3	EQU #50ADB *
=LINEON3	EQU #50AEA *
=TOGLINE	EQU #50AF9 *
=LINEOFF	EQU #50B08 *
=Id>Menu	EQU #3A2DD *
=HARDBUFF2	EQU #12645 *
=DoCRCc	EQU #0597E *
=DoCRC	EQU #05981 *
=EditLevel1	EQU #42D32 *
=ViewLevel1	EQU #42D46 *
=CharEdit	EQU #42D82 *
=ObEdit	EQU #42DC8 *
=DOFINISH	EQU #2E876 *
=DOTRANSIO	EQU #2ED10 *
=DOBAUD	EQU #2EC84 *
=DOPARITY	EQU #2ECCA *
=DOKERRM	EQU #2EDA6 *
=AND$	EQU #18873 *
=ERRORCLR	EQU #04D33 *
=XOR$	EQU #1889B *
=CHECKPICT	EQU #51166 *
=DOERASE	EQU #4B60C *
=DRAWBOX#	EQU #4E582 *
=WINDOW#	EQU #4F052 *
=Wait/GetKey	EQU #1A738 *
=XEQRCL	EQU #20B81 *
=GBUFFGROBDIM	EQU #5187F *
=ORDERXY#	EQU #51893 *
=ORDERXY%	EQU #518CA *
=TRCXY	EQU #2B53D *
=SENDPKT	EQU #2E0F4 *
=ENCODE	EQU #30BD7 *
=DOSBRK	EQU #2EE18 *
=UNIT>$	EQU #0F218 *
=UM=?	EQU #0F584 *
=UM#?	EQU #0F598 *
=UM<?	EQU #0F5AC *
=UM>?	EQU #0F5C0 *
=UM<=?	EQU #0F5D4 *
=UM>=?	EQU #0F5E8 *
=UMABS	EQU #0F5FC *
=UMCHS	EQU #0F615 *
=UMSIN	EQU #0F62E *
=UMCOS	EQU #0F660 *
=UMTAN	EQU #0F674 *
=UM+	EQU #0F6A2 *
=UM-	EQU #0F774 *
=UM/	EQU #0F823 *
=UMXROOT	EQU #0F8FA *
=UMSI	EQU #0F945 *
=UMMAX	EQU #0FB6F *
=UMMIN	EQU #0FB8D *
=UM%	EQU #0FBAB *
=UM%CH	EQU #0FC3C *
=UM%T	EQU #0FCCD *
=UMSIGN	EQU #0FCE6 *
=UMIP	EQU #0FCFA *
=UMFP	EQU #0FD0E *
=UMFLOOR	EQU #0FD22 *
=UMCEIL	EQU #0FD36 *
=UMTRC	EQU #0FD8B *
=UM*	EQU #0F792 *
=UMSQ	EQU #0F913 *
=UMSQRT	EQU #0F92C *
=XEQORDER	EQU #20FF2 *
=PICTRCL	EQU #20CAD *
=LISTRCL	EQU #20B9A *
=XEQPURGEPICT	EQU #20F8A *
=GetMenu%	EQU #415C9 *
=C%0	EQU #524AF *
=C%1	EQU #524F7 *
=C%%1	EQU #5193B *
=C%-1	EQU #5196A *
=C>Re%	EQU #519A3 *
=C>Im%	EQU #519B7 *
=C%>%%	EQU #519CB *
=C%>%%SWAP	EQU #519DF *
=C%%>C%	EQU #519F8 *
=Re>C%	EQU #51A37 *
=C%%0=	EQU #51B2A *
=C%0=	EQU #51B43 *
=C%CHS	EQU #51B70 *
=C%%CHS	EQU #51B91 *
=C%CONJ	EQU #51BB2 *
=C%%CONJ	EQU #51BC1 *
=C%1/	EQU #51EFA *
=C%ABS	EQU #52062 *
=C%ARG	EQU #52099 *
=C%SGN	EQU #520CB *
=C%SQRT	EQU #52107 *
=C%EXP	EQU #52193 *
=C%LN	EQU #521E3 *
=C%LOG	EQU #522BF *
=C%ALOG	EQU #52305 *
=C%R^C	EQU #52342 *
=C%C^R	EQU #52360 *
=C%C^C	EQU #52374 *
=C%SIN	EQU #52530 *
=C%COS	EQU #52571 *
=C%TAN	EQU #525B7 *
=C%SINH	EQU #5262F *
=C%COSH	EQU #52648 *
=C%TANH	EQU #5265C *
=C%ASIN	EQU #52804 *
=C%ACOS	EQU #52863 *
=C%ATAN	EQU #52675 *
=C%ASINH	EQU #5281D *
=C%ACOSH	EQU #52836 *
=C%ATANH	EQU #527EB *
=C%%>%%	EQU #05DBC *
=%%>C%	EQU #51A07 *
=HXS>%	EQU #5435D *
=HXS#HXS	EQU #544EC *
=HXS>=HXS	EQU #5452C *
=HXS<=HXS	EQU #5453F *
=HXS<HXS	EQU #54552 *
=bitAND	EQU #53D04 *
=bitOR	EQU #53D15 *
=bitXOR	EQU #53D26 *
=bitNOT	EQU #53D4E *
=bitSL	EQU #53D5E *
=bitSLB	EQU #53D6E *
=bitSR	EQU #53D81 *
=bitSRB	EQU #53D91 *
=bitRR	EQU #53DA4 *
=bitRRB	EQU #53DE1 *
=bitRL	EQU #53E0C *
=bitRLB	EQU #53E3B *
=bitASR	EQU #53E65 *
=bit%#/	EQU #5429F *
=bit#%/	EQU #542BD *
=bit%#-	EQU #542FE *
=bit#%-	EQU #5431C *
=bit%#+	EQU #54330 *
=bit#%+	EQU #54349 *
=bit%#*	EQU #542D1 *
=bit#%*	EQU #542EA *
=bit/	EQU #53F05 *
=bit*	EQU #53ED3 *
=PIXON3	EQU #13825 *
=PIXOFF3	EQU #1380F *
=PIXON?	EQU #13992 *
=PIXON?3	EQU #13986 *
=%-1=case	EQU #5F267 *
=%2=case	EQU #5F1EA *
=AEQ1stcase	EQU #5EF15 *
=AEQopscase	EQU #5F048 *
=COMPEVAL	EQU #18EBA *
=CREATE	EQU #08696 *
=M-1stcasechs	EQU #5EE10 *
=MEQ1stcase	EQU #5EFD9 *
=MEQopscase	EQU #5EFF9 *
=Mid1stcase	EQU #5F061 *
=NOTLISTcase	EQU #27244 *
=NOTROMPcase	EQU #27264 *
=NOTSECOcase	EQU #27254 *
=R>	EQU #0701F *
=R@	EQU #07012 *
=RDUP	EQU #14EA5 *
=RPIT	EQU #070FD *
=RPITE	EQU #070C3 *
=SKIP	EQU #0714D *
=delimcase	EQU #2512D *
=idntcase	EQU #5F0AA *
=idntlamcase	EQU #5F0CD *
=metatail	EQU #28296 *
=need'case	EQU #255FB *
=nonopcase	EQU #5E984 *
=num-1=case	EQU #5F23A *
=num0=case	EQU #5F0FA *
=num1=case	EQU #5F154 *
=num2=case	EQU #5F1BD *
=pixon2	EQU #138CA *
=psh&	EQU #5E3AC *
=pullpsh1&	EQU #5E4EA *
=pullrev	EQU #5E4BD *
=tok8trior	EQU #0BD60 *
=tok=casedrop	EQU #2856C *
=!*triand	EQU #0BCCF *
=!*trior	EQU #0BC6F *
=DO%EXIT	EQU #15007 *
=DO#EXIT	EQU #1502F *
=IntDiv	EQU #03F24 *
=clkspd	EQU #018E2 *
=CK1NoBlame	EQU #1592D *
=DoKeyOb	EQU #40454 *
=SysMenuCheck	EQU #3866F *
=SysDisplay	EQU #386A1 *
=SetEcma94	EQU #3252B *
=makegrob	EQU #115B3 *
=ClrDA1OK	EQU #390CC *
=DA1OK?	EQU #38DAC *
* =x*	EQU #1ADEE * dup
=portnotaverr	EQU #0000A =
=Date>d$	EQU #0CFD9 *
=TOD>t$	EQU #0D06A *
=CROSS_HAIRS	EQU #4DA0D *
=CROSS_OFF	EQU #4DA76 *
=GetRes	EQU #4B7D8 *
=NEWINDEP	EQU #4C09B *
=NEXTSTEP	EQU #4BFAE *
=PLOTERR	EQU #4B6D9 *
=PLOTPREP	EQU #4B765 *
=RESETDEPTH	EQU #4B710 *
=!#1+IF<dim-1	EQU #50E59 *
=!#1-IF>0	EQU #50EA5 *
=!DcompWidth	EQU #1795A *
='IDFUNCTION	EQU #5129C *
='IDPARAMETER	EQU #512D8 *
='IDPOLAR	EQU #512C4 *
='IDX	EQU #4744F *
=0LASTOWDOB!	EQU #1884D *
=1A/LockA	EQU #3AA0A *
=1REV	EQU #514DC *
=1stkdecomp$w	EQU #15978 *
=4NULLLAM{}	EQU #52D26 *
=?DispMenu	EQU #3A1CA *
=?OKINALG	EQU #26A2D *
=?PURGE_HERE	EQU #1854F *
=?TogU/LCase	EQU #448C1 *
=ALGeq?	EQU #1568F *
=ATTNFLG@	EQU #05040 *
=AUTOSCALE	EQU #491D5 *
=AppDisplay!	EQU #38C08 *
=AppError!	EQU #38C98 *
=AppExitCond!	EQU #38C68 *
=AppKeys!	EQU #38C38 *
=BOTROW	EQU #515B4 *
=BlankDA1	EQU #3A546 *
=BlankDA2a	EQU #3A591 *
=Box/StdLbl:	EQU #3ECB2 *
=CHECKMENU	EQU #4E266 *
=CHECKPVARS	EQU #4A9AF *
=CLEARMENU	EQU #51125 *
=CROSSMARKON	EQU #4ECAD *
=CRUNCHNoBlam	EQU #15941 *
=CURRENTMARK?	EQU #4E442 *
=CkEQUtil	EQU #49C54 *
=ClrAppSuspOK	EQU #38D9B *
=DA1OK?NOTIT	EQU #38F28 *
=DA2aOK?NOTIT	EQU #38F41 *
=DA2bOK?NOTIT	EQU #38F5A *
=DA3OK?NOTIT	EQU #38F73 *
=DISPCOORD2	EQU #4A055 *
=DOSTOE	EQU #15717 *
=DRAWLINE#3	EQU #50758 *
=DROPDEADTRUE	EQU #4D11E *
=DispCoord1	EQU #4E6EF *
=DispEditLine	EQU #3A00D *
=EDITLINE$	EQU #44683 *
=EDITPARTS	EQU #44730 *
=EQCURSOR?	EQU #4E46A *
=EQUATION	EQU #15744 *
=EVALCRUNCH	EQU #1583C *
=EXITFCNsto	EQU #4CE4C *
=EchoChrKey	EQU #42AE4 *
=EditMenu	EQU #3BDFA *
=EditString	EQU #443CB *
=ExitFcn	EQU #4CF68 *
=FcnUtilEnd	EQU #49BA5 *
=GDISPCENTER	EQU #4CF05 *
=GETINDEP	EQU #4AF63 *
=GETPMIN&MAX	EQU #4B0DA *
=GETPTYPE	EQU #4B062 *
=GETRES	EQU #4AFDB *
=GETRHS	EQU #514AF *
=GETXMAX	EQU #4B139 *
=GETXMIN	EQU #4B10C *
=GETXPOS	EQU #505C6 *
=GETYMAX	EQU #4B14D *
=GETYMIN	EQU #4B120 *
=GETYPOS	EQU #5068D *
=GetEqN	EQU #4A0AA *
=GraphicExit	EQU #4CEE7 *
=HSCALE	EQU #4B5AD *
=ICMPDRPRTDRP	EQU #4A95A *
=INDEPVAR	EQU #510AD *
=ISTOP-INDEX	EQU #5182F *
=IStackKey	EQU #3E5CD *
=InitEd&Modes	EQU #44277 *
=InitEdLine	EQU #4428B *
=InitEdModes	EQU #44394 *
=InputLAttn	EQU #43200 *
=Key>U/SKeyOb	EQU #3FA57 *
=LASTPT?	EQU #50D78 *
=LEFTCOL	EQU #515FA *
=MAKEPICT#	EQU #4B323 *
=MAKEPVARS	EQU #4AAEA *
=MENUOFF	EQU #4E2AC *
=MENUOFF?	EQU #4E360 *
=NDROPFALSE	EQU #169A5 *
=NEWMARK	EQU #4E4B0 *
=NoExitAction	EQU #3EC85 *
=PREMARKON	EQU #4E497 *
=PUTINDEP	EQU #4AF77 *
=PUTINDEPLIST	EQU #4AF8B *
=PUTPTYPE	EQU #4B076 *
=PUTRES	EQU #4B012 *
=PUTXMAX	EQU #4B1AC *
=PUTXMIN	EQU #4B166 *
=PUTYMAX	EQU #4B1CF *
=PUTYMIN	EQU #4B189 *
=Parse.1	EQU #40AD9 *
=ParseFail	EQU #40B2E *
=PlotOneMore?	EQU #50DA5 *
=PointDerivUt	EQU #49AD3 *
=PointMoveCur	EQU #49F06 *
=PtoR	EQU #5133C *
=RAD?	EQU #53BDD *
=RECORDX&YC%	EQU #510D5 *
=RIGHTCOL	EQU #5160E *
=RootUtil	EQU #49BD2 *
=SETLOOPENV	EQU #4CF41 *
=SORTASLOW	EQU #48FF9 *
=SYMBN	EQU #0546D *
=SYMBWHERE	EQU #547B5 *
=SYMSHOW	EQU #58D75 *
=SetAlgEntry	EQU #53976 *
=SetAppMode	EQU #38D09 *
=SetCursor	EQU #4325A *
=SetDA2aValid	EQU #38FEB *
=SetDoStdKeys	EQU #38D5D *
=SetNAppKeyOK	EQU #38D33 *
=SetPrgmEntry	EQU #11533 *
=StartMenu	EQU #41008 *
=TIMER1	EQU #00137 =
=TOGGLELINE#3	EQU #5072B *
=TOPROW	EQU #515A0 *
=TurnOffKey	EQU #3A9CE *
=U>nbr	EQU #10047 *
=VSCALE	EQU #4B553 *
=WINDOWBOT?	EQU #51645 *
=WINDOWLEFT?	EQU #5165E *
=WINDOWRIGHT?	EQU #51677 *
=WINDOWTOP?	EQU #5162C *
=YHI	EQU #64BDA *
=Z-BOX	EQU #4E776 *
=drax	EQU #4C639 *
=ederr	EQU #15A40 *
=getxpos	EQU #505E4 *
=getypos	EQU #506AB *
=rstfmt1	EQU #15A60 *
=savefmt1	EQU #15A8B *
=stkdecomp$w	EQU #159EB *
=tok'	EQU #65284 *
=tok->	EQU #25446 *
=tok<<	EQU #651D6 *
* =x-	EQU #1AD09 * dup
* =xFUNCTION	EQU #1E661 * dup
* =xPARAMETRIC	EQU #1E6C1 * dup
* =xPOLAR	EQU #1E6A1 * dup
=SetServMode	EQU #2D9A1 *
=ATTNERR	EQU #64FC2 *
=CLOSEUART	EQU #315C6 *
=GPErrjmpC	EQU #10F40 *
=2DropBadKey	EQU #3FDBD *
=DropBadKey	EQU #3FDC7 *
=0LastRomWrd!	EQU #1884D *
=SavPtrTime*	EQU #01307 =
=ECUSER	EQU #039EF *
=MOVEDSD	EQU #06A1D *
=MOVEDSU	EQU #069C5 *
=MOVERSD	EQU #06992 *
=MOVERSU	EQU #06A53 *
=DOSYMB	EQU #02AB8 =
=UNDO_ON	EQU #538CE *
=UNDO_OFF	EQU #538DC *
=UNDO_ON?	EQU #538C0 *
=GETTEMP	EQU #039BE *
=CRC	EQU #00104 =
=MEMERR	EQU #03FF9 *
=CRER	EQU #00113 =
=RBR	EQU #00114 =
=RCS	EQU #00111 =
=CloseUart	EQU #315F9 *
=GETSCALE	EQU #4ADB0 *
=PUTSCALE	EQU #4AE3C *

=GetStrLenC	EQU #2FFB7 *
=SAFESKIPOB	EQU #0A532 *
=mpop1%	EQU #0D8AE *
=CKTIME	EQU #0D9C7 *
=?DispStatus	EQU #3959C *
=DispStatus	EQU #395BA *
=EXCHINITPK	EQU #2D517 *
=>HCOMP	EQU #052C6 *
=MenuRow!	EQU #41848 *
=OCRC%	EQU #1A1FC *
=RDROPFALSE	EQU #5DE55 *
=STATCLST	EQU #2C22F *
=STATMEAN	EQU #2C571 *
=STATN	EQU #2C535 *
=STATSADD%	EQU #2C2D9 *
=STATSMAX	EQU #2C558 *
=STATSMIN	EQU #2C58A *
=STATSTDEV	EQU #2C5A3 *
=STATTOT	EQU #2C5BC *
=STATVAR	EQU #2C5D5 *
=psh1top&	EQU #5E401 *
* =x/	EQU #1AF05 * dup
* =x^	EQU #1B02D * dup
=APNDCRLF	EQU #2E4DC *
=DropSysErr$	EQU #2DDC4 *
=GETKP	EQU #307E2 *
=LAMKLIST	EQU #2D45A *
=LAMKP	EQU #2D3EE *
=LAMOBJ	EQU #2D40E *
=LAMOPOS	EQU #2D41D *
=LAMPACKET	EQU #2D3B1 *
=DoPlotMenu	EQU #3ADED *
=GetKeyOb	EQU #4203C *
=InitSysUI	EQU #385E8 *
=SysErrorTrap	EQU #38728 *
=VLM	EQU #17B86 *
=1GETLAMSWP1+	EQU #55288 *
=xsngeneral	EQU #5611F *
=xnsgeneral	EQU #56101 *
=xssgeneral	EQU #560ED *
=DOCR	EQU #31868 *
=LastMenuDef@	EQU #419F4 *
=LastMenuRow@	EQU #41881 *
=LastMenuDef!	EQU #419E4 *
=LastMenuRow!	EQU #4186E *
=C%>#	EQU #4F408 *
=%9	EQU #2A371 *
=EditLExists?	EQU #53A4A *
=AlgEntry?	EQU #53968 *
=AlgEntryStat	EQU #3981B *
=AngleStatus	EQU #39673 *
=BAK>OB	EQU #0948E *
=BAKNAME	EQU #081D9 *
=Blank&GROB!	EQU #39632 *
=ClrDA2aBad	EQU #394B3 *
=ClrDA2OK	EQU #39117 *
=ComVecStatus	EQU #396C8 *
=DA2aBad?	EQU #39497 *
=DispStsBound	EQU #39B0A *
=EXITMSGSTO	EQU #04E37 *
=GETPARAM	EQU #4B364 *
=GetUserKeys	EQU #41F3F *
=InitTrack:	EQU #41741 *
=KeyOb!	EQU #40A6F *
=KeyOb@	EQU #40A82 *
=PrgmEntrStat	EQU #39853 *
=PrgmEntry?	EQU #11511 *
=SetDA123NoCh	EQU #391EE *
=SetDA12NoCh	EQU #3919E *
=SetDA1Bad	EQU #3947B *
=SetDA1IsStat	EQU #39523 *
=SetDA2aBad	EQU #394A5 *
=SetDA2OKTemp	EQU #39207 *
=SetDA2Valid	EQU #3915D *
=SetNoRollDA2	EQU #3957A *
=WINDOWDOWN	EQU #13220 *
=WINDOWLEFT	EQU #134E4 *
=WINDOWRIGHT	EQU #1357F *
=WINDOWUP	EQU #131C8 *
=WINDOWXY	EQU #13679 *
=MENP&FixDA12	EQU #390B3 *
=SetRebuild	EQU #417F3 *
=SYNTAXERR	EQU #10F86 *
=UserFlagStat	EQU #39748 *
=UserKeysStat	EQU #397BB *
=?DispStack	EQU #39B85 *
=DISPROW8	EQU #124CB *
=NEXTLIBBAK	EQU #0AB82 *
=SaveLastMenu	EQU #4139B *
=AppMode?	EQU #38CFB *
=DoNewMatrix	EQU #44C31 *
=DoOldMatrix	EQU #44FE7 *
=OFFSRRP	EQU #076AE *
=SETMESG	EQU #0764E *
=InitEnab	EQU #0970A *
=ADDF	EQU #2B7DC *
=CLKUTL1	EQU #0D7A1 *
=ALARMS@	EQU #0E235 *
=STOALM	EQU #0E6ED *
=FindNext	EQU #0EBD5 *
=Date>hxs13	EQU #0EE50 *
=DOECMP	EQU #0299D =
=DOLNKARRY	EQU #02A0A =
=DORRP	EQU #02A96 =
=DOTAG	EQU #02AFC =
=DOBAK	EQU #02B62 =
=DOEXT1	EQU #02BAA =
=DOEXT2	EQU #02BCC =
=DOEXT3	EQU #02BEE =
=DOEXT4	EQU #02C10 =
=SETPORTNOTAV	EQU #04FF2 *
=DIV5	EQU #06A8E *
=ROMPTR>#	EQU #08CCC *
=DISPCHAR+PC	EQU #13B51 *
=cursorblink+	EQU #13D28 *
=cursorblink-	EQU #13D55 *
=CURSOR_OFF	EQU #13E85 *
=editdecomp$w	EQU #15B31 *
=longhxs	EQU #15E83 *
=addtics	EQU #1605F *
=stackitw	EQU #1686A *
=DcompWidth@	EQU #17980 *
=NEXTRRPOB	EQU #179D0 *
=FixRRP	EQU #17ADB *
=DOSIZEERR	EQU #18CA7 *
=SETSTACKERR	EQU #18CC2 *
=OB>BAKcode	EQU #216D8 *
=GetBVars	EQU #21922 *
={}>DIR	EQU #24EA6 *
=newBASE	EQU #25632 *
=convertbase	EQU #256E4 *
=Extobcode	EQU #25C41 *
=realPAcode	EQU #265ED *
=SETIVLERR	EQU #29DFC *
=DoWarning	EQU #38908 *
=POLErrorTrap	EQU #38B45 *
=AppDisplay@	EQU #38C18 *
=AppKeys0	EQU #38C58 *
=AppExitCond@	EQU #38C78 *
=AppError@	EQU #38CAB *
=ClrAppMode	EQU #38D17 *
=SetAppSuspOK	EQU #38D8A *
=DA2aLess1OK?	EQU #38FB9 *
=SetDA2aEcho	EQU #39086 *
=SetDA23NoCh	EQU #391B2 *
=SetDA13NoCh	EQU #391C6 *
=SetDA2bNoCh	EQU #39427 *
=DA1Bad?	EQU #3946D *
=ClrDA1Bad	EQU #39489 *
=ClrNoRollDA2	EQU #3958B *
=?RollUpDA2	EQU #39BF3 *
=DA2bNoCh?	EQU #39419 *
=ClrDA2bNoCh	EQU #39435 *
=LINESOFSTACK	EQU #39F6F *
=AbbrevStack?	EQU #39FB0 *
=SetAbbrevStk	EQU #39FC1 *
=ClrAbbrevStk	EQU #39FD2 *
=Echo2Macros	EQU #3EE47 *
=?Key>UKeyOb	EQU #3FA7A *
=ModifierKey?	EQU #3FE7B *
=SystemLevel?	EQU #40792 *
=KeyOb0	EQU #40A95 *
=SaveLastEdit	EQU #40C76 *
=CMDSTO	EQU #40C94 *
=CacheStack	EQU #40CE9 *
=DoMenuKey	EQU #40DC0 *
=?ClrAlg	EQU #40E3D *
=?ClrAlgSetPr	EQU #40E5B *
=CheckMenuRow	EQU #41111 *
=MenuKeyNS@	EQU #41924 *
=DoMenuKeyNS	EQU #41934 *
=UserKeys?	EQU #41A8D *
=DCursor	EQU #424DA *
=LCursor	EQU #4256B *
=UCursor	EQU #42660 *
=LastERow?	EQU #426F1 *
=TopERow?	EQU #4272D *
=Echo$Key	EQU #42BD4 *
=CkChr00	EQU #42C3D *
=Roll&Do:	EQU #42E27 *
=Rcl&Do:	EQU #42E86 *
=DispILPrompt	EQU #430CF *
=CURSOR_END?	EQU #444A5 *
=Char>Edit	EQU #444EE *
=NoEditLine?	EQU #4488A *
=ROWNUM	EQU #4489E *
=HISTON?	EQU #53860 *
=ClrAlgEntry	EQU #53984 *
=REPLACE_MODE	EQU #53A20 *
=INSERT_MODE	EQU #53A2E *
=INSERT?	EQU #53A3C *
=ClrNewEditL	EQU #53A90 *
=BASE	EQU #54050 *
=P{}N	EQU #5E0DA *
=DOBIND	EQU #074E4 *
=CK&DISPATCH2	EQU #18FA9 *
=ngsizecase	EQU #255BD *
=check_pdata	EQU #27D00 *
=nextsym'R	EQU #29A8D *
=subpdcdptch	EQU #29BC2 *
=COLAthexFCN	EQU #5573D *
=numb1stcase	EQU #5EDFC *
=C%0=case	EQU #5F13B *
=C%1=case	EQU #5F19F *
=C%2=case	EQU #5F208 *
=C%-1=case	EQU #5F285 *
=Cursor&Disp	EQU #427AF *

*************************************************************************
*	
*	Here are variants of TakeOver used to mark keys.
*	
*************************************************************************

=Modifier	EQU #4085A *
=MenuMaker	EQU #407FB *
=MenuKey	EQU #40828 *
=DoDelim	EQU #40DD4 *
=DoDelims	EQU #40DF7 *

=NULLID	EQU #15777 *
=MenuDef@	EQU #418A4 *
=SetDA2bBad	EQU #394CF *
=ClrDA2bBad	EQU #394DD *
=SetDA3Bad	EQU #394F9 *

=PvarsC%0	EQU #4AB2A *
=ID_X		EQU #4AB1C *
=ID_Y		EQU #4AB59 *

*** BANKMTHDS and JumpTable Locations **********************************
=BANKMTHDS	EQU #70601 *
=COPYVAR	EQU #7DF87 *
=D/D*		EQU #7DBE2 *
=D/D+		EQU #7DBED *
=D/D-		EQU #7DBF8 *
=D/D/		EQU #7DC03 *
=D/D=		EQU #7DC72 *
=D/DABS		EQU #7DC7D *
=D/DACOS	EQU #7DCA1 *
=D/DACOSH	EQU #7DCAC *
=D/DALOG	EQU #7DCB7 *
=D/DAPPLY	EQU #7DE1C *
=D/DARG		EQU #7DCC2 *
=D/DASIN	EQU #7DCCD *
=D/DASINH	EQU #7DCD8 *
=D/DATAN	EQU #7DCE3 *
=D/DATANH	EQU #7DCEE *
=D/DCHS		EQU #7DCF9 *
=D/DCONJ	EQU #7DD17 *
=D/DCOS		EQU #7DD35 *
=D/DCOSH	EQU #7DD40 *
=D/DDER		EQU #7DDF0 *
=D/DEXP		EQU #7DD4B *
=D/DEXPM1	EQU #7DD4B *
=D/DIFTE	EQU #7DD82 *
=D/DINTEGRAL	EQU #7DE06 *
=D/DINV		EQU #7DD56 *
=D/DLN		EQU #7DD61 *
=D/DLNP1	EQU #7DD6C *
=D/DLOG		EQU #7DD77 *
=D/DSIN		EQU #7DD8D *
=D/DSINH	EQU #7DD98 *
=D/DSQ		EQU #7DDA3 *
=D/DSQRT	EQU #7DDAE *
=D/DSUM		EQU #7DE11 *
=D/DTAN		EQU #7DDB9 *
=D/DTANH	EQU #7DDC4 *
=D/DWHERE	EQU #7DDFB *
=D/D^		EQU #7DDCF *
=D/D^X		EQU #7DDDA *
=D/D^Y		EQU #7DDE5 *
=D/Dalg=	EQU #7DC72 *
=MANMENU*/	EQU #7DF0E *
=MANMENU+-	EQU #7DF03 *
=MANMENUATG	EQU #7DF66 *
=MANMENUCSIV	EQU #7DF3A *
=MANMENUCX	EQU #7DF50 *
=MANMENUEQ	EQU #7DF45 *
=MANMENUEXP	EQU #7DF24 *
=MANMENULN	EQU #7DF2F *
=MANMENUTRG	EQU #7DF5B *
=MANMENU^	EQU #7DF19 *
=MOVEVAR	EQU #7DF7C *
=PTYPE>PINFO	EQU #7DF71 *
=SPLITWHERE	EQU #7DEF8 *
=derprod1	EQU #7DC54 *
=derquot	EQU #7DC0E *
=easyabs	EQU #7DC88 *
=nCOLCTQUOTE	EQU #7DEED *
=nCustomMenu	EQU #7DEE2 *
=nINTGACOS	EQU #7DEA0 *
=nINTGALOG	EQU #7DECC *
=nINTGASIN	EQU #7DE95 *
=nINTGATAN	EQU #7DEAB *
=nINTGCOS	EQU #7DE5E *
=nINTGCOSH	EQU #7DE7F *
=nINTGEXPM	EQU #7DED7 *
=nINTGINV	EQU #7DE27 *
=nINTGLN	EQU #7DEB6 *
=nINTGLOG	EQU #7DEC1 *
=nINTGSIGN	EQU #7DE32 *
=nINTGSIN	EQU #7DE53 *
=nINTGSINH	EQU #7DE74 *
=nINTGSQ	EQU #7DE48 *
=nINTGSQRT	EQU #7DE3D *
=nINTGTAN	EQU #7DE69 *
=nINTGTANH	EQU #7DE8A *
=nWHEREDER	EQU #7DBAB *
=nWHEREFCNAPP	EQU #7DBD7 *
=nWHEREIFTE	EQU #7DBA0 *
=nWHEREINTG	EQU #7DBB6 *
=nWHERESUM	EQU #7DBC1 *
=nWHEREWHERE	EQU #7DBCC *

**New and Revised Library handling utilities**
=SETHASH	EQU #07638 *
=SETROMPART	EQU #21CBA *
=?ACCPTR>	EQU #715B1 *
=rGETATELN	EQU #0C506 *
=RPTRACC	EQU #71DB2 *
=rNTHELCOMP	EQU #71C3B *
 
**=SET added to assist in bug work-around**
=SET		EQU #07661 *
=H/WKey>KeyOb	EQU #3FE26 *
=NOBLINK	EQU #538F8 *
=?BlinkCursor	EQU #42078 *
=DOEREL	EQU #02955 =
=DoHere:	EQU #185C7 *
=NUMSOLVE	EQU #3303F *
=SetDA1NoCh	EQU #393D3 *
=SetDA2aNoCh	EQU #393FD *
=ChkGrHook	EQU #32CAF *
=SETROMPERR	EQU #05016 *
=SetDA2aTemp	EQU #39045 *
=CKPICT	EQU #51148 *
* =rpnXROOT	EQU #1B185 * dup
=NULLCOMP?	EQU #055B7 *
=PUSHhxs	EQU #5422C *
=Echo$NoChr00	EQU #42BB6 *
=SETNONEXTERR	EQU #18C92 *
=VerifyTOD	EQU #0E66A *
=POPTIME%	EQU #0D948 *
=ErrTime	EQU #0CBC4 *
=DOGRAPHIC	EQU #4CE6F *
=InputLEnter	EQU #43179 *
=DATE+DAYS	EQU #0CC5B *
=DOSTOSYSF	EQU #1C6E3 *
=DOSTOALLF	EQU #1C6A2 *
=RCLUSERF	EQU #1C64E *
=Ck&Freeze	EQU #142FB *
=DispDir?Tim1	EQU #398F4 *
=DispDir?Tim2	EQU #39958 *
=HARDHEIGHT	EQU #12B6C *
=PathStatus	EQU #39971 *
=IRAM@	EQU #0011F =
=#PUSHA-	EQU #03DC7 *
=JSTOP@	EQU #07264 *
=JINDEXSTO	EQU #072AD *
=JSTOPSTO	EQU #072C2 *
=%18	EQU #1CDF2 *
=%19	EQU #1CE07 *
=EXTN	EQU #05481 *
=UMRND	EQU #0FD68 *
=HXS==HXS	EQU #544D9 *
=NoEdit?case	EQU #40D93 *
=WindowXY	EQU #136AA *
=LINECHANGE	EQU #4E37E *

=DOPX>C	EQU #4F0AC *
=DOC>PX	EQU #4F179 *
=CHECKHEIGHT	EQU #511E3 *
=norecPWLseq	EQU #01FBD *
=norecCSseq	EQU #01FDA *
=Coldstart	EQU #01FD3 *
=SetDA2bTemp	EQU #39059 *
=SetDA3Temp	EQU #39072 *
=REPEATERCH	EQU #51735 *
=ClrDA2aOK	EQU #390E5 *
=ClrDA2bOK	EQU #390FE *
=GETEXITMSG	EQU #04E07 *
=#EXITERR	EQU #65094 *
=Y<=X	EQU #2BD32 *
=SysSTO	EQU #2E9E6 *
=SuspendOK?	EQU #1446F *
=NOHALTERR	EQU #10FC6 *
=IDUP	EQU #0716B *
=SQRF	EQU #2BA0F *
=PACKSB	EQU #29E21 *
=disprange	EQU #133AB *
=BITMAP	EQU #008E6 =
=Debounce	EQU #009A5 =
=TIMERCTRL.1	EQU #0012E =
=TIMERCTRL.2	EQU #0012F =

************************************************************
* Start of new ROM addresses used to access some formerly
* supported RAM entries in a version independent manner.
************************************************************
=addrADISP	EQU #1265A *
=addrATTNFLG	EQU #4226A *
=addrClkOnNib	EQU #0E7D3 *
* !! addrKEYSTATE is really an address, but an ABS in the
* !! file containing it forces different treatment
=addrKEYSTATE	EQU #00D48 =
=addrLINECNTg	EQU #136AC *
=addrORghost	EQU #0188D *
=addrTEMPENV	EQU #04E66 *
=addrTEMPTOP	EQU #179E8 *
=addrVDISP	EQU #1263A *
=addrVDISP2	EQU #1264A *

=adrDISABLE_K	EQU #047CF *
=adrGraphPrtH	EQU #32CB6 *
=adrKEYBUFFER	EQU #047DD *
=adrTIMEOUTCL	EQU #42284 *
=adr_uart_han	EQU #312DA *

************************************************************
* End of new version independent RAM access entries
************************************************************

************************************************************
* Start of G series entries - these DO NOT WORK ON THE S/SX!
************************************************************
*=X@	EQU #0931B *
=DOACPTR	EQU #02BAA *
=DoInputForm EQU #199EB *
='DROPFALSE	EQU #3A9B8 *

************************************************************
* End of 1st half entries
* ----------------------------------------------------------
* Rompointer entries go below here
************************************************************

=~BRDispItems	EQU #450E0 =
=~BRRclC1	EQU #180E0 =
=~BRRclCurRow	EQU #170E0 =
=~BRStoC1	EQU #030E0 =
=~BRViewItem	EQU #520E0 =
=~BRbrowse	EQU #100E0 =
=~BRdone	EQU #130E0 =
=~BRinverse	EQU #490E0 =
=~BRoutput	EQU #120E0 =
=~BRGetItem	EQU #530E0 =
=~MESRclEqn	EQU #120E4 =
=~UTBADATERR	EQU #060E7 =
=~PCunpack	EQU #630E3 =
=~UTTYPEEXT0?	EQU #580E7 =
=~UTVUNS1Arg	EQU #110E7 =
=~DoMsgBox	EQU #000B1 =
=~grobAlertIcon EQU #850B0 =
=~MsgBoxMenu	EQU #020B1 =
=~DoMKeyOK	EQU #090B1 =
=~Choose	EQU #000B3 =
=~DoCKeyCance	EQU #2D0B3 =
=~DoCKeyOK	EQU #2E0B3 =
=~ChooseMenu0	EQU #050B3 =
=~ChooseMenu1	EQU #060B3 =
=~ChooseMenu2	EQU #070B3 =
=~DoKeyCancel	EQU #590B0 =
=~DoKeyOK	EQU #5A0B0 =
=~grobCheckKe	EQU #860B0 =
=~DoCKeyCheck	EQU #2A0B3 =
=~DoCKeyChAll	EQU #2B0B3 =
=~DoCKeyUnChA	EQU #2C0B3 =
=~LEDispItem	EQU #360B3 =
=~LEDispList	EQU #350B3 =
=~LEDispPromp	EQU #300B3 =
=~IFMenuRow1	EQU #050B0 =
=~IFMenuRow2	EQU #060B0 =
=~GetFieldVal	EQU #C80B0 =
=~gFldVal	EQU #C50B0 =

************************************************************
* End of rompointer entries
************************************************************

*****************************************************************
*		User Accessible Entries				*
*****************************************************************

*****************************************************************
*		Library 002					*
*****************************************************************

=xASR		EQU #1957B * U
=xRL		EQU #1959B * U
=xRLB		EQU #195BB * U
=xRR		EQU #195DB * U
=xRRB		EQU #195FB * U
=xSL		EQU #1961B * U
=xSLB		EQU #1963B * U
=xSR		EQU #1965B * U
=xSRB		EQU #1967B * U
=xR>B		EQU #1969B * U
=xB>R		EQU #196BB * U
=xCONVERT	EQU #196DB * U
=xUVAL		EQU #1971B * U
=x>UNIT		EQU #1974F * U
=xUBASE		EQU #19771 * U
=xUFACT		EQU #197A5 * U
=xTIME		EQU #197F7 * U
=xDATE		EQU #19812 * U
=xTICKS		EQU #1982D * U
=xWSLOG		EQU #19848 * U
=xACKALL	EQU #19863 * U
=xACK		EQU #1987E * U
=xSETDATE	EQU #1989E * U
=xSETTIME	EQU #198BE * U
=xCLKADJ	EQU #198DE * U
=xSTOALARM	EQU #198FE * U
=xRCLALARM	EQU #19928 * U
=xFINDALARM	EQU #19948 * U
=xDELALARM	EQU #19972 * U
=xTSTR		EQU #19992 * U
=xDDAYS		EQU #199B2 * U
=xDATE+		EQU #199D2 * U
=xCRDIR		EQU #1A105 * U
=xPATH		EQU #1A125 * U
=xHOME		EQU #1A140 * U
=xUPDIR		EQU #1A15B * U
=xVARS		EQU #1A194 * U
=xTVARS		EQU #1A1AF * U
=xBYTES		EQU #1A1D9 * U
=xNEWOB		EQU #1A2BC * U
=xKILL		EQU #1A303 * U
=xOFF		EQU #1A31E * U
=xDOERR		EQU #1A339 * U
=xERR0		EQU #1A36D * U
=xERRN		EQU #1A388 * U
=xERRM		EQU #1A3A3 * U
=xEVAL		EQU #1A3BE * U
=xIFTE		EQU #1A3FE *
=xIFT		EQU #1A4CD * U
=xSYSEVAL	EQU #1A52E * U
=xDISP		EQU #1A584 * U
=xFREEZE	EQU #1A5A4 * U
=xBEEP		EQU #1A5C4 * U
=x>NUM		EQU #1A5E4 * U
=xLAST		EQU #1A604 * U
=xWAIT		EQU #1A71F * U
=xCLLCD		EQU #1A858 * U
=xKEY		EQU #1A873 * U
=xCONT		EQU #1A8BB * U
=x=		EQU #1A8D8 * U
=xNEG		EQU #1A995 * U
=xABS		EQU #1AA1F * U
=xCONJ		EQU #1AA6E * U
=xPI		EQU #1AABD * U
=xMAXR		EQU #1AADF * U
=xMINR		EQU #1AB01 * U
=xCONSTANTe	EQU #1AB23 * U
=xi		EQU #1AB45 * U
=x+		EQU #1AB67 *
=xNEGNEG	EQU #1ACDD * U
=x-		EQU #1AD09 *
=x*		EQU #1ADEE *
=x/		EQU #1AF05 *
=x^		EQU #1B02D *
=rpnXROOT	EQU #1B185 *
=xXROOT		EQU #1B1CA * U
=xINV		EQU #1B278 * U
=xARG		EQU #1B2DB * U
=xSIGN		EQU #1B32A * U
=xSQRT		EQU #1B374 * U
=xSQ		EQU #1B426 * U
=xSIN		EQU #1B4AC * U
=xCOS		EQU #1B505 * U
=xTAN		EQU #1B55E * U
=xSINH		EQU #1B5B7 * U
=xCOSH		EQU #1B606 * U
=xTANH		EQU #1B655 * U
=xASIN		EQU #1B6A4 * U
=xACOS		EQU #1B72F * U
=xATAN		EQU #1B79C * U
=xASINH		EQU #1B7EB * U
=xACOSH		EQU #1B830 * U
=xATANH		EQU #1B8A2 * U
=xEXP		EQU #1B905 * U
=xLN		EQU #1B94F * U
=xLOG		EQU #1B9C6 * U
=xALOG		EQU #1BA3D * U
=xLNP1		EQU #1BA8C * U
=xEXPM		EQU #1BAC2 * U
=xFACT		EQU #1BB02 * U
=preFACT	EQU #1BB41 * U
=xIP		EQU #1BB6D * U
=xFP		EQU #1BBA3 * U
=xFLOOR		EQU #1BBD9 * U
=xCEIL		EQU #1BC0F * U
=xXPON		EQU #1BC45 * U
=xMAX		EQU #1BC71 * U
=xMIN		EQU #1BCE3 * U
=xRND		EQU #1BD55 * U
=xTRNC		EQU #1BDD1 * U
=xMOD		EQU #1BE4D * U
=xMANT		EQU #1BE9C * U
=xD>R		EQU #1BEC8 * U
=xR>D		EQU #1BEF4 * U
=x>HMS		EQU #1BF1E * U
=xHMS>		EQU #1BF3E * U
=xHMS+		EQU #1BF5E * U
=xHMS-		EQU #1BF7E * U
=xRNRM		EQU #1BF9E * U
=xCNRM		EQU #1BFBE * U
=xDET		EQU #1BFDE * U
=xDOT		EQU #1BFFE * U
=xCROSS		EQU #1C01E * U
=xRSD		EQU #1C03E * U
=x%		EQU #1C060 * U
=x%T		EQU #1C0D7 * U
=x%CH		EQU #1C149 * U
=xRAND		EQU #1C1B9 * U
=xRDZ		EQU #1C1D4 * U
=xCOMB		EQU #1C1F6 * U
=xPERM		EQU #1C236 * U
=xSF		EQU #1C274 * U
=xCF		EQU #1C2D5 * U
=xFS?		EQU #1C313 * U
=xFC?		EQU #1C360 * U
=xDEG		EQU #1C399 * U
=xRAD		EQU #1C3B4 * U
=xGRAD		EQU #1C3CF * U
=xFIX		EQU #1C3EA * U
=xSCI		EQU #1C41E * U
=xENG		EQU #1C452 * U
=xSTD		EQU #1C486 * U
=xFS?C		EQU #1C4A1 * U
=xFC?C		EQU #1C520 * U
=xBIN		EQU #1C559 * U
=xDEC		EQU #1C574 * U
=xHEX		EQU #1C58F * U
=xOCT		EQU #1C5AA * U
=xSTWS		EQU #1C5C5 * U
=xRCWS		EQU #1C5FE * U
=xRCLF		EQU #1C619 * U
=xSTOF		EQU #1C67F *
=x>LIST		EQU #1C783 * U
=xR>C		EQU #1C79E * U
=xRE		EQU #1C7CA * U
=xIM		EQU #1C819 * U
=xSUB		EQU #1C85C * U
=xREPL		EQU #1C8EA * U
=xLIST>		EQU #1C95A * U
=xC>R		EQU #1C98E * U
=xSIZE		EQU #1C9B8 * 
=xPOS		EQU #1CAB4 * U
=x>STR		EQU #1CB0B * U
=xSTR>		EQU #1CB26 * U
=xNUM		EQU #1CB46 * U
=xCHR		EQU #1CB66 * U
=xTYPE		EQU #1CB86 * U
=xVTYPE		EQU #1CE28 * U
=xEQ>		EQU #1CEE3 * U
=xOBJ>		EQU #1CF7B * 
=x>ARRY		EQU #1D009 * U
=xARRY>		EQU #1D092 * U
=xRDM		EQU #1D0DF *
=xCON		EQU #1D186 *
=xIDN		EQU #1D2DC * U
=xTRN		EQU #1D392 * U
=xPUT		EQU #1D407 * U
=xPUTI		EQU #1D5DF *
=xGET		EQU #1D7C6 * U
=xGETI		EQU #1D8C7 * U
=xV>		EQU #1DD06 * U
=x>V2		EQU #1DE66 * U
=x>V3		EQU #1DEC2 * U
=xINDEP		EQU #1E04A * U
=xPMIN		EQU #1E07E * U
=xPMAX		EQU #1E09E * U
=xAXES		EQU #1E0BE * U
=xCENTR		EQU #1E0E8 * U
=xRES		EQU #1E126 * U
=x*H		EQU #1E150 * U
=x*W		EQU #1E170 * U
=xDRAW	EQU #1E190 * U
=xAUTO	EQU #1E1AB * U
=xDRAX	EQU #1E1C6 * U
=xSCALE	EQU #1E1E1 * U
=xPDIM	EQU #1E201 * U
=xDEPND	EQU #1E22B * U
=xERASE	EQU #1E25F * U
=xPX>C	EQU #1E27A * U
=xC>PX	EQU #1E29A * U
=xGRAPH	EQU #1E2BA * U
=xLABEL	EQU #1E2D5 * U
=xPVIEW	EQU #1E2F0 * U
=xPIXON	EQU #1E31A * U
=xPIXOFF	EQU #1E344 * U
=xPIX?	EQU #1E36E * U
=xLINE	EQU #1E398 * U
=xTLINE	EQU #1E3C2 * U
=xBOX		EQU #1E3EC * U
=xBLANK	EQU #1E416 * U
=xPICT	EQU #1E436 * U
=xGOR		EQU #1E456 * U
=xGXOR	EQU #1E4E4 * U
=xLCD>	EQU #1E572 * U
=x>LCD	EQU #1E58D * U
=x>GROB	EQU #1E5AD * U
=xARC		EQU #1E5D2 * U
=xTEXT	EQU #1E606 * U
=xXRNG	EQU #1E621 * U
=xYRNG	EQU #1E641 * U
=xFUNCTION	EQU #1E661 *
=xCONIC	EQU #1E681 * U
=xPOLAR	EQU #1E6A1 *
=xPARAMETRIC	EQU #1E6C1 *
=xTRUTH	EQU #1E6E1 * U
=xSCATTER	EQU #1E701 * U
=xHISTOGRAM	EQU #1E721 * U
=xBAR		EQU #1E741 * U
=xSAME	EQU #1E761 * U
=xAND		EQU #1E783 * U
=xOR		EQU #1E809 * U
=xNOT		EQU #1E88F * U
=xXOR		EQU #1E8F6 * U
=x==		EQU #1E972 * U
=x#?		EQU #1EA9D * U
=x<?		EQU #1EBBE *
=x>?		EQU #1EC5D *
=x<=?		EQU #1ECFC * U
=x>=?		EQU #1ED9B * U
=xOLDPRT	EQU #1EE38 * U
=xPR1		EQU #1EE53 * U
=xPRSTC	EQU #1EE6E * U
=xPRST	EQU #1EE89 * U
=xCR		EQU #1EEA4 * U
=xPRVAR	EQU #1EEBF * U
=xDELAY	EQU #1EF43 * U
=xPRLCD	EQU #1EF63 * U
=rpnDER	EQU #1EF7E * U
=xDER		EQU #1EFD2 * U
=xRCEQ	EQU #1F133 * U
=xSTEQ	EQU #1F14E * U
=xROOT	EQU #1F16E * U
=rpnINTG	EQU #1F1D4 * U
=xINTEGRAL	EQU #1F223 * U
=xSUM		EQU #1F2C9 * U
=rpnWHERE	EQU #1F354 * U
=xWHERE	EQU #1F3F3 * U
=xQUOTE	EQU #1F500 * U
=rpnAPPLY	EQU #1F55D * U
=xAPPLY	EQU #1F5C5 * U
=xFCNAPPLY	EQU #1F640 * 
=COMPLEXDUMMY	EQU #1F996 * U
=POLARDUMMY	EQU #1F9AE * U
=x->Q		EQU #1F9C4 * U
=x->QPI	EQU #1F9E9 * U
=xMATCHUP	EQU #1FA59 * U
=xMATCHDN	EQU #1FA8D * U
=xFORMUNIT	EQU #1FAEB * U
=xPREDIV	EQU #1FB5D * U
=xDUP		EQU #1FB87 * U
=xDUP2	EQU #1FBA2 * U
=xSWAP	EQU #1FBBD * U
=xDROP	EQU #1FBD8 * U
=xDROP2	EQU #1FBF3 * U
=xROT		EQU #1FC0E * U
=xOVER	EQU #1FC29 * U
=xDEPTH	EQU #1FC44 * U
=xDROPN	EQU #1FC64 * U
=xDUPN	EQU #1FC7F * U
=xPICK	EQU #1FC9A * U
=xROLL	EQU #1FCB5 * U
=xROLLD	EQU #1FCD0 * U
=xCLEAR	EQU #1FCEB * U
=xSTOSIGMA	EQU #1FD0B * U
=xCLSIGMA	EQU #1FD2B * U
=xRCLSIGMA	EQU #1FD46 * U
=xSIGMA+	EQU #1FD61 * U
=xSIGMA-	EQU #1FD8B * U
=xNSIGMA	EQU #1FDA6 * U
=xCORR	EQU #1FDC1 * U
=xCOV		EQU #1FDDC * U
=xSUMX	EQU #1FDF7 * U
=xSUMY	EQU #1FE12 * U
=xSUMX2	EQU #1FE2D * U
=xSUMY2	EQU #1FE48 * U
=xSUMXY	EQU #1FE63 * U
=xMAXSIGMA	EQU #1FE7E * U
=xMEAN	EQU #1FE99 * U
=xMINSIGMA	EQU #1FEB4 * U
=xSDEV	EQU #1FECF * U
=xTOT		EQU #1FEEA * U
=xVAR		EQU #1FF05 * U
=xLR		EQU #1FF20 * U
=xPREDV	EQU #1FF7A * U
=xPREDY	EQU #1FF9A * U
=xPREDX	EQU #1FFBA * U
=xXCOL	EQU #1FFDA * U
=xYCOL	EQU #1FFFA * U
=xUTPC	EQU #2001A * U
=xUTPN	EQU #2003A * U
=xUTPF	EQU #2005A * U
=xUTPT	EQU #2007A * U
=xCOLSIGMA	EQU #2009A * U
=xSCLSIGMA	EQU #200C4 * U
=xSIGMALINE	EQU #200F3 * U
=xBINS	EQU #2010E * U
=xBARPLOT	EQU #20133 * U
=xHISTPLOT	EQU #20167 * U
=xSCATRPLOT	EQU #2018C * U
=xLINFIT	EQU #201B1 * U
=xLOGFIT	EQU #201D6 * U
=xEXPFIT	EQU #201FB * U
=xPWRFIT	EQU #20220 * U
=xBESTFIT	EQU #2025E * U
=xSINV	EQU #202CE * U
=xSNEG	EQU #2034D * U
=xSCONJ	EQU #203CC * U
=xSTO+	EQU #2044B * U
=xSTO-	EQU #20538 * U
=xSTO/	EQU #2060C * U
=xSTO*	EQU #20753 * U
=xINCR	EQU #208F4 * U
=xDECR	EQU #209AA * U
=xCOLCT	EQU #20A15 * U
=xEXPAN	EQU #20A49 * U
=xRULES	EQU #20A7D * U
=xISOL	EQU #20A93 * U
=xQUAD	EQU #20AB3 * U
=xSHOW	EQU #20AD3 * U
=xTAYLR	EQU #20B20 * U
=xRCL		EQU #20B40 * U
=xSTO		EQU #20CCD * U
=xDEFINE	EQU #20D65 * U
=xPURGE	EQU #20EFE * U
=xMEM		EQU #20FAA *
=xORDER	EQU #20FD9 * U
=xCLUSR	EQU #210FC * U
=xTMENU	EQU #2115D * U
=xMENU	EQU #21196 * U
=xRCLMENU	EQU #211E1 * U
=xPVARS	EQU #211FC * U
=xPGDIR	EQU #2123A * U
=xARCHIVE	EQU #2125A * U
=xRESTORE	EQU #2133C * U
=xMERGE	EQU #2137F * U
=xFREE	EQU #213D1 *
=xLIBS	EQU #2142D * U
=xATTACH	EQU #21448 * U
=xDETACH	EQU #2147C * U
=xXMIT	EQU #21E75 * U
=xSRECV	EQU #21E95 * U
=xOPENIO	EQU #21EB5 * U
=xCLOSEIO	EQU #21ED5 * U
=xSEND	EQU #21EF0 * U
=xKGET	EQU #21F24 * U
=xRECN	EQU #21F62 * U
=xRECV	EQU #21F96 * U
=xFINISH	EQU #21FB6 * U
=xSERVER	EQU #21FD1 * U
=xCKSM	EQU #21FEC * U
=xBAUD	EQU #2200C * U
=xPARITY	EQU #2202C * U
=xTRANSIO	EQU #2204C * U
=xKERRM	EQU #2206C * U
=xBUFLEN	EQU #22087 * U
=xSTIME	EQU #220A2 * U
=xSBRK	EQU #220C2 * U
=xPKT		EQU #220DD * U
=xINPUT	EQU #224CA * U
=xASN		EQU #224F4 * U
=xSTOKEYS	EQU #22514 * U
=xDELKEYS	EQU #22548 * U
=xRCLKEYS	EQU #22586 * U
=x->TAG	EQU #225BE * U
=xDTAG	EQU #22633 * U

*****************************************************************
*		Library 700					*
*****************************************************************

=xIF		EQU #22EC3 * U
=xTHEN	EQU #22EFA * U
=xELSE	EQU #22FB5 * U
=xIFEND	EQU #22FD5 * U
=xALG->	EQU #22FEB * U
=xWHILE	EQU #23033 * U
=xREPEAT	EQU #2305D * U
=xDO		EQU #230C3 * U
=xUNTIL	EQU #230ED * U
=xSTART	EQU #23103 * U
=xSTARTVAR	EQU #231A0 * U
=xNEXT	EQU #2324C * U
=xSTEP	EQU #23380 * U
=xIFERR	EQU #233DF * U
=xHALT	EQU #23472 * U
=xSILENT'	EQU #2349C * U
=xRPN->	EQU #234C1 * U
=x>>ABND	EQU #235FE * U
=x<<		EQU #2361E *
=x>>		EQU #23639 * U
=x'		EQU #23654 * U
=xENDTIC	EQU #23679 * U
=xWHILEEND	EQU #23694 * U
=xENDDO	EQU #236B9 * U
=xERRTHEN	EQU #2371F * U
=xCASE	EQU #2378D * U
=xTHENCASE	EQU #237A8 * U
=xDIR		EQU #23813 * U
=xPROMPT	EQU #23824 * U

*******************************************************************
*  Added for HP SDK Debug2 support (see rament.a). WGG 7/2002
*******************************************************************
=TEMPOB       EQU #806E9
*=USEROB       EQU #80711
=RSKTOP       EQU #806F3
=TEMPENV	  EQU #80702
*=CONTEXT      EQU #8071B
*
=~xNOVAL EQU #05B0AB =
=NOVAL EQU #6509E *



